SuperStrict


'Types
Type TTile			'Tile-Type
	
	Field TilesetValue:Byte
	Field CanBuildTower:Byte
	
	'Init methode
	Method Init( value:Byte )
		
		Self.TilesetValue = value
		Self.CanBuildTower = CanBuildTowers[ value ]
		
	End Method
	
	'Update methode
	Method Update()
	
	End Method
	
	'Render-methode
	Method Render( X:Byte, Y:Byte )
		
		DrawImage Tileset, XConvertItoS( X, Y ), YConvertItoS( Y ), Self.TilesetValue
		
	End Method
	
End Type


Type TGameMap			'Map-Type
	
	Field Tiles:TTile[ 13, 50 ]	'Tiles
	Field Towers:TList			'Towers
	Field Ways:TList			'Wege fr die Einheiten
	Field Units:TList			'Einheiten
	Field Effects:TList			'Effekte
	Field Shots:TList			'Schuesse
	Field Waves:TList			'Angriffswellen
	Field Blitzs:TList			'Blitze
	Field NextWaveTime:Int		'Zeit bis zur nchsten Welle
	Field CollPixmap:TPixmap		'Kollisionspixmap
	
	Method Init( Name:String )
		
		'Datei ffnen
		Local Stream:TStream = ReadFile( "level\" + Name + "\map" )
		
		'Map einlesen
		For Local y:Byte = 0 To 49
			
			For Local x:Byte = 0 To 12
				
				Self.Tiles[ x, y ] = New TTile				'Tile erstellen
				Self.Tiles[ x, y ].Init( ReadByte( Stream ) )	'Tile initialisieren
				
			Next
			
		Next
		
		'Wege erstellen / lesen
		Self.Ways = CreateList()
		
		Local W:TWay
		
		For Local I:Byte = 0 To 9
			
			Local C:Byte = ReadByte( Stream )
			
			If C > 0 Then
			
				W = New TWay
				W.Init( I )
				Self.Ways.AddLast W
				
				For Local J:Byte = 1 To C
					
					Local P:TWaypoint = New TWaypoint
					Local X:Byte = ReadByte( Stream )
					Local Y:Byte = ReadByte( Stream )
					Local D:Byte = ReadByte( Stream )
					P.Init( X, Y, D )
					W.AddPoint( P )
					
				Next
				
			End If
			
		Next
		
		'Datei schlieen
		CloseFile Stream
		
		'Wellen laden
		Self.Waves = CreateList()
		
		Stream = ReadFile( "level\" + Name + "\waves.txt" )
		
		Local CountWaves:Byte = Byte( ReadLine( Stream ) )
		
		For Local CW:Byte = 1 To CountWaves
		
			Local CountUnits:Byte = Byte( ReadLine( Stream ) )
			
			Local W:TWave = New TWave
			W.Init( Self )
			Self.Waves.AddLast( W )
			
			For Local CU:Byte = 1 To CountUnits
				
				Local Amount:Int = Int( ReadLine( Stream ) )
				Local Typ:Byte = Byte( ReadLine( Stream ) )
				
				For Local I:Int = 1 To Amount
					
					Local N:Int = Typ
					W.Units.AddLast( String( N ) )
					
				Next
				
			Next
			
		Next
		
		'Und bis zum Start der ersten Welle dauerts noch kurz
		Self.NextWaveTime = 300
		
		CloseFile Stream
		
		'Collision Pixmap erstellen
		Self.CollPixmap = CreatePixmap( 1024, 768, PF_BGR888 )
		ClearPixels( Self.CollPixmap, $FF000000 )
		
		'Kollisionspixmap rendern
		Self.RenderPixmap()
		
		'Towerliste erstellen
		Self.Towers = CreateList()
		
		'Gegnerliste erstellen
		Self.Units = CreateList()
		
		'Effektliste erstellen
		Self.Effects = CreateList()
		
		'Schussliste erstellen
		Self.Shots = CreateList()
		
		'Blitzliste erstellen
		Self.Blitzs = CreateList()
		
	End Method
	
	Method Update()
		
		'Wellen updaten
		For Local W:TWave = EachIn Self.Waves
			
			'Wenn die Welle berhaupt aktiv ist
			If W.Active = True Then
				
				'Falls sie gelscht werden soll, lschen
				If W.Del = True Then
					ListRemove( Self.Waves, W )
					W = Null
				Else
					'Ansonsten aktualisieren
					W.Update()
				End If
				
			End If
			
		Next
		
		'Falls keine Einheiten mehr rumlaufen, bald nchste Welle starten
		If Self.Units.IsEmpty() = True And Self.NextWaveTime = -1 Then Self.NextWaveTime = 300
		
		'Zeit bis zur nchsten Welle runterzhlen wenn die aktuelle fertig ist
		If Self.NextWaveTime > 0 Then Self.NextWaveTime :- 1
		
		'Welle aktivieren wenn die Zeit abgelaufen ist
		If Self.NextWaveTime = 0 Then
			'Falls noch Wellen vorhanden sind
			If Self.Waves.IsEmpty() = False Then
				TWave( Self.Waves.First() ).Enable()
				Self.NextWaveTime = -1
			'Ansonsten
			Else
				Victory()
			End If
		End If
		
		'Trme updaten
		For Local T:TTower = EachIn Self.Towers
			
			T.Update()
			
		Next
		
		'Einheiten updaten
		For Local U:TUnit = EachIn Self.Units
			
			If U.Del = True Then
				ListRemove( Self.Units, U )
				U = Null
			End If
			
			If U <> Null Then U.Update()
			
		Next
		
		'Effekte updaten
		For Local E:TEffect = EachIn Self.Effects
			
			If E.Del = True Then
				ListRemove( Self.Effects, E )
				E = Null
			End If
			
			If E <> Null Then E.Update()
			
		Next
		
		'Schuesse updaten
		For Local S:TShot = EachIn Self.Shots
			
			If S.Del = True Then
				ListRemove( Self.Shots, S )
				S = Null
			End If
			
			If S <> Null Then S.Update()
			
		Next
		
		'Blitze updaten
		For Local B:TBlitz = EachIn Self.Blitzs
			
			If B.Del = True Then
				ListRemove( Self.Blitzs, B )
				B = Null
			End If
			
			If B <> Null Then B.Update() ; B.Del = True
			
		Next
		
	End Method
	
	Method Render()
		
		'Map rendern
		For Local y:Byte = 0 To 49
			
			For Local x:Byte = 0 To 12
				
				Self.Tiles[ X, Y ].Render( X, Y )
				
			Next
			
		Next
		
		'Einheiten rendern
		For Local U:TUnit = EachIn Self.Units
			
			U.Render()
			
		Next
		
		'Trme rendern
		For Local T:TTower = EachIn Self.Towers
			
			T.Render()
			
		Next
		
		'Effekte rendern
		For Local E:TEffect = EachIn Self.Effects
			
			E.Render()
			
		Next
		
		'Schuesse rendern
		For Local S:TShot = EachIn Self.Shots
			
			S.Render()
			
		Next
		
		'Blitze rendern
		For Local B:TBlitz = EachIn Self.Blitzs
			
			B.Render()
			
		Next
		
	End Method
	
	'Methode um Tile an Bildschirmkoordinate herauszufinden
	Method GetTile:TTile( X:Int, Y:Int )
		
		If MX < 800 Then
		
			Local ARGB:Int = ReadPixel( CollPixmap, X, Y )
				
			Local R:Int = ( ARGB Shl 8 ) Shr 24
			Local G:Int = ( ARGB Shl 16 ) Shr 24
			
			Return Self.Tiles[ R, G ]
			
		End If
		
	End Method
	
	'Methode um Tile-Koordinate an Bildschirmkoordinate herauszufinden
	Method GetTileC:Byte( X:Int, Y:Int, Ret:Byte )
		
		Local ARGB:Int = ReadPixel( CollPixmap, X, Y )
		
		Local R:Int = ( ARGB Shl 8 ) Shr 24
		Local G:Int = ( ARGB Shl 16 ) Shr 24
		
		Select Ret
			Case 1
				Return R
			Case 2
				Return G
		End Select
		
	End Method
	
	'Methode um Turm hinzufgen
	Method AddTower( T:TTower )
		
		Self.Towers.AddLast( T ) 
		
	End Method
	
	'Methode um Einheiten hinzufgen
	Method AddUnit( U:TUnit )
		
		Self.Units.AddLast( U )
		
	End Method
	
	'Methode um Effekte hinzufgen
	Method AddEffect( E:TEffect )
		
		Self.Effects.AddLast( E )
		
	End Method
	
	'Methode um Schuss hinzuzufgen
	Method AddShot( S:TShot )
		
		Self.Shots.AddLast( S )
		
	End Method
	
	'Funktion zum Neu-Rendern der Kollisions-Pixmap
	Method RenderPixmap()
		
		Cls
		
		For Local y:Byte = 0 To 49
			For Local x:Byte = 0 To 12
				SetColor x, y, 0
				DrawImage TilesetW, XConvertItoS( x, y ), YConvertItoS( y ), Self.Tiles[ x, y ].TilesetValue
			Next
		Next
		
		Self.CollPixmap = GrabPixmap( 0, 0, 1024, 768 )
		
		SetColor 255, 255, 255
		
	End Method
	
	'Methode um Weg anhand der Nummer herauszufinden
	Method GetWay:TWay( NR:Byte )
		
		For Local W:TWay = EachIn Self.Ways
			
			If W.NR = NR Then Return W
			
		Next
		
		Return Null
		
	End Method
	
End Type


Type TTower		'Turmtype
	
	'Position auf der Map
	Field X:Byte
	Field Y:Byte
	
	'Position auf dem Bildschirm
	Field SX:Int
	Field SY:Int
	
	'Typ des Turms
	Field Typ:Byte
	
	'zu zeichnendes Frame
	Field Frame:Byte
	
	'letztes gezeichnetes Frame
	Field LastFrame:Byte
	
	'Die bentigte Zeit bis zum nchsten Schuss ; aktuell / immer nach Schuss
	Field Cooldown:Int
	Field Firerate:Int
	
	'Die Reichweite in Pixeln
	Field Range:Int
	
	'Die Extra Eigenschaft wie z.B. Schaden oder Schockzeit
	Field ExtraValue:Int
	
	'Ob er angeklickt ist
	Field Clicked:Byte
	
	'Init Methode
	Method Init( X:Byte, Y:Byte, Typ:Byte )
		
		Self.X = X
		Self.Y = Y
		Self.SX = XConvertItoS( X, Y )
		Self.SY = YConvertItoS( Y ) - 17
		Self.Typ = Typ
		Self.Range = TowerRanges[ Self.Typ ]
		Self.Firerate = TowerCooldowns[ Self.Typ ]
		Self.ExtraValue = TowerExtraValues[ Self.Typ ]
		
	End Method
	
	'Update Methode
	Method Update()
		
		'Wenns drehbar ist
		If TowerAnimStyles[ Self.Typ ] = 1 Then
			
			'Drehen
			AnimGuntower( Self )
			
		End If
		
		'Wenn er noch nicht schieen kann
		If Self.Cooldown > 0 Then
			
			'Weiter "abkhlen"
			Self.Cooldown :- 1
		
		'Wenn er schieen kann
		ElseIf Self.Cooldown = 0
			
			'Schieen
			Select Self.Typ
				
				Case T_GUNTOWER
					
					FireGuntower( Self )
					
				Case T_SHOCKTOWER
					
					FireShocktower( Self )
					
				Case T_TESLATOWER
					
					FireTeslatower( Self )
					
			End Select
			
		End If
		
	End Method
	
	'Render Methode
	Method Render()
		
		DrawImage ITowers[ Self.Typ ], Self.SX, Self.SY, Self.Frame
		
	End Method
	
	'Methode zum Prfen auf angeklickt sein
	Method CheckIfClicked()
		
		'Auf Anklicken prfen
		If CirclesOverlap( Self.SX + 32, Self.SY + 42, 20, MX, MY, 2 ) = True Then
			
			SelectionMode = SM_TOWER
			SelectedTower = Self
			
		End If
		
	End Method
	
End Type


Type TBlitz		'Blitz Type fr Tesla Tower
	
	Field LineCoords:Int[ 10, 4, 3 ]
	Field X1:Int
	Field Y1:Int
	Field X2:Int
	Field Y2:Int
	Field Del:Byte
	
	Method Init( X1:Int, Y1:Int, X2:Int, Y2:Int )
		
		Self.X1 = X1
		Self.Y1 = Y1
		Self.X2 = X2
		Self.Y2 = Y2
		
	End Method
	
	Method Update()
		
		Local angle:Float = GetAngle( Self.X1, Self.Y1, Self.X2, Self.Y2 )
		Local totaldistance:Int = Sqr( ( Self.X1 - Self.X2 )^2 + ( Self.Y1 - Self.Y2 )^2 )
		Local linedistance:Int = totaldistance / 10
		For Local i:Byte = 0 To 2
			For Local j:Byte = 0 To 9
				Local x1:Int
				Local y1:Int
				Local x2:Int
				Local y2:Int
				If j = 0 Then
					x1 = Self.X1 + Cos( angle ) * linedistance * j
					y1 = Self.Y1 - Sin( angle ) * linedistance * j
				Else
					x1 = Self.LineCoords[ j-1, 2, i ]
					y1 = Self.LineCoords[ j-1, 3, i ]
				End If
				If j < 9 Then
					x2 = x1 + Cos( angle + Rand( -20, 20 ) ) * linedistance
					y2 = y1 - Sin( angle + Rand( -20, 20 ) ) * linedistance
				Else
					x2 = Self.X2 + Rand( -10, 10 )
					y2 = Self.Y2 + Rand( -10, 10 )
				End If
				Self.LineCoords[ j, 0, i ] = x1
				Self.LineCoords[ j, 1, i ] = y1
				Self.LineCoords[ j, 2, i ] = x2
				Self.LineCoords[ j, 3, i ] = y2
			Next
		Next
		
	End Method
	
	Method Render()
		
		For Local i:Byte = 0 To 2
			Local c:Byte = Rand( 0, 255 )
			SetColor c, c, 255
			For Local j:Byte = 0 To 9
				Local x1:Int = Self.LineCoords[ j, 0, i ]
				Local y1:Int = Self.LineCoords[ j, 1, i ]
				Local x2:Int = Self.LineCoords[ j, 2, i ]
				Local y2:Int = Self.LineCoords[ j, 3, i ]
				DrawLine x1, y1, x2, y2
			Next
		Next
		
		SetColor 255, 255, 255
		
	End Method
	
End Type


Type TUnit		'Einheitentype
	
	'Koordinaten auf dem Bildschirm
	Field X:Float
	Field Y:Float
	
	'Typ der Einheit
	Field Typ:Byte
	
	'Weg den die Einheit abfhrt
	Field Way:TWay
	
	'Punkt den die Einheit zuletzt abgefahren hat, die Nummer davon und den als nchstes anzufahrenden
	Field LastPoint:TWaypoint
	Field LastPointNr:Byte
	Field NextPoint:TWaypoint
	
	'Map auf der die Einheit ist
	'Field GameMap:TGameMap
	
	'Richtung und Frame und so
	Field Direction:Byte
	Field Frame:Byte
	Field AnimationStyle:Byte
	Field Time:Int
	Field Turntime:Byte
	
	'Geschwindigkeit
	Field Speed:Float
	
	'Die Zeit die die Einheit noch geschockt ist, wenn sie es ist
	Field ShockedTime:Int
	
	'Ob die Einheit gelscht werden soll
	Field Del:Byte
	
	'Die Hitpoints
	Field Hitpoints:Int
	Field MaxHitpoints:Int
	
	'Belohnung
	Field Reward:Int
	
	'Init-Methode
	Method Init( M:TGameMap, Way:TWay, Typ:Byte )
		
		'Map und Weg zuweisen
		'Self.GameMap = M
		Self.Way = Way
		
		'1. Punkt und nchsten Punkt zuweisen
		Self.LastPoint = TWaypoint( Self.Way.Points.First() )
		Self.LastPointNr = 0
		Self.NextPoint = Self.GetNextPoint()
		
		'Screen-Position errechnen
		Self.X = XConvertItoS( Self.LastPoint.X, Self.LastPoint.Y )
		Self.Y = YConvertItoS( Self.LastPoint.Y )
		
		'Typ zuweisen
		Self.Typ = Typ
		Self.AnimationStyle = UnitAnimStyles[ Typ ]
		
		'Richtung und Frame
		Self.Direction = Self.LastPoint.Direction
		Self.Frame = Self.ConvertDirToFrame( Self.Direction )
		
		'Speed
		Self.Speed = UnitSpeeds[ Self.Typ ]
		
		'Hitpoints
		Self.Hitpoints = UnitHP[ Self.Typ ]
		Self.MaxHitpoints = UnitHP[ Self.Typ ]
		
		'Belohnung
		Self.Reward = UnitReward[ Self.Typ ]
			
	End Method
	
	'Methode um nchsten Punkt zu finden
	Method GetNextPoint:TWaypoint()
		
		If Self.LastPointNr + 1 < CountList( Self.Way.Points )
			Return TWaypoint( Self.Way.Points.ValueAtIndex( Self.LastPointNr + 1 ) )
		Else
			Return Null
		End If
		
	End Method
	
	'Update Methode
	Method Update()
		
		If Self.ShockedTime > 0 Then
			
			Self.ShockedTime :- 1
			
		Else
			
			'Kollisionen berprfen ( Pfeile, Stadt, .. )
			Self.CheckCollisions()
			
			If Self.Del = False Then
			
				'Bewegen
				If Self.Turntime = 0 Then
					
					Self.Move()
					
				Else
					
					'Drehungs-Zeit
					If Self.Turntime > 0 Then Self.Turntime :+ 1
					
				End If
				
				'Zeit erhhen
				Self.Time :+ 1
				
				'Nach 5 Mal aufhren
				If Self.Turntime = 5 Then
					
					'Aufhren zu drehen
					Self.Turntime = 0
					
					'Frame berechnen
					Self.Frame = Self.ConvertDirToFrame( Self.Direction )
					
				End If
			
			End If
			
		End If
		
	End Method
	
	'Render Methode
	Method Render()
		
		Select Self.AnimationStyle
			Case 0	'hoch + runter
				DrawImage IUnits[ Self.Typ ], Self.X, Self.Y + Self.Time / 10 Mod 2, Self.Frame
			Case 1	'richtige animation
				DrawImage IUnits[ Self.Typ ], Self.X, Self.Y, Self.Frame + ( ( Self.Time / 10 ) Mod 4 ) * 8
		End Select
		
	End Method
	
	'Methode zum Bewegen
	Method Move()
		
		'Bildschirmkoordinaten verndern
		Self.X :+ ConvertDirToXSpeed( Self.Direction )
		Self.Y :+ ConvertDirToYSpeed( Self.Direction )
		
	End Method
	
	'Methode zum Prfen von Kollisionen
	Method CheckCollisions()
		
		If Self.IsOnNextPoint() Then
			
			'Position Cheater mig anpassen
			Self.X = XConvertItoS( Self.NextPoint.X, Self.NextPoint.Y )
			Self.Y = YConvertItoS( Self.NextPoint.Y )
			
			'Richtung zuweisen
			Self.Direction = Self.NextPoint.Direction
			
			'Turntime auf 1 setzen damit er sich nur dreht
			Self.Turntime = 1
			
			'Frame fr das kurze Drehen bestimmen
			Local LPDF:Byte = Self.ConvertDirToFrame( Self.LastPoint.Direction )
			Local NPDF:Byte = Self.ConvertDirToFrame( Self.NextPoint.Direction )
			If LPDF = NPDF + 2 Then
				Self.Frame :- 1
			Else
				Self.Frame :+ 1
				If LPDF = 0 And NPDF = 6 Then Self.Frame = 7
			End If
			
			'Nchsten Punkt bestimmen
			Self.LastPoint = Self.NextPoint
			Self.LastPointNR :+ 1
			Self.NextPoint = Self.GetNextPoint()
			
			'Falls es der letzte Punkt war, Stadt angreifen
			If Self.NextPoint = Null Then Self.DoDamage()
			
		End If
		
	End Method
	
	'Methode zum Ermitteln ob man auf nchstem Waypoint steht
	Method IsOnNextPoint:Byte()
		
		Local NPX:Int = XConvertItoS( Self.NextPoint.X, Self.NextPoint.Y )
		Local NPY:Int = YConvertItoS( Self.NextPoint.Y )
		Local Distance:Float = Sqr( ( Self.X - NPX )^2 + ( Self.Y - NPY )^2 )
		If Distance < Self.Speed Then
			Return True
		Else
			Return False
		End If
		
	End Method
	
	'Methode zum umrechnen von direction zu frame
	Method ConvertDirToFrame:Byte( Dir:Byte )
		
		Select Dir
			Case 0
				Return 2
			Case 1
				Return 4
			Case 2
				Return 0
			Case 3
				Return 6
		End Select
		
	End Method
	
	'Methode zum umrechnen von direction in x-geschwindigkeit
	Method ConvertDirToXSpeed:Float( Dir:Float )
		
		Return Float( ( Dir Mod 2.0 ) * 2.0 - 1.0 ) * Self.Speed
		
	End Method
	
	'Methode zum umrechnen von direction in y-geschwindigkeit
	Method ConvertDirToYSpeed:Float( Dir:Float )
		
		Return Float( Floor( Int( Dir ) / 2 ) * 2 - 1 ) * ( Self.Speed / 2.0 )
		
	End Method
	
	'Methode die die Einheit Schaden nehmen lsst
	Method GetDamage( dmg:Int )
		
		Self.Hitpoints :- dmg
		If Self.Hitpoints <= 0 Then Self.Die
		
	End Method
	
	'Methode die die Einheit Schaden zufgen lsst
	Method DoDamage()
		
		Self.Del = True
		Life :- 1
		If Life = 0 Then Loss()
		
	End Method
	
	'Lsst Einheit sterben
	Method Die()
		
		GetMoney( +Self.Reward )
		Self.Del = True
		
	End Method
	
End Type


Type TWay			'Wegtype
	
	Field Points:TList				'Punkt-Liste
	Field NR:Byte					'Nummer des Wegs
	
	'Init-Methode
	Method Init( NR:Byte )
		Self.Points = CreateList()
		Self.NR = NR
	End Method
	
	'Punkt Hinzufgen-Methode
	Method AddPoint( P:TWaypoint )
		Self.Points.AddLast P
	End Method
	
End Type


Type TWaypoint		'Wegpunkttyp
	
	'Koordinaten und Richtung
	Field X:Byte
	Field Y:Byte
	Field Direction:Byte
	
	'Init-Methode
	Method Init( X:Byte, Y:Byte, Direction:Byte )
		Self.X = X
		Self.Y = Y
		Self.Direction = Direction
	End Method
	
End Type


Type TEffect		'Grafikeffekt
	
	'Position
	Field X:Float
	Field Y:Float
	
	'Typ
	Field Typ:Byte
	
	'Zeit
	Field Time:Float
	
	'Frame
	Field Frame:Byte
	
	'Skalierung
	Field Scale:Float
	
	'Obs gelscht werden soll
	Field Del:Byte
	
	'Init-Methode
	Method Init( X:Int, Y:Int, Typ:Byte, Scale:Float )
		
		'Werte weitergeben
		Self.X = X
		Self.Y = Y
		Self.Typ = Typ
		Self.Scale = Scale
		
	End Method
	
	'Update-Methode
	Method Update()
		
		Select Self.Typ
			
			Case E_SHOCK
				Self.Time :+ 1.5
				
			Case E_SMOKE
				Self.Time :+ 0.25
				Self.Y :- 0.5
				
			Case E_EXPLOSION
				Self.Time :+ 1
				
		End Select
		
		Self.Frame = ( Self.Time / 2 ) Mod EffectFrameCounts[ Self.Typ ]
		If Frame = EffectFrameCounts[ Self.Typ ] - 1 Then Self.Del = True
		
	End Method
	
	'Render-Methode
	Method Render()
		
		'Skalieren
		SetScale Self.Scale, Self.Scale
		
		'Und zeichnen
		DrawImage IEffects[ Self.Typ ], Self.X, Self.Y, Frame
		
		'Skalierung zurcksetzen
		SetScale 1, 1
		
	End Method
	
End Type


Type TShot			'Schuss Typ
	
	'Position
	Field X:Float
	Field Y:Float
	
	'Winkel
	Field Angle:Float
	
	'Von welchem Turm er kommt
	Field Source:TTower
	
	'Ziel
	Field Target:TUnit
	
	'Ob er gelscht werden soll
	Field Del:Byte
	
	'Init-Methode
	Method Init( X:Int, Y:Int, Source:TTower, Target:TUnit )
		
		Self.X = X
		Self.Y = Y
		Self.Source = Source
		Self.Target = Target
		
	End Method
	
	'Update-Methode
	Method Update()
		
		'berprfen ob Ziel berhaupt noch existiert. Ansonsten lschen
		If Target <> Null Then 
		
			'Winkel neu berechnen / Ziel verfolgen, man siehts nicht unbedingt aber Schuss trifft immer ;>
			Self.Angle:Float = GetAngle( Self.X, Self.Y, Self.Target.X + 32, Self.Target.Y + 32 )
			
			'Solange bewegen bis Maximaldistanz zurckgelegt ist oder auf Ziel trifft
			Local Distance:Byte = 0
			
			Repeat
				
				'Bewegen
				Self.X :+ Cos( Self.Angle )
				Self.Y :- Sin( Self.Angle )
				Distance :+ 1
				
				'Auf Kollision prfen
				If Self.HitTarget() Then
					
					Self.Explode()
					Self.Target.GetDamage( Self.Source.ExtraValue )
					Exit
					
				End If
				
				'Genug geflogen?
				If Distance = 15 Then Exit
				
			Forever
			
		Else
			
			Self.Explode()
			
		End If
		
	End Method
	
	'Render-Methode
	Method Render()
		
		DrawLine Self.X, Self.Y, Self.X + Cos( Self.Angle ), Self.Y - Sin( Self.Angle )
		
	End Method
	
	'Methode zum Feststellen ob Ziel getroffen wurde
	Method HitTarget:Byte()
		
		Local TX:Int = Self.Target.X + 20
		Local TY:Int = Self.Target.Y + 20
		Local TX2:Int = TX + 20
		Local TY2:Int = TY + 20
		If Self.X >= TX And Self.X <= TX2 And Self.Y >= TY And Self.Y <= TY2 Then Return True
		
	End Method
	
	'Methode zum Explodieren
	Method Explode()
		
		'Lschen lassen
		Self.Del = True
		
		'Effekte
		Local E:TEffect = New TEffect
		E.Init( Self.X, Self.Y, E_EXPLOSION, 1 )
		Map.AddEffect( E )
		
	End Method
	
End Type


Type TWave			'Type fr die Angriffswellen von Gegnern
	
	Field CreationCooldown:Int
	Field Map:TGameMap
	Field Units:TList
	Field Del:Byte
	Field Active:Byte
	
	'Init-Methode
	Method Init( M:TGameMap )
		
		'Mgliche Wege
		Self.Map = M
		
		'Einheiten die kommen
		Self.Units = CreateList()
		
	End Method
	
	'Update-Methode
	Method Update()
		If Self.CreationCooldown = 0 Then
			
			Self.SpawnUnits()
			
		End If
		
		Self.CreationCooldown :- 1
		
	End Method
	
	'Units raushauen
	Method SpawnUnits()
		
		For Local W:TWay = EachIn Self.Map.Ways
			
			If Self.Units.IsEmpty() = False
				Local Typ:Int = Int( String( Self.Units.First() ) )
				Self.Units.RemoveFirst()
				
				Local U:TUnit = New TUnit
				U.Init( Self.Map, W, Typ )
				Self.Map.AddUnit( U )
				
				Self.CreationCooldown = ( 300 - U.Speed * 100 ) / 4
			Else
				Self.Del = True
				Exit
			End If
			
		Next
		
	End Method
	
	'Methode zum aktivieren
	Method Enable()
		
		Self.Active = True
		
	End Method
	
End Type


Type TButton			'Button Type fr GUI
	
	Field event()		'Funktion die bei Klick ausgefhrt wird
	
	Field X:Int
	Field Y:Int
	Field Width:Int
	Field Height:Int
	
	Field Img:TImage
	
	Field visible:Byte
	
	Field Hotkey:Byte
	
	'Init-Methode
	Method Init( X:Int, Y:Int, Width:Int, Height:Int, Img:TImage, event(), visible:Byte = True, Hotkey:Byte = 0 )
		
		Self.X = X
		Self.Y = Y
		Self.Width = Width
		Self.Height = Height
		Self.Img = Img
		Self.event = event
		Self.visible = visible
		Self.Hotkey = Hotkey
		
	End Method
	
	'Update-Methode
	Method Update()
		
		If Self.visible = True Then
			
			Local c1:Byte = ( MHL And MX > Self.X And MY > Self.Y And MX < Self.X + Self.Width And MY < Self.Y + Self.Height)
			Local c2:Byte = KeyHit( Self.Hotkey )
			
			If c1 Or c2 Then
				
				Self.event()
				FlushKeys()
				
			End If
			
		End If
		
	End Method
	
	'Render-Methode
	Method Render()
		
		If Self.visible = True Then
			
			DrawImage Self.Img, Self.X, Self.Y
			
		End If
		
	End Method
	
End Type


Type TLabel			'Label-Type fr GUI
	
	Field X:Int
	Field Y:Int
	Field Width:Int
	Field Height:Int
	Field Txt:String
	
	Field visible:Byte
	
	'Init-Methode
	Method Init( X:Int, Y:Int, Width:Int, Height:Int, Txt:String, visible:Byte = 1 )
		
		Self.X = X
		Self.Y = Y
		Self.Width = Width
		Self.Height = Height
		Self.Txt = Txt
		Self.visible = visible
		
	End Method
	
	'Render-Methode
	Method Render()
		
		SetImageFont FStencil18
		
		If Self.visible = True Then
			'SetColor 0,0,0
			'DrawRect Self.X, Self.Y, Self.Width, Self.Height
			'SetColor 255,255,255
			DrawCenteredText Self.Txt, Self.X + Self.Width / 2, Self.Y + Self.Height / 2
		End If
		
		SetImageFont FStencil
		
	End Method
	
End Type


Type TFrame			'Frame-Ding fr GUI
	
	'Listen fr Objekte
	Field Buttons:TList
	Field Labels:TList
	Field InfoTexts:TList
	
	'Initialisieren
	Method Init()
		Self.Buttons = CreateList()
		Self.Labels = CreateList()
		Self.InfoTexts = CreateList()
	End Method
	
	'Button hinzufgen-Methode
	Method AddButton( B:TButton )
		Self.Buttons.AddLast B
	End Method
	
	'Label hinzufgen-Methode
	Method AddLabel( L:TLabel )
		Self.Labels.AddLast L
	End Method
	
	'Infotext hinzufgen-Methode
	Method AddInfotext( I:TInfoText )
		Self.InfoTexts.AddLast I
	End Method
	
	'Updaten
	Method Update()
		For Local B:TButton = EachIn Self.Buttons
			B.Update()
		Next
		
		For Local I:TInfoText = EachIn Self.InfoTexts
			If I.Del = True Then
				ListRemove( Self.InfoTexts, I )
				I = Null
			End If
			If I <> Null Then I.Update()
		Next
	End Method
	
	'Rendern
	Method Render()
		For Local B:TButton = EachIn Self.Buttons
			B.Render()
		Next
		
		For Local L:TLabel = EachIn Self.Labels
			L.Render()
		Next
		
		For Local I:TInfoText = EachIn Self.InfoTexts
			I.Render()
		Next
	End Method
	
	'Verstecken
	Method Hide()
		For Local B:TButton = EachIn Self.Buttons
			B.visible = False
		Next
		
		For Local L:TLabel = EachIn Self.Labels
			L.visible = False
		Next
	End Method
	
	'Zeigen
	Method Show()
		For Local B:TButton = EachIn Self.Buttons
			B.visible = True
		Next
		
		For Local L:TLabel = EachIn Self.Labels
			L.visible = True
		Next
	End Method
	
End Type


Type TGui
	
	Field Frames:TList
	
	Method Init()
		Frames = CreateList()
	End Method
	
	Method Update()
		For Local F:TFrame = EachIn Self.Frames
			F.Update()
		Next
	End Method
		
	Method Render()
		For Local F:TFrame = EachIn Self.Frames
			F.Render()
		Next
	End Method
	
	Method AddFrame( F:TFrame )
		Self.Frames.AddLast( F )
	End Method
	
End Type


Type TInfoText			'Type fr einen Infotext zu der Geldanzeige
	
	Field Amount:Int
	Field X:Int
	Field Y:Int
	Field Alpha:Float
	Field Color:Byte
	Field Time:Int
	Field Del:Byte
	
	Method Init( Amount:Int )
		
		Self.Amount = Amount
		If Amount > 0 Then Self.Color = 1
		Self.X = GUIX + 96
		Self.Y = 725
		Self.Alpha = 1
		
	End Method
	
	Method Update()
		
		Self.Time :+ 1
		Self.Alpha :- 0.01
		Self.Y :- 1
		Self.X = GUIX + 96 + ( Self.Time / 4 Mod 2 - 1 )
		If Self.Alpha = 0 Then Self.Del = True
		
	End Method
	
	Method Render()
		
		If Self.Color = 0 Then SetColor 200, 0, 0
		If Self.Color = 1 Then SetColor 0, 200, 0
		SetAlpha Self.Alpha
		If Self.Amount > 0 Then
			DrawText "+" + Self.Amount, Self.X, Self.Y
		Else
			DrawText Self.Amount, Self.X, Self.Y
		End If
		SetColor 255, 255, 255
		SetAlpha 1
		
	End Method
	
End Type



'Globals
Global Timer:TTimer					'Der Frametimer

Global EndGame:Byte					'Ob das Programm beendet werden soll

Global Gamestate:Byte				'Ob man sich gerade im Men oder im Spiel oder wo auch immer befindet

Global GUI:TGui					'Das Objekt, dass all die Listen fr GUI-Dinger verwaltet
Global frmGUI1:TFrame				'Frame fr die GUI-Buttons wie "Trme bauen" oder "Aktive Fhigkeiten"

Global frmTowers:TFrame				'Frame fr die Trme-Bau-Sektion

Global EmptyImage:TImage				'Leeres Bild wenn mans mal braucht

Global MenuGUI:TGui					'Mengui
Global MenuFrame:TFrame				'Frame fr das Spielmen am Anfang

Global Map:TGameMap					'Die Map

Global Money:Int					'Wie viel Geld man besitzt
Global Life:Int					'Wie viel "Leben" man noch hat

Global CanBuildTowers:Byte[ 64 ]		'Array in dem gespeichert wird, auf welchen Arten von Feldern man Trme bauen kann

Global Tileset:TImage				'Tileset Image
Global TilesetW:TImage				'Tileset Image in wei

Global ITowers:TImage[ 4 ]			'Bilder der Trme
Global TowerAnimStyles:Byte[ 4 ]		'Animationsstyles der Einheiten
Global TowerRanges:Int[ 4 ]			'Standardreichweiten der Trme
Global TowerCooldowns:Int[ 4 ]		'Cooldowns der Trme
Global TowerExtraValues:Int[ 4 ]		'Extradaten fr Trme ( Damage, Schockzeit, etc ), variiert je nach Turm
Global TowerCosts:Int[ 4 ]			'Kosten fr Trme

Global IUnits:TImage[ 7 ]			'Bilder der Einheiten
Global UnitAnimStyles:Byte[ 7 ]		'Animationsstyles der Einheiten
Global UnitSpeeds:Float[ 7 ]			'Bewegungsgeschwindigkeiten der Einheiten
Global UnitHP:Int[ 7 ]				'Lebenspunkte der Einheiten
Global UnitReward:Int[ 7 ]			'Belohnung fr die Einheit

Global IEffects:TImage[ 5 ]			'Bilder der Effekte
Global EffectFrameCounts:Byte[ 5 ]		'Anzahl der Animationsframes der Effekte

Global IGUI:TImage					'Bild der GUI
Global GUIX:Int					'X-Koordinate der GUI

Global SelectionMode:Byte			'Art der Auswahl
Global SelectedTower:TTower			'Vom Spieler ausgewhlter Turm
Global SelectedBuildingTower:Byte		'Der Typ des Turms den der Spieler bauen will

Global FStencil:TImageFont			'Schrift "Stencil"
Global FStencil18:TImageFont			'Schrift "Stencil" in der Schriftgre 18
Global FStencil72:TImageFont			'Schrift "Stencil" in der Schriftgre 72

Global MMusic1:TSound				'Musikstck 1
Global MMusic2:TSound				'Musikstck 2
Global MMusic3:TSound				'Musikstck 3
'Global MMusic4:TSound				'Musikstck 4
Global MusicChannel:TChannel			'Musikkanal
Global CurrentMusic:Byte				'Aktelle Musik Nr.

Global MenuImage:TImage				'Menbild

Global MX:Short					'Maus-X
Global MY:Short					'Maus-Y
Global MHL:Byte					'Mausklick Links
Global MHR:Byte					'Mausklick Rechts
Global MDL:Byte					'Linke Maustaste gedrckt halten

Global KEYHESC:Byte					'Ob Escape gedrckt wurde

Global APPT:Byte					'Ob Programm geschlossen wurde


'Consts

'Gamestates
Const GS_INGAME:Byte	= 1
Const GS_MENU:Byte		= 2
Const GS_VICTORY:Byte	= 3
Const GS_LOSS:Byte		= 4

'Einheiten
Const U_TANK:Byte		= 1
Const U_ROBOT:Byte		= 2
Const U_AIR1:Byte		= 3
Const U_AIR2:Byte		= 4
Const U_AIR3:Byte		= 5
Const U_JEEP:Byte		= 6

'Trme
Const T_GUNTOWER:Byte	= 1
Const T_SHOCKTOWER:Byte	= 2
Const T_TESLATOWER:Byte	= 3

'Effekte
Const E_SMOKE:Byte		= 1
Const E_EXPLOSION:Byte	= 2
Const E_SHOCK:Byte		= 3

'Auswahl-Modi
Const SM_NONE:Byte		= 0
Const SM_TOWER:Byte		= 1
Const SM_BUILDTOWER:Byte	= 2


'Initialisieren
Init()

'Local fps:Float
'Local FPS_LAST:Int
'Mainloop
Repeat
	
	'Benutzereingaben einlesen
	GetInputs()
	
	'Je nach Gamestate Funktionen ausfhren
	Select Gamestate
		
		Case GS_INGAME		'Im Spiel
			Update()
			Render()
			
		Case GS_MENU		'Im Men
			Menu()
			
		Case GS_VICTORY	'Wenn man gewonnen hat
			Render()
			Victory()
			
		Case GS_LOSS		'Wenn man verloren hat
			Render()
			Loss()
			
	End Select
	
	'Musik
	If ChannelPlaying( MusicChannel ) = False Then
		CurrentMusic :+ 1
		If CurrentMusic = 4 Then CurrentMusic = 1
		Select CurrentMusic
			Case 1
				PlaySound( MMusic1, MusicChannel )
			Case 2
				PlaySound( MMusic2, MusicChannel )
			Case 3
				PlaySound( MMusic3, MusicChannel )
			'Case 4
			'	PlaySound( MMusic4, MusicChannel )
		End Select
	End If
	
	'Fps berechnen und anzeigen 
   	'fps=(19*fps+(1000/(MilliSecs()-FPS_LAST)))/20;FPS_LAST=MilliSecs() 
   	'DrawText fps + " FPS",1,1
	
	'..
	WaitTimer Timer
	Flip 0
	Cls
	
Until EndGame = True


'Beenden
End


'Functions

'Funktion zur Initialisierung des Programmes
Function Init()
	
	'Grafikfenster
	Graphics 1024, 768, 0
	
	'Alphablend benutzen
	SetBlend ALPHABLEND
	
	'Zufallsgenerator initialisieren
	SeedRnd MilliSecs()
	
	'Leeres Bild erstellen
	EmptyImage = CreateImage( 1, 1 )
	
	'Man hat 150 Geldeinheiten und 10 Leben
	Money = 150
	Life = 10
	
	'Timer
	Timer = CreateTimer( 60 )
	
	'Im Men starten
	Gamestate = GS_MENU
	
	'CanBuildTowers-Array einlesen
	ReadCanBuildTowers()
	
	'Tilesets laden
	Tileset = LoadAnimImage( "gfx\tileset.png", 64, 64, 0, 64 )			'Tileset laden
	TilesetW = LoadAnimImage( "gfx\tilesetW.png", 64, 64, 0, 64 )		'Tileset in wei laden
	
	'Einheiten laden
	ReadUnits()
	
	'Trme laden
	ReadTowers()
	
	'Effekte laden
	LoadEffects()
	
	'Fonts laden
	FStencil = LoadImageFont( "font\STENCIL.TTF", 36 )
	FStencil18 = LoadImageFont( "font\STENCIL.TTF", 18 )
	FStencil72 = LoadImageFont( "font\STENCIL.TTF", 72 )
	SetImageFont FStencil
	
	'Musik etc laden
	Local Drivers:String[] = ["FreeAudio DirectSound", "FreeAudio Multimedia", "FreeAudio", "Null"]
	For Local Driver:String = EachIn Drivers
		If( AudioDriverExists( Driver ) ) Then
			SetAudioDriver( Driver )
			Exit
		End If
	Next
	
	MusicChannel = New TChannel
	MMusic1 = LoadSound( "sfx\music1.ogg" )
	MMusic2 = LoadSound( "sfx\music2.ogg" )
	MMusic3 = LoadSound( "sfx\music3.ogg" )
	'MMusic4 = LoadSound( "sfx\music4.ogg" )
	MusicChannel = PlaySound(MMusic1)
	
	'Menhintergrundbild laden
	MenuImage = LoadImage( "gfx\menuimage.png" )
	
	'Sidebar-Bild laden
	IGUI = LoadImage( "gfx\GUI.png" )
	
	'Sidebar soll an der X-Koordinate 768 gezeichnet werden
	GUIX = 768
	
	'Map laden
	Map = New TGameMap
	Map.Init( "map1" )
	
	'Komplette GUI-Sachen initialisieren
	InitGUI()
	
End Function

'Funktion zum Initialisieren aller GUI-Sachen
Function InitGUI()
	
	'GUI Objekt initialisieren
	GUI = New TGUI
	GUI.Init()
	
	'GUI Frame 1
	InitGuiFrame1()
	
	'GUI Towermen Frame
	InitTowerMenuFrame()
	
	'Men initialisieren
	InitMenu
	
End Function

Function InitMenu()
	
	MenuGUI = New TGUI
	MenuGUI.Init()
	
	MenuFrame = New TFrame
	MenuFrame.Init()
	MenuGUI.AddFrame( MenuFrame )
	
	'Buttons
	Local B:TButton
	
	B = New TButton
	B.Init( 130, 330, 256, 256, LoadImage( "gfx\Level01.png" ), StartLevel1, True )
	MenuFrame.AddButton( B )
	
	B = New TButton
	B.Init( 400, 330, 256, 256, LoadImage( "gfx\Level02.png" ), StartLevel2, True )
	MenuFrame.AddButton( B )
	
	B = New TButton
	B.Init( 670, 330, 256, 256, LoadImage( "gfx\Level03.png" ), StartLevel3, True )
	MenuFrame.AddButton( B )
	
	B = New TButton
	B.Init( 384, 650, 256, 64, LoadImage( "gfx\LevelExit.png" ), EndIt, True )
	MenuFrame.AddButton( B )
	
End Function

'Funktion zum Initialisieren des frmGUI1
Function InitGuiFrame1()
	
	'Frame
	frmGUI1 = New TFrame
	frmGUI1.Init()
	GUI.AddFrame( frmGUI1 )
	
	'Buttons darauf
	InitFrmGUI1Buttons()
	
End Function

'Funktion um Buttons auf frmGUI1 zu erstellen etc
Function InitFrmGUI1Buttons()
	
	Local B:TButton
	
	'Turmmen-Button
	B = New TButton
	B.Init( GUIX + 112, 320, 48, 48, EmptyImage, SwitchToTowerMenu, True, KEY_1 )
	frmGUI1.AddButton( B )
	
	'??!-Button
	B = New TButton
	B.Init( GUIX + 160, 320, 48, 48, EmptyImage, SwitchToUnitMenu, True, KEY_2 )
	frmGUI1.AddButton( B )
	
End Function

'Funktion um Turmmen-Frame zu initialisieren
Function InitTowerMenuFrame()
	
	'Frame
	frmTowers = New TFrame
	frmTowers.Init()
	GUI.AddFrame( frmTowers )
	
	'Buttons
	InitFrmTowerButtons()
	
	'Labels
	InitFrmTowerLabels()
	
End Function

'Funktion um Buttons auf Trme-Men zu initialisieren
Function InitFrmTowerButtons()
	
	Local B:TButton
	
	'Guntower-Button
	B = New TButton
	B.Init( GUIX + 52, 420, 64, 64, LoadImage( "gfx\guntower_button.png" ), GuntowerIconClick, True, KEY_Q )
	frmTowers.AddButton( B )
	
	'Shocktower-Button
	B = New TButton
	B.Init( GUIX + 120, 420, 64, 64, LoadImage( "gfx\shocktower_button.png" ), ShocktowerIconClick, True, KEY_W )
	frmTowers.AddButton( B )
	
	'Teslatower-Button
	B = New TButton
	B.Init( GUIX + 188, 420, 64, 64, LoadImage( "gfx\teslatower_button.png" ), TeslaTowerIconClick, True, KEY_E )
	frmTowers.AddButton( B )
	
End Function

'Funktion um Lables auf Trme-Men zu initialisieren
Function InitFrmTowerLabels()
	
	Local L:TLabel
	
	'Guntower-Labels
	L = New TLabel
	L.Init( GUIX + 52, 485, 64, 20, TowerCosts[ T_GUNTOWER ] )
	frmTowers.AddLabel( L )
	
	L = New TLabel
	L.Init( GUIX + 93, 425, 20, 20, "Q" )
	frmTowers.AddLabel( L )
	
	'Shocktower-Labels
	L = New TLabel
	L.Init( GUIX + 120, 485, 64, 20, TowerCosts[ T_SHOCKTOWER ] )
	frmTowers.AddLabel( L )
	
	L = New TLabel
	L.Init( GUIX + 161, 425, 20, 20, "W" )
	frmTowers.AddLabel( L )
	
	'Teslatower-Labels
	L = New TLabel
	L.Init( GUIX + 188, 485, 64, 20, TowerCosts[ T_TESLATOWER ] )
	frmTowers.AddLabel( L )
	
	L = New TLabel
	L.Init( GUIX + 229, 425, 20, 20, "E" )
	frmTowers.AddLabel( L )
	
End Function

'Funktion um Trme-Men anzuzeigen
Function SwitchToTowerMenu()
	
	frmTowers.Show()
	
End Function

'Funktion um Einheiten-Men anzuzeigen
Function SwitchToUnitMenu()
	
	frmTowers.Hide()
	
End Function

'Funktion die aufgerufen wird wenn man auf das Guntower Icon im Men klickt
Function GuntowerIconClick()
	
	If Money >= TowerCosts[ T_GUNTOWER ] Then
		SelectionMode = SM_BUILDTOWER
		SelectedBuildingTower = T_GUNTOWER
	End If
	
End Function

'Funktion die aufgerufen wird wenn man auf das Shocktower Icon im Men klickt
Function ShocktowerIconClick()
	
	If Money >= TowerCosts[ T_SHOCKTOWER ] Then
		SelectionMode = SM_BUILDTOWER
		SelectedBuildingTower = T_SHOCKTOWER
	End If
	
End Function

'Funktion die aufgerufen wird wenn man auf das Teslatower Icon im Men klickt
Function TeslatowerIconClick()
	
	If Money >= TowerCosts[ T_TESLATOWER ] Then
		SelectionMode = SM_BUILDTOWER
		SelectedBuildingTower = T_TESLATOWER
	End If
	
End Function

'Funktion zum Laden von Einheiten
Function ReadUnits()
	
	ReadUnit( "tank", U_TANK )
	ReadUnit( "robot", U_ROBOT )
	ReadUnit( "air1", U_AIR1 )
	ReadUnit( "air2", U_AIR2 )
	ReadUnit( "air3", U_AIR3 )
	ReadUnit( "jeep", U_JEEP )
	
End Function

'Funktion zum Laden von Trmen
Function ReadTowers()
	
	ReadTower( "guntower", T_GUNTOWER )
	ReadTower( "shocktower", T_SHOCKTOWER )
	ReadTower( "teslatower", T_TESLATOWER )
	
End Function

'Funktion zum Laden einzelner Einheiten
Function ReadUnit( name:String, value:Byte )
	
	Local Stream:TStream = ReadFile( "data\" + name + ".txt" )
	
	Local GFXFile:String = ReadLine( Stream )
	Local GFXFrames:Byte = Int( ReadLine( Stream ) )
	Local AnimStyle:Byte = Int( ReadLine( Stream ) )
	Local Speed:Float = Float( ReadLine( Stream ) )
	Local Hitpoints:Int = Int( ReadLine( Stream ) )
	Local Reward:Int = Int( ReadLine( Stream ) )
	
	CloseFile Stream
	
	IUnits[ value ] = LoadAnimImage( GFXFile, 64, 64, 0, GFXFrames )
	UnitAnimStyles[ value ] = AnimStyle
	UnitSpeeds[ value ] = Speed
	UnitHP[ value ] = Hitpoints
	UnitReward[ value ] = Reward
	
End Function

'Funktion zum Laden einzelner Trme
Function ReadTower( name:String, value:Byte )
	
	Local Stream:TStream = ReadFile( "data\" + name + ".txt" )
	
	Local GFXFile:String = ReadLine( Stream )
	Local GFXFrames:Byte = Int( ReadLine( Stream ) )
	Local AnimStyle:Byte = Int( ReadLine( Stream ) )
	Local Range:Int = Int( ReadLine( Stream ) )
	Local Cooldown:Int = Int( ReadLine( Stream ) )
	Local ExtraValue:Int = Int( ReadLine( Stream ) )
	Local Cost:Int = Int( ReadLine( Stream ) )
	
	CloseFile Stream
	
	ITowers[ value ] = LoadAnimImage( GFXFile, 64, 64, 0, GFXFrames )
	TowerAnimStyles[ value ] = AnimStyle
	TowerRanges[ value ] = Range
	TowerCooldowns[ value ] = Cooldown
	TowerExtraValues[ value ] = ExtraValue
	TowerCosts[ value ] = Cost
	
End Function

'Funktion zum Einlesen des CanBuildTowers-Arrays
Function ReadCanBuildTowers()
	
	'Datei ffnen
	Local Stream:TStream = ReadFile( "data\tiles.txt" )
	
	'Datei lesen und Werte speichern
	For Local i:Byte = 0 To 63
		
		CanBuildTowers[ i ] = Int( ReadLine( Stream ) )
		
	Next
	
	'Datei schlieen
	CloseFile Stream
	
End Function

'Funktion zum Laden der Grafikeffekte
Function LoadEffects()
	
	'Bilder laden
	AutoMidHandle 1
	IEffects[ E_Smoke ] 	= LoadAnimImage( "gfx\smoke.png", 		10, 10, 0, 4 )
	IEffects[ E_Explosion ]	= LoadAnimImage( "gfx\explosion.png",	10, 10, 0, 8 )
	IEffects[ E_Shock ]		= LoadAnimImage( "gfx\shock.png",		64, 64, 0, 8 )
	AutoMidHandle 0
	
	'Anzahl Frames zuweisen
	EffectFrameCounts[ E_Smoke ] 		= 4
	EffectFrameCounts[ E_Explosion ] 	= 8
	EffectFrameCounts[ E_Shock ] 		= 8
	
End Function

'Funktion zum Updaten des Spiels
Function Update()
	
	'Bei Escape soll es beenden
	If ( KEYHESC = True ) Or ( APPT = True ) Then EndGame = True
	
	'Map updaten
	Map.Update()
	
	'GUI updaten
	Gui.Update()
	
	'Auswahlen aktualisieren
	DoSelections()
	
End Function

'Funktion zum Rendern des Spiels
Function Render()
	
	'Map rendern
	Map.Render()
	
	'GUI rendern
	RenderSidebar()
	GUI.Render()
	
	'Auswahlkreis eines Turms
	RenderSelections()
	
End Function

'Funktion um Auswahlen zu erkennen
Function DoSelections()
	
	'Falls Maus geklickt wurde
	If MHL = True Then
		
		If MX >= 800 Then
			
			'Maus auf GUI
			
		Else
			
			'Maus auf Map
			
			If SelectionMode = SM_BUILDTOWER Then
				PlaceTower()				
			Else
			
				'Noch nichts wurde ausgewhlt
				SelectionMode = SM_NONE
					
				'Trme
				For Local T:TTower = EachIn Map.Towers
					T.CheckIfClicked()	
				Next
			
			End If
			
		End If
		
	End If
	
	'Falls rechte Maustaste gedrckt wurde
	If MHR = True Then
		
		SelectionMode = SM_NONE
		
	End If
	
End Function

'Funktion um Auswahl z.B. eines Turmes darzustellen
Function RenderSelections()
	
	Select SelectionMode
		
		Case SM_TOWER
			DrawSelectedTowerCircle()
			
		Case SM_BUILDTOWER
			SetAlpha 0.8
			Local X:Int = Map.GetTileC( MX, MY, 1 )
			Local Y:Int = Map.GetTileC( MX, MY, 2 )
			If Map.Tiles[ X, Y ].CanBuildTower = 0 Then SetColor 200, 0, 0
			X = XConvertItoS( X, Y )
			Y = YConvertItoS( Y ) - 17
			DrawImage ITowers[ SelectedBuildingTower ], X, Y, 0
			SetColor 255, 255, 255
			SetAlpha 1
		
	End Select
	
End Function

'Funktion um Reichweiten- / und Cooldownkreis um ausgewhlten Turm zu zeichnen
Function DrawSelectedTowerCircle()
	
	SetColor 200, 200, 200
	SetAlpha 0.3
	
	Local ST:TTower = SelectedTower
	
	'Hellen Reichweitenkreis malen
	Local X:Int = ST.SX
	Local Y:Int = ST.SY
	Local R:Int = ST.Range
	DrawOval X + 32 - R, Y + 42 - R, R * 2, R * 2
	
	'Cooldownkreis
	For Local A:Float = ( ST.Firerate - ST.Cooldown ) / Float( ST.Firerate ) * 360.0 - 90 To 269
		
		DrawLine ST.SX + 32, ST.SY + 42, ST.SX + 32 + Cos( A ) * 15, ST.SY + 42 + Sin( A ) * 15
		
	Next
	
	'Farbe und Alpha wieder zurcksetzen
	SetColor 255, 255, 255
	SetAlpha 1
	
End Function

'Funktion zum Rendern der Sidebar
Function RenderSidebar()
	
	'Sidebar-Bild
	DrawImage IGUI, GUIX, 0
	
	'Geld
	DrawText Money, GUIX + 96, 725
	
	'Nchste Welle Anzeige, falls demnchst eine kommt
	If Map.NextWaveTime > 0 Then
		SetColor 200, 200, 200
		SetAlpha 0.5
		
		DrawRect GUIX - 190, 0, 206, 40
		DrawRect GUIX + 16, 0, -180 * ( Map.NextWaveTime / 300.0 ), 40
		
		SetAlpha 0.8
		DrawText "Next Wave", GUIX - 185, 5
		
		SetColor 255,255,255
	End If
	
	'Lebensanzeige
	SetAlpha 0.8
	DrawText "Leben: " + Life, 5, 5
	
	'Farbe und Alpha wieder zurcksetzen
	SetColor 255, 255, 255
	SetAlpha 1
	
End Function


'Funktion zum Ermitteln von Eingaben
Function GetInputs()
	
	'Maus
	MX = MouseX()
	MY = MouseY()
	MHL = MouseHit( MOUSE_LEFT )
	MHR = MouseHit( MOUSE_RIGHT )
	MDL = MouseDown( MOUSE_LEFT )
	
	'Tastatur
	KEYHESC = KeyHit( KEY_ESCAPE )
	
	'AppTerminate
	APPT = AppTerminate()
	
End Function


'Funktion zum zentrierten Schreiben von Text
Function DrawCenteredText( txt:String, x:Int, y:Int )
	
	Local newX:Int
	Local newY:Int
	
	newX = x - TextWidth( txt ) / 2
	newY = y - TextHeight( txt ) / 2
	
	DrawText txt, newX, newY
		
End Function


'Funktionen um Iso-Koordinaten in Bildschirmkoordinaten umzurechnen
Function XConvertItoS:Int( X:Byte, Y:Byte )
	
	Return ( x * 64 + ( y Mod 2 ) * 32 ) - 32
	
End Function

Function YConvertItoS:Int( Y:Byte )
	
	Return y * 16 - 41
	
End Function


'Funktionen um Bildschirmkoordinaten in Iso-Koordinaten umzuwandeln
Function XConvertStoI:Int( X:Int, Y:Int )
	
	Return ( X + 32 - 32 * ( Y Mod 2 ) ) / 64
	
End Function

Function YConvertStoI:Int( Y:Int )
	
	Return ( Y + 41 ) / 16
	
End Function


'Funktion um Guntower zu platzieren
Function PlaceTower()
	
	Local X:Int = Map.GetTileC( MX, MY, 1 )
	Local Y:Int = Map.GetTileC( MX, MY, 2 )
	
	If Map.Tiles[ X, Y ].CanBuildTower = 1 Then
		
		Local T:TTower = New TTower
		T.Init( X, Y, SelectedBuildingTower )
		Map.AddTower( T )
		Map.Tiles[ X, Y ].CanBuildTower = 0
		SelectionMode = SM_NONE
		GetMoney( - TowerCosts[ SelectedBuildingTower ] )
		
	End If
	
End Function


'Funktion um den Guntower zu animieren
Function AnimGuntower( T:TTower )
	
	'Winkel der nchsten Einheit ermitteln
	Local angle:Float = FindNearestUnitAngle( T )
	If angle > -1 Then
		
		angle = ( Int( angle ) / 45 * 45 ) Mod 360
		
		T.LastFrame = T.Frame
		
		'Je nach dem Turm Frame zuweisen
		If angle = 225 Then T.Frame = 0
		If angle = 180 Then T.Frame = 1
		If angle = 135 Then T.Frame  = 2
		If angle = 90 Then T.Frame = 3
		If angle = 45 Then T.Frame = 4
		If angle = 0 Then T.Frame = 5
		If angle = 315 Then T.Frame = 6
		If angle = 270 Then T.Frame = 7
		
	Else
		
		T.Frame = T.LastFrame
		
	End If
	
End Function


'Funktion um einen Guntower abzufeuern
Function FireGuntower( T:TTower )
	
	'Winkel der nchsten Einheit ermitteln
	Local angle:Float = FindNearestUnitAngle( T )
	If angle > -1 Then
		
		angle = Int( angle / 45 ) * 45
		
		'Effekte
		Local E:TEffect = New TEffect
		E.Init( T.SX + 32 + Cos( angle ) * 30, T.SY + 42 - Sin( angle ) * 25, E_SMOKE, 1 )
		Map.AddEffect( E )
		
		'Schuss
		Local U:TUnit = FindNearestUnit( T )
		Local S:TShot = New TShot
		S.Init( T.SX + 32, T.SY + 42, T, U )
		Map.AddShot( S )
		
		T.Cooldown = T.Firerate
		
	End If
	
End Function


'Funktion um eine Schockwelle abzufeuern
Function FireShocktower( T:TTower )
	
	'Variable zum Anzeigen ob der Tower feuert
	Local Fire:Byte
	
	'Alle Einheiten in der Umgebung schocken
	For Local U:TUnit = EachIn Map.Units
		
		Local distance:Int = Sqr( ( T.SX - U.X )^2 + ( T.SY - U.Y )^2 )
		
		If distance < T.Range
			
			Fire = 1
			T.Cooldown = T.Firerate
			U.ShockedTime = T.ExtraValue
			
		End If
		
	Next
	
	'Schnen Schockeffekt machen
	If Fire = 1 Then
		
		Local E:TEffect = New TEffect
		E.Init( T.SX + 32, T.SY + 36, E_SHOCK, T.Range / 13.0 )
		Map.AddEffect( E )
		
	End If
	
End Function


'Funktion um einen Teslatower abzufeuern
Function FireTeslatower( T:TTower )
	
	'Winkel der nchsten Einheit ermitteln
	Local U:TUnit = FindNearestUnit( T )
	If U <> Null Then
		
		'Blitzeffekt
		Local B:TBlitz = New TBlitz
		B.Init( T.SX + 32, T.SY + 16, U.X + 32, U.Y + 32 )
		Map.Blitzs.AddLast( B )
		
		'Schaden
		U.GetDamage( T.ExtraValue )
		
	End If
	
End Function


'Funktion um nchste Einheit vom Turm zu finden
Function FindNearestUnit:TUnit( T:TTower )
	
	Local minimum:Int = 999999
	Local minunit:TUnit
	
	For Local U:TUnit = EachIn Map.Units
		
		Local distance:Int = Sqr( ( ( T.SX + 32 ) - ( U.X + 32 ) )^2 + ( ( T.SY + 42 ) - ( U.Y + 32 ) )^2 )
		If distance < minimum And distance <= T.Range Then
			minimum = distance
			minunit = U
		End If
		
	Next
	
	If minunit <> Null Then
		Return minunit
	Else
		Return Null
	End If
	
End Function

'Funktion um den Winkel zur nchsten Einheit vom Turm zu finden
Function FindNearestUnitAngle:Float( T:TTower )
	
	Local U:TUnit = FindNearestUnit( T )
	
	If U = Null Then Return -1
	
	Local angle:Float = GetAngle( T.SX + 32, T.SY + 42, U.X + 32, U.Y + 32 )
		
	Return angle
	
End Function

'Funktion um Geld zu verlieren
Function GetMoney( amount:Int )
	
	Money :+ amount
	Local I:TInfoText = New TInfoText
	I.Init( amount )
	FrmGUI1.AddInfoText( I )
	
End Function

'Funktion um Winkel zwischen 2 Koordinaten zu ermitteln
Function GetAngle:Float( X1:Int, Y1:Int, X2:Int, Y2:Int )
	
	Return ( - ATan2( Y2 - Y1, X2 - X1 ) + 360 ) Mod 360
	
End Function

'Funktion zum prfen ob sich zwei Kreise schneiden
Function CirclesOverlap:Byte( X1:Int, Y1:Int, R1:Int, X2:Int, Y2:Int, R2:Int )
	
	If Sqr( ( X2 - X1 )^2 + ( Y2 - Y1 )^2 ) < R1 + R2 Then
		Return True
	Else
		Return False
	End If
	
End Function

'Funktion die aufgerufen wird, wenn man gewonnen hat
Function Victory()
	
	SetColor 255, 255, 255
	
	Gamestate = GS_VICTORY
	
	SetImageFont FStencil72
	
	DrawCenteredText "Victory!", 512, 340
	
	SetImageFont FStencil18
	
	DrawCenteredText "Press a key to continue!", 512, 440
	Local k:Int = GetChar()
	If k <> 0 Then Gamestate = GS_MENU
	
End Function

'Funktion die aufgerufen wird, wenn man verloren hat
Function Loss()
	
	SetColor 255, 255, 255
	
	Gamestate = GS_LOSS
	
	SetImageFont FStencil72
	
	DrawCenteredText "Defeat!", 512, 340
	
	SetImageFont FStencil
	
	DrawCenteredText "Press a key to continue!", 512, 440
	Local k:Int = GetChar()
	If k <> 0 Then Gamestate = GS_MENU
	
End Function

'Men-Funktion
Function Menu()
	
	SetScale 1.6, 1.6
	DrawImage MenuImage, 0, 0
	SetScale 1, 1
	
	If KEYHESC Or APPT Then End
	
	MenuGUI.Update()
	MenuGUI.Render()
	
End Function

Function StartLevel1()
	
	Map.Init( "map1" )
	Gamestate = GS_INGAME
	
End Function

Function StartLevel2()
	
	Map.Init( "map2" )
	Gamestate = GS_INGAME
	
End Function

Function StartLevel3()
	
	Map.Init( "map3" )
	Gamestate = GS_INGAME
	
End Function

Function EndIt()
	
	EndGame = True
	
End Function