SuperStrict


'Types
Type TTile			'Tile-Type
	
	Field TilesetValue:Byte
	
	'init methode
	Method Init( value:Byte )
		
		Self.TilesetValue = value
		
	End Method
	
	'update methode
	Method Update()
	
	End Method
	
	'render-methode
	Method Render()
	
	End Method
	
End Type


Type TGameMap			'Map-Type
	
	Field Tiles:TTile[ 13, 50 ]
	
	Method Init( file:String )
		
		'Datei ffnen
		Local Stream:TStream = ReadFile( file )
		
		'Map einlesen
		For Local y:Byte = 0 To 49
			
			For Local x:Byte = 0 To 12
				
				Self.Tiles[ x, y ] = New TTile				'Tile erstellen
				Self.Tiles[ x, y ].Init( ReadByte( Stream ) )	'Tile initialisieren
				
			Next
			
		Next
		
		'Wege erstellen / lesen
		Ways = CreateList()
		
		Local W:TWay
		
		For Local I:Byte = 0 To 9
			
			W = New TWay
			W.Init( I )
			Ways.AddLast W
			
			Local C:Byte = ReadByte( Stream )
			
			For Local J:Byte = 1 To C
				
				Local P:TWaypoint = New TWaypoint
				Local X:Byte = ReadByte( Stream )
				Local Y:Byte = ReadByte( Stream )
				Local D:Byte = ReadByte( Stream )
				P.Init( X, Y, D )
				W.AddPoint( P )
				
			Next
			
			
		Next
		
		'Datei schlieen
		CloseFile Stream
		
		'Kollisionspixmap rendern
		RenderPixmap()
		
	End Method
	
	Method Update()
		
		'Checken ob Maus nicht doof ist
		If MX > 0 And MY > 0 And MX <= 1024 And MY <= 768 Then
			
			Select DrawMode
				Case 0	'Tiles
					'Tile setzen
					If MDL = True Then
						GetTile( MX, MY ).TilesetValue = SelectedTile
						RenderPixmap()
					End If
					
					'Pipette
					If KEYDP = True Then
						SelectedTile = GetTile( MX, MY ).TilesetValue
					End If
					
					'Floodfill
					If KEYHF = True And GetTile( MX, MY ).TilesetValue <> SelectedTile Then
						Local X:Byte = Self.GetTileC( MX, MY, 1 )
						Local Y:Byte = Self.GetTileC( MX, MY, 2 )
						Local V:Byte = Self.GetTile( MX, MY ).TilesetValue
						Map.Floodfill( X, Y, V, SelectedTile )
						RenderPixmap()
					End If
					
				Case 1	'Waypoints
					If MHL = True Then
						If Not( Self.GetTile( MX, MY ) = Null ) Then
							For Local W:TWay = EachIn Ways
								If W.NR = SelectedWay Then
									Local P:TWaypoint = New TWaypoint
									P.Init( Self.GetTileC( MX, MY, 1 ), Self.GetTileC( MX, MY, 2 ), SelectedTile )
									W.AddPoint( P )
								End If
							Next
						End If
					End If
					
					If MHR = True Then
						For Local W:TWay = EachIn Ways
							If W.NR = SelectedWay Then
								W.DeleteLastPoint()
							End If
						Next
					End If
					
			End Select
		End If
		
	End Method
	
	Method GetTile:TTile( X:Int, Y:Int )
		
		Local ARGB:Int = ReadPixel( CollPixmap, MX, MY )
			
		Local R:Int = ( ARGB Shl 8 ) Shr 24
		Local G:Int = ( ARGB Shl 16 ) Shr 24
		
		Return Self.Tiles[ R, G ]
		
	End Method
	
	Method GetTileC:Byte( X:Int, Y:Int, Ret:Byte )
		
		Local ARGB:Int = ReadPixel( CollPixmap, MX, MY )
			
		Local R:Int = ( ARGB Shl 8 ) Shr 24
		Local G:Int = ( ARGB Shl 16 ) Shr 24
		
		Select Ret
			Case 1
				Return R
			Case 2
				Return G
		End Select
		
	End Method
	
	Method Render()
		
		If KEYDC = False Then
			
			For Local y:Byte = 0 To 49
				
				For Local x:Byte = 0 To 12
					
					DrawImage Tileset, ( x * 64 + ( y Mod 2 ) * 32 ) - 32, y * 16 - 41, Self.Tiles[ x, y ].TilesetValue
					
				Next
				
			Next
			
		Else
			
			DrawPixmap CollPixmap, 0, 0
			
		EndIf
		
	End Method
	
	Method Save()
		
		Local Filename:String = "level\" + Input("Dateiname eingeben: ") + "\map"
		Local Stream:TStream = WriteFile( Filename )
		
		For Local y:Byte = 0 To 49
			
			For Local x:Byte = 0 To 12
				
				WriteByte( Stream, Self.Tiles[ x, y ].TilesetValue )
				
			Next
			
		Next
		
		For Local W:TWay = EachIn Ways
			
			WriteByte( Stream, CountList( W.Points ) )
			
			For Local P:TWaypoint = EachIn W.Points
				
				WriteByte( Stream, P.X )
				WriteByte( Stream, P.Y )
				WriteByte( Stream, P.Direction )
				
			Next
			
		Next
		
		CloseFile Stream
		
	End Method
	
	Method FloodFill( X:Int, Y:Int, Tile1:Byte, Tile2:Byte )
		
		If X > -1 And X < 13 And Y > -1 And Y < 50 Then
			
			If Self.Tiles[ X, Y ].TilesetValue = Tile1 Then
				
				Self.Tiles[ X, Y ].TilesetValue = Tile2
				
				Self.FloodFill( X, Y - 1, Tile1, Tile2 )
				Self.FloodFill( X, Y + 1, Tile1, Tile2 )
				Self.FloodFill( X - 1 + ( Y Mod 2 ) * 2, Y - 1, Tile1, Tile2 )
				Self.FloodFill( X - 1 + ( Y Mod 2 ) * 2, Y + 1, Tile1, Tile2 )
				
			End If
			
		End If
		
	End Method
	
End Type


Type TWay			'Wegtype
	
	Field Points:TList
	Field NR:Byte
	
	Method Init( NR:Byte )
		Self.Points = CreateList()
		Self.NR = NR
	End Method
	
	Method AddPoint( P:TWaypoint )
		Self.Points.AddLast P
	End Method
	
	Method DeleteLastPoint()
		Self.Points.RemoveLast
	End Method
	
	Method Render()
		SetColor 255, 0, 0
		For Local P:TWaypoint = EachIn Self.Points
			P.Render()
			SetColor 255, 255, 255
		Next
		SetColor 255, 255, 255
	End Method
	
End Type


Type TWaypoint		'Wegpunkttyp
	
	Field X:Byte
	Field Y:Byte
	Field Direction:Byte
	
	Method Init( X:Byte, Y:Byte, Direction:Byte )
		Self.X = X
		Self.Y = Y
		Self.Direction = Direction
	End Method
	
	Method Render()
		DrawImage Arrow, ( Self.X * 64 + ( Self.Y Mod 2 ) * 32 ) - 32, Self.Y * 16 - 41, Self.Direction
	End Method
	
End Type

'Globals
Global Timer:TTimer		'Der Frametimer

Global EndGame:Byte		'Ob das Programm beendet werden soll

Global Map:TGameMap		'Die Map

Global Tileset:TImage	'Tileset Image
Global TilesetW:TImage	'Tileset Image in wei

Global Arrow:TImage		'Pfeil Image

Global CollPixmap:TPixmap'Pixmap fr die Kollision

Global DrawMode:Byte	'Zeichenmodus

Global SelectedTile:Int	'Ausgewhltes Tile

Global SelectedWay:Byte	'Ausgewhlter Weg im W

Global Ways:TList		'Wege


Global MX:Short		'Maus-X
Global MY:Short		'Maus-Y
Global MHL:Byte		'Mausklick Links
Global MHR:Byte		'Mausklick Rechts
Global MDL:Byte		'Linke Maustaste gedrckt halten
Global MZS:Int			'Mausrad-"Geschwindigkeit"

Global KEYHESC:Byte		'Ob Escape gedrckt wurde
Global KEYDC:Byte		'Ob C gedrckt wird
Global KEYDP:Byte		'Ob P gedrckt wird
Global KEYHS:Byte		'Ob S gedrckt wurde
Global KEYHL:Byte		'Ob L gedrckt wurde
Global KEYHF:Byte		'Ob F gedrckt wurde
Global KEYHCL:Byte		'Ob die linke Cursortaste gedrckt wurde
Global KEYHCR:Byte		'Ob die rechte Cursortaste gedrckt wurde
Global KEYHNR:Byte		'Ob Nummerntasten gedrckt wurden und welche

Global APPT:Byte		'Ob Programm geschlossen wurde



'Initialisieren
Init()


'Mainloop
Repeat
	
	'Benutzereingaben einlesen
	GetInputs()
		
	Update()
	Render()
	
	'..
	WaitTimer Timer
	Flip 0
	Cls
	
Until EndGame = True


'Beenden
End


'Funktion zur Initialisierung des Programmes
Function Init()
	
	Graphics 1024, 768, 0
	
	'Timer
	Timer = CreateTimer( 60 )
	
	'Tileset laden
	Tileset = LoadAnimImage( "gfx\tileset.png", 64, 64, 0, 64 )
	
	'Tileset in wei laden
	TilesetW = LoadAnimImage( "gfx\tilesetW.png", 64, 64, 0, 64 )
	
	'Pfeile laden
	Arrow = LoadAnimImage( "gfx\Pfeil.png", 64, 64, 0, 4 )
	
	'Collision Pixmap erstellen
	CollPixmap = CreatePixmap( 1024, 768, PF_BGR888 )
	ClearPixels( CollPixmap, $FF000000 )
	
	'Map laden
	Map = New TGameMap
	Map.Init( "level\empty" )
	
	'GUI Objekt initialisieren
	'GUI = New TGUI
	'GUI.Init()
	
End Function


'Funktion zum Updaten des Spiels
Function Update()
	
	'Bei Escape soll es beenden
	If ( KEYHESC = True ) Or ( APPT = True ) Then EndGame = True
	
	'Map updaten (?)
	Map.Update()
	
	'Zeichenmodus bestimmen
	DrawMode :+ KEYHCR - KEYHCL
	If DrawMode < 0 Then DrawMode = 1
	If DrawMode > 1 Then DrawMode = 0
	
	'Ausgewhltes Tile bestimmen
	SelectedTile :+ ( MZS > 0 ) - ( MZS < 0 )
	
	Select DrawMode
		Case 0	'Tiles
			If SelectedTile < 0 Then SelectedTile = 63
			If SelectedTile > 63 Then SelectedTile = 0
		Case 1	'Waypoints
			If SelectedTile < 0 Then SelectedTile = 3
			If SelectedTile > 3 Then SelectedTile = 0
			SelectedWay = KEYHNR
	End Select
	
	'Speichern wenn man mchte
	If KEYHS = True Then Map.Save()
	
	'Laden wenn man mchte
	If KEYHL = True Then
		Local Mapname:String = Input("Map laden: ")
		Map.Init( "level\" + Mapname + "\map" )
	End If
	
	'GUI updaten
	'Gui.Update()
	
End Function


'Funktion zum Rendern des Spiels
Function Render()
	
	'Map rendern
	Map.Render()
	
	'DrawMode anzeigen (1)
	Local T:String
	
	'Ausgewhltes Tile rendern
	Select DrawMode
		Case 0	'Tiles
			DrawImage Tileset, MX, MY - 32, SelectedTile
			T = "Tiles"
		Case 1	'Waypoints
			'Wegpunkte dieses Typs rendern
			For Local W:TWay = EachIn Ways
				If W.NR = SelectedWay Then W.Render()
			Next
			
			'Ausgewhlten Pfeil rendern
			DrawImage Arrow, MX, MY - 32, SelectedTile
			T = "Waypoints" + SelectedWay
	End Select
	
	'DrawMode anzeigen (2)
	DrawText "Zeichenmodus: " + T, 820, 10
	
	'SelectedTile anzeigen
	DrawText "Ausgewaehlt: " + SelectedTile, 820, 25
	
	'GUI rendern
	'GUI.Render()
	
End Function


'Funktion zum Ermitteln von Eingaben
Function GetInputs()
	
	'Maus
	MX = MouseX()
	MY = MouseY()
	MHL = MouseHit( MOUSE_LEFT )
	MHR = MouseHit( MOUSE_RIGHT )
	MDL = MouseDown( MOUSE_LEFT )
	MZS = MouseZSpeed()
	
	'Tastatur
	KEYHESC = KeyHit( KEY_ESCAPE )
	KEYDC = KeyDown( KEY_C )
	KEYDP = KeyDown( KEY_P )
	KEYHS = KeyHit( KEY_S )
	KEYHL = KeyHit( KEY_L )
	KEYHF = KeyHit( KEY_F )
	KEYHCL = KeyHit( KEY_LEFT )
	KEYHCR = KeyHit( KEY_RIGHT )
	For Local N:Byte = KEY_0 To KEY_9
		If KeyHit( N ) Then KEYHNR = N - KEY_0
	Next
	
	'AppTerminate
	APPT = AppTerminate()
	
End Function


'Funktion zum Neu-Rendern der Kollisions-Pixmap
Function RenderPixmap()
	
	Cls
	
	For Local y:Byte = 0 To 49
		For Local x:Byte = 0 To 12
			SetColor x, y, 0
			
			DrawImage TilesetW, ( x * 64 + ( y Mod 2 ) * 32 ) - 32, y * 16 - 41, Map.Tiles[ x, y ].TilesetValue
		Next
	Next
	
	CollPixmap = GrabPixmap( 0, 0, 1024, 768 )
	
	SetColor 255, 255, 255
	
End Function


'Funktion zum zentrierten Schreiben von Text
Function DrawCenteredText( txt:String, x:Int, y:Int )
	
	Local newX:Int
	Local newY:Int
	
	newX = x - TextWidth( txt ) / 2
	newY = y - TextHeight( txt ) / 2
	
	DrawText txt, newX, newY
		
End Function