'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Graphics Manager managed the different Screen resolutions and ratios. It provides an abstract layer for the programmer to program his games on a fixed resolution, keeping that aspect ratio on all other resolutions.
End Rem
Type TGraphicsManager
	Field scale:Float
	Field virtualResolution:Float[2]
	Field resolutionOffset:Float[2]
	
	Method recalcResolution()
		Local screenRatio:Float[2]
		screenRatio[0] = Double(TProgramSettings.GFX_WIDTH_NATIVE) / TProgramSettings.GFX_WIDTH
		screenRatio[1] = Double(TProgramSettings.GFX_HEIGHT_NATIVE) / TProgramSettings.GFX_HEIGHT
		
		scale:Float = Min(screenRatio[0], screenRatio[1])

		virtualResolution[0] = TProgramSettings.GFX_WIDTH_NATIVE / scale
		virtualResolution[1] = TProgramSettings.GFX_HEIGHT_NATIVE / scale
		
		SetVirtualResolution(virtualResolution[0], virtualResolution[1])
		
		'offset calculation
		Local boarderWidth:Float = Max(0, virtualResolution[0] - TProgramSettings.GFX_WIDTH)
		Local boarderHeight:Float = Max(0, virtualResolution[1] - TProgramSettings.GFX_HEIGHT)
		
		resolutionOffset[0] = boarderWidth / 2
		resolutionOffset[1] = boarderHeight / 2
		SetOrigin(resolutionOffset[0], resolutionOffset[1])
		
		'viewport calculation
		SetViewport(resolutionOffset[0], resolutionOffset[1], TProgramSettings.GFX_WIDTH, TProgramSettings.GFX_HEIGHT)
	End Method
	

	Field gfx:TGraphics

	Method onStart()
		gfx = Graphics(TProgramSettings.GFX_WIDTH_NATIVE, TProgramSettings.GFX_HEIGHT_NATIVE, -1 * (TProgramSettings.GFX_WINDOWED = False))
		recalcResolution()
	End Method
	
	Method startRendering()
		Cls
	End Method
	
	Method finishRendering()
		Flip 1
	End Method
	
	Method onStop()
		'gfx.Close() ''somehow a bug is here
	End Method
End Type
