'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:This Type manages all Views
	TODO: Time Management
End Rem
Type TProgramManager
	Global _singleton:Byte
	Global programManager:TProgramManager
	Field graphicsManager:TGraphicsManager
	
	Field _TimeCurrent:Double
	Field _TimeLastProcess:Double
	Field _TimeDt:Double
	
	Function getInstance:TProgramManager()
		Return programManager
	End Function
	
	Method New()
		Assert _singleton = False, "TProgramManager.New(): Only a single instance of this type is allowed!"
		_singleton = True
		programManager = Self
	End Method


	Method Main()
		_onStart()
		While (Not _shutdown)
			MouseX()'tweek, if mousex() isn't called once withing the loop, the window freezes
			_calcTime()
			_currentView.onProcess(_TimeDt) 'ToDo: make process time invariant
			_graphicsManager.startRendering()
			_currentView.onDraw()
			_graphicsManager.finishRendering()
		Wend
		_onStop()
	End Method
	
	Method shutdown()
		_shutdown = True
	End Method
	
	
	
	
	
	
	'########## Private methods & functions #################
	
	Field _shutdown:Byte
	Field _currentView:TView
	Field _graphicsManager:TGraphicsManager
	
	Function _EventHook:Object(id:Int, data:Object, context:Object)
		Local event:TEvent = TEvent(data)

		If programManager = Null Return data
		
		Select event.id
			Case EVENT_MOUSEMOVE
				'manipulate mouse coordinates to fit the managed new resolion of the screen:
				Local gfxMngr:TGraphicsManager = programManager._graphicsManager
				If gfxMngr
					event.x = event.x / gfxMngr.scale - gfxMngr.resolutionOffset[0]
					event.y = event.y / gfxMngr.scale - gfxMngr.resolutionOffset[1]
					If event.x < 0 event.x = 0
					If event.x > TProgramSettings.GFX_WIDTH event.x = TProgramSettings.GFX_WIDTH
					If event.y < 0 event.y = 0
					If event.y > TProgramSettings.GFX_HEIGHT event.y = TProgramSettings.GFX_HEIGHT
				EndIf
			Case EVENT_APPTERMINATE
				DebugLog "AppTerminate"
				programManager.shutdown()
				Return Null
			Case EVENT_APPSUSPEND
				DebugLog "AppSuspend"
				If programManager._currentView programManager._currentView.onPause()
				Return Null
			Case EVENT_APPRESUME
				DebugLog "AppResume"
				If programManager._currentView programManager._currentView.onResume()
				Return Null
			Case EVENT_KEYDOWN
				If event.data = KEY_END programManager.shutdown()
		End Select
		If programManager._currentView = Null Return data
		Return programManager._currentView.onEvent(id, event, context)
	End Function
	
	Method _calcTime()
		_TimeCurrent = MilliSecs()
		_TimeDt = _TimeCurrent - _TimeLastProcess
		If _TimeDt > 25 _TimeDt = 25
		_TimeLastProcess = _TimeCurrent
	End Method
	
	Method _onStart()
		_shutdown = False
		seedrnd(millisecs())
		Local xmlNode:TXMLNode = TXMLReader.ReadXML(ReadFile("res/settings.ini"))
		xmlNode = TXMLNode(xmlNode.children.First())
		If xmlNode.name = "program"
			TProgramSettings.GFX_WIDTH_NATIVE = Int(xmlNode.getValue("gfxwidth"))
			TProgramSettings.GFX_HEIGHT_NATIVE = Int(xmlNode.getValue("gfxheight"))
			TProgramSettings.GFX_WINDOWED = not Int(xmlNode.getValue("fullscreen"))
			TProgramSettings.PLAYERNAME = xmlNode.getValue("playername")	
		EndIf
		
		AppTitle = My.Application.name
		
		
		
		TGuiObject._onProgramStart()
		AddHook(EmitEventHook, TProgramManager._EventHook)
		_graphicsManager = New TGraphicsManager
		_graphicsManager.onStart()
		_setCurrentView(TProgramSettings.startview)
	End Method
	
	Method _onStop()
		_setCurrentView(Null)
		_graphicsManager.onStop()
		_graphicsManager = Null
		programManager = Null
	End Method
	
	Method _setCurrentView(view:TView)
		Local _oldView:TView = _currentView
		
		If view view.onCreate() 'TODO: Move this to an earlier position
		
		If _oldView 'If old view exists
			_oldView.onStop()
		EndIf

		_currentView = view
		
		If _oldView 'If old view exists
			_oldView.onDestroy()
			_oldView = Null
		EndIf
		
		If _currentView _currentView.onStart()
		
		FlushKeys()
		FlushMouse()
	End Method

End Type
