'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:A special effect for fading in / out.
End Rem
Type TViewFadeEffect
	Field finished:Byte
	Field progress:Double 'value between 0 and 1. 0 = beginning, 1 = end (invariant by fade direction)
	Field fade:Double 'progress value with fade Calc applied on (influenced by fade direction)
	Field duration:Double
	Field timecounter:Double
	Field fadecolor:Int
	Field fadeDirectionMode:Byte
	Field fadeCalcMode:Byte
	
	' FadeDirectionMode Constants
	Const FADEDIR_IN:Byte = 0
	Const FADEDIR_OUT:Byte = 1
	
	' Fade Calculation Mode Constants
	Const FADECALC_LINEAR:Byte = 0 'linear blend progress
	Const FADECALC_SIN:Byte = 1 ' sin blend progress
	Const FADECALC_EXP:Byte = 2 ' exponential progress
	Const FADECALC_SQR:Byte = 3 ' squareroot progress
	
	Function Create:TViewFadeEffect(fadeDirectionMode:Byte = FADEDIR_IN, duration:Double, fadeCalcMode:Byte = FADECALC_LINEAR, fadecolor:Int = $ff000000)
		Local fe:TViewFadeEffect = New TViewFadeEffect
		fe.fadecolor = fadecolor
		fe.duration = duration
		fe.fadeDirectionMode = fadeDirectionMode
		fe.fadeCalcMode = fadeCalcMode
		fe.reset()
		Return fe
	End Function
	
	Method reset()
		finished = False
		progress = 0
		timecounter = 0
		process(0)
	End Method
	
	Method process(dt:Double)
		timecounter:+dt
		progress = timecounter / duration
		If progress > 1
			progress = 1
			finished = True
		End If
		
		Select fadeDirectionMode
			Case FADEDIR_IN
				fade = (1.0 - progress)
			Case FADEDIR_OUT
				fade = progress
		End Select
		
		Select fadeCalcMode
			Case FADECALC_SIN
				fade = Sin(fade * 90)
			Case FADECALC_EXP
				fade = fade * fade
			Case FADECALC_SQR
				fade = Sqr(fade)
		End Select
	End Method
	
	Method draw()
		SetBlend ALPHABLEND
		SetIntColor(fadecolor)
		
		SetAlpha fade
		DrawRect(0, 0, TProgramSettings.GFX_WIDTH, TProgramSettings.GFX_HEIGHT)
		
		SetAlpha 1
		SetColor 255, 255, 255
	End Method
	
	Method isFinished:Int()
		Return finished
	End Method
End Type
