'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TGuiAbstractButton Extends TGuiObject Abstract
	Field state_pressedDown:Byte
	Field data:Int 'is send via Event if button fires an event
	Field extra:Object

	Rem
		bbdoc:Gets called if an event occurs. return "null" if this object processed the event. Otherwise return super.onEvent() to make sure your children get it as well.
	End Rem
	Method onEvent:Object(id:Int, event:TEvent, context:Object)
		If Self.active = False Return event
		Select event.id
			Case EVENT_MOUSEDOWN
				If state_mouseOver = False Return event
				onButtonPressed()
				Return Null
			Case EVENT_MOUSEUP
				If state_mouseOver = False Return event
				If state_pressedDown
					onButtonReleased()
					onButtonClicked()
				End If
				Return Null
		End Select
		Return Super.onEvent(id, event, context)
	End Method
	
	Method setData(s:Int)
		data = s
	End Method
	
	Method getData:Int()
		Return data
	End Method
	
	Method _updateMouseOver()
		Super._updateMouseOver()
		If state_pressedDown And state_mouseOver = False
			onButtonReleased()
		EndIf
	End Method
	
	Rem
		bbdoc:Processes this object and all of its children. Make sure your call self.active = true before processing!
	End Rem
	Method process()
		If Self.active = False Return
		Super.process()
	End Method
	
	
	Method onButtonClicked()
		Local e:TEvent = CreateEvent:TEvent(EVENT_BUTTONCLICKED, Self)
		e.data = data
		e.extra = extra
		e.Emit()
	End Method
	
	Method onButtonPressed()
		state_pressedDown = True
		Local e:TEvent = CreateEvent:TEvent(EVENT_BUTTONPRESSED, Self)
		e.data = data
		e.extra = extra
		e.Emit()
	End Method
	
	Method onButtonReleased()
		state_pressedDown = False
		Local e:TEvent = CreateEvent:TEvent(EVENT_BUTTONRELEASED, Self)
		e.data = data
		e.extra = extra
		e.Emit()
	End Method
	
	rem
		bbdoc: The mousecursor enters this objects surface
	end rem
	Method onMouseOver()
		Local e:TEvent = CreateEvent:TEvent(EVENT_MOUSEOVER, Self)
		e.data = data
		e.extra = extra
		e.Emit()
	End Method
	
	rem
		bbdoc: The mousecursor left this object's surface
	end rem
	Method onMouseLeft()
		Local e:TEvent = CreateEvent:TEvent(EVENT_MOUSELEFT, Self)
		e.data = data
		e.extra = extra
		e.Emit()
	End Method
End Type
