'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type ViewGameMap Extends TView
	Const FIRSTBUILDTIME:Int = 60000
	Const BUILDTIME:Int = 60000
	Const MOUSESCROLLBORDER:Float = 10
	Const MOUSESCROLLSPEED:Float = 1.0
	
	Field levelid:String'needed for highscore entry
	Field levelfile:String
	
	Field mousepos:Float[2]
	
	Field gui:TGuiObject
	Field infobox:TGuiTextBox
	Field finalMessageCreated:Byte 'win or loose notification created
	Field nextWaveButton:TGuiImageButton
	
	Field shutdown:Byte = False
	Field fadeeffect:TViewFadeEffect
	
	Field tilemap:TTileMap
	
	Field buildTowerId:Int
	
	Field currentWave:TWave
	Field nextWave:TWave
	
	Field nextWaveCounter:Double
	Field pause:Byte
	
	Field gameplaystate:Int
	Const GAMEPLAYSTATE_BUILDING:Int = 0
	Const GAMEPLAYSTATE_SPAWNING:Int = 1
	Const GAMEPLAYSTATE_GAMEOVER:Int = 2
	Const GAMEPLAYSTATE_FINISHED:Int = 3

	
	Rem
		bbdoc:Fill this with content, no super-call needed
	End Rem
	Method onStart()
		gui = New TGuiDummyBox
		
		Local menue:TGuiImage = New TGuiImage
		menue.setName("Window")
		menue.image = LoadImage("res/guileiste.png")
		menue.color = $ff88AAFF
		menue.SetPosition(-0.5, TProgramSettings.GFX_HEIGHT - 100, 0, 0)
		gui.add(menue)
		
		nextWaveButton = New TGuiImageButton
		nextWaveButton.setName("NextWave")
		nextWaveButton.image = LoadImage("res/nextWave.png")
		nextWaveButton.SetPosition(0, 70, 0.5, 0)
		nextWaveButton.midhandle()
		gui.add(nextWaveButton)
		
		
		
		For Local i:Int = 0 Until TTowerType.TOWERCOUNT
			Local button:TGuiImageButton = New TGuiImageButton
			button.setName("BuildTower")
			button.setData(i)
			button.image = LoadImage("res/buttonT" + i + ".png")
			button.SetPosition(30 + (i Mod 7) * 45, 28 + Floor(i / 7) * 45, 0, 0)
			button.midhandle()
			menue.add(button)
		Next
		
		infobox = New TGuiTextbox
		infobox.width = 400
		infobox.height = 91
		infobox.drawrectbox = False
		infobox.rectboxcolor = $88000000
		infobox.setPosition(-2.5, -2.5, 1, 1)
		infobox.SetHandle(0, 0, 1, 1)
		menue.add(infobox)
		
		fadeeffect = TViewFadeEffect.Create(TViewFadeEffect.FADEDIR_IN, 500)
		tilemap = TTileMap.Create(levelfile)
		
		nextWave = TWave.peekNextWave()
		nextWaveCounter = FIRSTBUILDTIME
	End Method
	
	Rem
		bbdoc:This method is called when a Event occurs and this view is the current active view
	End Rem
	Method onEvent:Object(id:Int, event:TEvent, context:Object)
		Select event.id
			Case EVENT_KEYDOWN
				If event.data = KEY_ESCAPE And shutdown = False
					If gameplaystate = GAMEPLAYSTATE_GAMEOVER Or gameplaystate = GAMEPLAYSTATE_FINISHED
						leaveThisView()
					ElseIf gameplaystate <> GAMEPLAYSTATE_GAMEOVER And gameplaystate <> GAMEPLAYSTATE_FINISHED
						gameplaystate = GAMEPLAYSTATE_GAMEOVER
					EndIf
				EndIf
			Case TGuiObject.EVENT_BUTTONPRESSED
				Local pressed:TGuiObject = TGuiObject(event.source)
				Select pressed.name
					Case "BuildTower"
						buildTowerId = event.data
					Case "continue"
						leaveThisView()
					Case "NextWave"
						nextWaveCounter = -1
				End Select
				
			Case TGuiObject.EVENT_BUTTONRELEASED
			Case TGuiObject.EVENT_BUTTONCLICKED
			Case TGuiObject.EVENT_MOUSEOVER
				Local button:TGUIAbstractButton = TGUIAbstractButton(event.source)
				If button
					Select button.name
						Case "BuildTower"
							Local towerType:TTowerType = TTowerType.getInfo(button.data)
							infobox.textcolor = $ff88eeff
							infobox.setVisible(True)
							infobox.Settext(towerType.name + " Cost:" + towerType.cost + "~n" + towerType.description + "~n" + towerType.damage)
					End Select
				EndIf
		End Select
		'pass the event over to the gui
		Return gui.onEvent(id, event, context)
	End Method
	
	
	Method leaveThisView()
		Self.shutdown = True
		fadeeffect = TViewFadeEffect.Create(TViewFadeEffect.FADEDIR_OUT, 500)
		gui.setActive(False)
	End Method

	
	
	Rem
		bbdoc:Fill this with content, no super-call needed. run method is called again and again until this view gets closed
	End Rem
	Method onProcess(dt:Double)
		Local l:Int, r:Int
		Local mx:Float = MouseX(), my:Float = MouseY()
		
		Self.tilemap.getLRforXY(mx, my, l, r)
		
		If MouseHit(MOUSE_LEFT)
			Local result:Int = tilemap.addTower(buildTowerId, l, r)
			If result < 0
				Select result
					Case - 1
						infobox.textcolor = $ff880000
						infobox.Settext("~nCONSTRUCTION FAILED:~nyou can only build towers on maze-fields during the building phase (between enemy waves)")
					Case - 2
						infobox.textcolor = $ff880000
						infobox.Settext("~nCONSTRUCTION FAILED:~nthere is already a tower on that field. Destroy that one first (rightclick, get 75% of cost back)")
					Case - 3
						infobox.textcolor = $ff880000
						infobox.Settext("~nCONSTRUCTION FAILED:~nbuilding a tower on that field is not permitted")
					Case - 4 'insufficent money
						infobox.textcolor = $ff880000
						infobox.Settext("~nCONSTRUCTION FAILED:~ninsufficent money to build this tower")
					Case - 5
						infobox.textcolor = $ff880000
						infobox.Settext("~nCONSTRUCTION FAILED:~nsorry, you may maze, but you mustn't block the enemie's path totally.")
				End Select
			End If
		ElseIf MouseHit(MOUSE_RIGHT)
			tilemap.removeTower(l, r, True)
		End If
		
		If mx < MOUSESCROLLBORDER tilemap.offset_x:+dt * (1.0 - (mx / MOUSESCROLLBORDER)) * MOUSESCROLLSPEED
		If mx > TProgramSettings.GFX_WIDTH - MOUSESCROLLBORDER tilemap.offset_x:-dt * (1.0 - (TProgramSettings.GFX_WIDTH - mx) / MOUSESCROLLBORDER) * MOUSESCROLLSPEED
		If my < MOUSESCROLLBORDER tilemap.offset_y:+dt * (1.0 - (my / MOUSESCROLLBORDER)) * MOUSESCROLLSPEED
		If my > TProgramSettings.GFX_HEIGHT - MOUSESCROLLBORDER tilemap.offset_y:-dt * (1.0 - (TProgramSettings.GFX_HEIGHT - my) / MOUSESCROLLBORDER) * MOUSESCROLLSPEED

	
		If KeyDown(KEY_UP) Or KeyDown(KEY_W) tilemap.offset_y:+dt
		If KeyDown(KEY_DOWN) Or KeyDown(KEY_S) tilemap.offset_y:-dt
		If KeyDown(KEY_LEFT) Or KeyDown(KEY_A) tilemap.offset_x:+dt
		If KeyDown(KEY_RIGHT) Or KeyDown(KEY_D) tilemap.offset_x:-dt
		If KeyHit(KEY_P) pause = Not pause
		If KeyDown(KEY_SPACE) dt:*10
		
		
		If Not pause processGameplay(dt)
		If Not pause tilemap.process(dt)

		'gui.SetPosition(0, 0, 0.5 + Sin(counter) / 4, 0.5 + Cos(counter) / 4)
		gui.process()
		If fadeeffect
			If fadeeffect.isFinished()
				fadeeffect = Null
				If shutdown TProgramManager.getInstance()._setCurrentView(New ViewLevelSelection)
			Else
				fadeeffect.process(dt)
			End If
		EndIf
	End Method
	

	
	Method processGameplay(dt:Double)
		Select gameplaystate
			Case GAMEPLAYSTATE_SPAWNING
				tilemap.BUILDINGALLOWED = False
				Local spawningFinished:Int = False
				If currentWave spawningFinished = currentWave.process(dt, tilemap)
				
				If tilemap.gameover
					gameplaystate = GAMEPLAYSTATE_GAMEOVER
				ElseIf spawningFinished And TEnemy.list.Count() = 0
					tilemap.credits:+currentWave.credits
					currentWave = Null
					If TWave.list.IsEmpty()
						gameplaystate = GAMEPLAYSTATE_FINISHED
					Else
						nextWave = TWave.peekNextWave()
						gameplaystate = GAMEPLAYSTATE_BUILDING
						nextWaveButton.setActive(True)
						nextWaveButton.setVisible(True)
					EndIf
				EndIf
			Case GAMEPLAYSTATE_BUILDING
				tilemap.BUILDINGALLOWED = True
				nextWaveCounter:-dt
			
				If nextWaveCounter <= 0
					nextWave = Null
					currentWave = TWave.getNextWave()
					gameplaystate = GAMEPLAYSTATE_SPAWNING
					nextWaveCounter = BUILDTIME
					nextWaveButton.setActive(False)
					nextWaveButton.setVisible(False)
				EndIf
			Case GAMEPLAYSTATE_GAMEOVER
				If Not finalMessageCreated onLoose()
				nextWaveButton.setActive(False)
				nextWaveButton.setVisible(False)
			Case GAMEPLAYSTATE_FINISHED
				If Not finalMessageCreated onWin()
				nextWaveButton.setActive(False)
				nextWaveButton.setVisible(False)
		End Select
	End Method
	
	Method onWin()
		finalMessageCreated = True
		Local tb:TGuiTextbox = New TGuiTextbox
		tb.setSize(200, 100)
		tb.SetPosition(0, 0, 0.5, 0.5)
		tb.SetHandle(0, 0, 0.5, 0.5)
		tb.textGravityHorizontal = 0.5 'center the text
		
		Local text:String
		
		If tilemap.leftThrough = 0
			tb.setSize(200, 120)
			text = "~n*PERFECT*"
		EndIf
		text:+"~nYou won this Map~n Final score: " + tilemap.points
		
		tb.Settext(text)
		tb.textcolor = $ffff8800
		tb.drawrectbox = True
		tb.rectboxcolor = $AA004488
		gui.add(tb)
		
		Local button:TGuiImageButton = New TGuiImageButton
		button.image = LoadImage("res/continue.png")
		button.setName("continue")
		button.SetPosition(0, -5, 0.5, 1)
		button.SetHandle(0, 0, 0.5, 1)
		tb.add(button)
		
		TProgressManager.Load()
		TLevelScore.Create(levelid, tilemap.points, TProgramSettings.PLAYERNAME)
		TProgressManager.save()
	End Method
	
	Method onLoose()
		finalMessageCreated = True
		Local tb:TGuiTextbox = New TGuiTextbox
		tb.setSize(200, 100)
		tb.SetPosition(0, 0, 0.5, 0.5)
		tb.SetHandle(0, 0, 0.5, 0.5)
		tb.textGravityHorizontal = 0.5 'center the text
		tb.Settext("~nGame Over~n Final score: " + tilemap.points)
		tb.textcolor = $ffee0000
		tb.drawrectbox = True
		tb.rectboxcolor = $AA884400
		gui.add(tb)
		
		Local button:TGuiImageButton = New TGuiImageButton
		button.image = LoadImage("res/continue2.png")
		button.setName("continue")
		button.SetPosition(0, -5, 0.5, 1)
		button.SetHandle(0, 0, 0.5, 1)
		tb.add(button)
	End Method


	Rem
		bbdoc:Fill this with content, no super-call needed. run method is called again and again until this view gets closed
	End Rem
	Method onDraw()
		tilemap.draw()
		gui.draw()
		SetBlend ALPHABLEND
		setIntColor($ffffffff)
		
		If nextWaveCounter > 0 And gameplaystate = GAMEPLAYSTATE_BUILDING
			Local s:String = "Next Wave in: " + Int(Ceil(nextWaveCounter / 1000)) + " Seconds!"
			setIntColor($88000000)
			DrawRect (TProgramSettings.GFX_WIDTH - TextWidth(s)) / 2 - 5, 15, TextWidth(s) + 10, TextHeight(s) + 10
			setIntColor($ffffff00)
			DrawText s, (TProgramSettings.GFX_WIDTH - TextWidth(s)) / 2, 20
		ElseIf currentWave
			Local s:String = currentWave.displayname
			setIntColor($88000000)
			DrawRect (TProgramSettings.GFX_WIDTH - TextWidth(s)) / 2 - 5, 15, TextWidth(s) + 10, TextHeight(s) + 10
			setIntColor($ffffff00)
			DrawText s, (TProgramSettings.GFX_WIDTH - TextWidth(s)) / 2, 20
		End If
		
		Local rectwidth:Int = 150 'tmp var for the size of the rectbox under the score and next wave text
		
		SetBlend ALPHABLEND
		setIntColor($ffffffff)
		
		Local i:Float = 1
		
		SetColor 128, 0, 0
		SetAlpha 0.2
		DrawRect 0, i * 20 - 2, rectwidth, 20
		SetAlpha 1
		DrawText "Kills:" + tilemap.kills, 10, i * 20; i:+1
		SetColor 128, 128, 128
		If tilemap.leftThroughTolleranceAbsolute >= 0
			SetAlpha 0.2
			DrawRect 0, i * 20 - 2, rectwidth, 20
			SetAlpha 1
			DrawText "LeftThrough:" + tilemap.leftThrough + "/" + tilemap.leftThroughTolleranceAbsolute, 10, i * 20; i:+1
		EndIf
		If tilemap.leftThroughTolleranceRelative >= 0
			Local value:Float = (tilemap.leftThrough / Float(tilemap.totalSpawnedEnemies))
			If tilemap.totalSpawnedEnemies = 0 value = 0
			SetAlpha 0.2
			DrawRect 0, i * 20 - 2, rectwidth, 20
			SetAlpha 1
			DrawText "LeftThroughRate:" + Int(ceil(10000 * value)) + "/" + int(Ceil(10000 * tilemap.leftThroughTolleranceRelative)), 10, i * 20; i:+1
		EndIf
		SetColor 255, 128, 0
		SetAlpha 0.2
		DrawRect 0, i * 20 - 2, rectwidth, 20
		SetAlpha 1
		DrawText "Credits: " + tilemap.credits, 10, i * 20; i:+1
		SetColor 128, 128, 255
		SetAlpha 0.2
		DrawRect 0, i * 20 - 2, rectwidth, 20
		SetAlpha 1
		DrawText "Points: " + tilemap.points, 10, i * 20; i:+1
		SetColor 255, 255, 255
		

		
		If nextWave
			i:+1
			
			setIntColor($88002da9)
			DrawRect 0, (i - 1) * 20 - 2, rectwidth, ((nextWave.spawner.Count() + 3) * 20 + 4)
			
			setIntColor($ff888888)
			DrawText "Next Wave:", 75 - TextWidth("Next Wave:") * 0.5, i * 20; i:+1
			setIntColor($ffffffff)
			DrawText "<" + nextWave.displayname + ">", 75 - TextWidth("<" + nextWave.displayname + ">") * 0.5, i * 20; i:+1
			For Local s:TSpawner = EachIn nextWave.spawner
				Local et:TEnemyTemplate = s.enemy
				
				If calcColorDistance(et.color, $000000) < 0.1
					setIntColor($22ffffff)
				Else
					setIntColor($88000000)
				EndIf
				
				Local text:String = s.amount + " x " + et.name
				Local x:Int = 75 - TextWidth(text) * 0.5
				
				DrawText text, x - 1, i * 20 - 1;
				DrawText text, x + 1, i * 20 + 1;
				DrawText text, x + 1, i * 20 - 1;
				DrawText text, x - 1, i * 20 + 1;
				
				setIntColor(et.color)
				DrawText text, x, i * 20; i:+1

			Next
		End If
		
		If fadeeffect fadeeffect.draw()
	End Method
	
	Rem
		bbdoc:Fill this with content, no super-call needed
	End Rem
	method onDestroy()
		tilemap.remove()
		tilemap = Null
	End Method

End Type
