'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type T2DAstar
	Field sizeX:Int, sizeY:Int
	Field StartX:Int, StartY:Int, TargetX:Int, TargetY:Int
	Field cost:Float[,] 'negative = not passable, positive = expensive
	Field nodes:T2DAStarNode[,]
	
	Field openList:TList
	Field closedList:TList
	
	Method init(sizeX:Int, sizeY:Int)
		Self.sizeX = sizeX
		Self.sizeY = sizeY
		nodes = New T2DAStarNode[sizeX, sizeY]
	End Method
	
	Method setCost(cost:Float[,])
		Self.cost = cost
	End Method

	Method search:TList(StartX:Int, StartY:Int, TargetX:Int, TargetY:Int)
		Self.StartX = StartX
		Self.StartY = StartY
		Self.TargetX = TargetX
		Self.TargetY = TargetY
		
		_reset()
		
		Local node:T2DAStarNode
		addOpenNode(StartX, StartY, Null)
		Repeat
			node = T2DAStarNode(openList.RemoveFirst())
			If node = Null Return Null 'no path was found
			
			'add succ
			addOpenNode(node.x - 1, node.y, node)
			addOpenNode(node.x + 1, node.y, node)
			addOpenNode(node.x, node.y - 1, node)
			addOpenNode(node.x, node.y + 1, node)
			
			node.f = cost[node.x, node.y]
			If node.pre node.f:+node.pre.f
			
			closedList.AddLast(node)
			
			If node.x = TargetX And node.y = TargetY
				Local resultList:TList = New TList
				While node
					resultList.AddLast([node.x, node.y])
					node = node.pre
				WEnd
				Return resultList
			EndIf
		Forever
	End Method
	
	Method addOpenNode(x:Int, y:Int, pre:T2DAStarNode)
		If x < 0 Return
		If y < 0 Return
		If x >= sizeX Return
		If y >= sizeY Return
		If nodes[x, y] Return
		If cost[x, y] < 0 Return
		
		Local newNode:T2DAStarNode = New T2DAStarNode
		newNode.x = x
		newNode.y = y
		newNode.pre = pre
		newNode.f = (x - TargetX) * (x - TargetX) + (y - TargetY) * (y - TargetY) + cost[x, y]
		If pre newNode.f:+pre.f
		nodes[x, y] = newNode
		
		
		'Insert into openList
		Local link:TLink = openList.FirstLink()
		
		Local test:T2DAStarNode
		

		
		While link And T2DAStarNode(link._value).f < newNode.f
			link = link.nextLink()
		Wend
		
		If link = Null
			openList.AddLast(newNode)
		Else
			openList.InsertBeforeLink(newNode, link)
		EndIf
	End Method
	
	
	Method _reset()
		For Local x:Int = 0 Until Self.sizeX
			For Local y:Int = 0 Until Self.sizeY
				nodes[x, y] = Null
			Next
		Next
		openList = New TList
		closedList = New TList
	End Method
End Type


Type T2DAStarNode
	Field x:Int, y:Int, f:Double
	Field pre:T2DAStarNode
End Type
