'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TEnemy Extends TTileMapDrawObject
	Global list:TList = New TList
	Const HPBARLENGHT:Int = 20
	Const HPBARHEIGHT:Int = 2
	
	Const EFFECTCOUNT:Int = 3
	Const EFFECT_FREEZE:Int = 0
	Const EFFECT_POISON:Int = 1
	Const EFFECT_VULNERABLE:Int = 2
	
	Field link:TLink
	Field image:TImage
	Field speed:Double
	Field way:Object[]
	
	Field hp:Double
	Field maxhp:Double
	Field color:Int
	Field credits:Int
	Field effectDuration:double[EFFECTCOUNT]
	Field effectAmount:Double[EFFECTCOUNT]
	Field enemyTemplate:TEnemyTemplate
	
	Field l:Float, r:Float
	Field centerX:Float, centerY:Float 'offset for effects
	Field progress:Double
	Field isDead:Byte = False
	
	Function ProcessAll(dt:Double, map:TTileMap)
		For Local e:TEnemy = EachIn list
			e.process(dt, map)
		Next
	End Function
	
	Function removeAll()
		For Local e:TEnemy = EachIn list
			e.remove()
		Next
		list.Clear()
	End Function
	
	Method New()
		Self.link = list.AddLast(Self)
	End Method

	Method receiveDamage(amount:Double, color:Int)
		Local distance:Double = calcColorDistance(Self.color, color)
		If effectDuration[EFFECT_VULNERABLE] amount:*(1 + effectAmount[EFFECT_VULNERABLE])
		Self.hp:-amount * distance
		If Self.hp <= 0 isDead = True
	End Method
	
	Method receiveEffect(amount:Double, duration:Double, color:Int, effectId:Int)
		Select effectId
			Case EFFECT_FREEZE
				effectAmount[EFFECT_FREEZE]:+amount * calcColorDistance(Self.color, color)
				effectDuration[EFFECT_FREEZE]:+duration
			Case EFFECT_POISON
				Local totalDmg:Float = amount * duration + effectAmount[EFFECT_POISON] * effectDuration[EFFECT_POISON]
				effectDuration[EFFECT_POISON]:+duration
				effectAmount[EFFECT_POISON] = totalDmg / effectDuration[EFFECT_POISON]
			Case EFFECT_VULNERABLE
				amount:*calcColorDistance(Self.color, color)
				Local totalDmg:Float = amount * duration + effectAmount[EFFECT_VULNERABLE] * effectDuration[EFFECT_VULNERABLE]
				effectDuration[EFFECT_VULNERABLE]:+duration
				effectAmount[EFFECT_VULNERABLE] = totalDmg / effectDuration[EFFECT_VULNERABLE]
		End Select
	End Method
	

	
	Method draw(map:TTileMap)
		centerX = x + map.TILE_W * 0.5
		centerY = y + map.TILE_H * 0.5
		Local midX:Float = centerX + map.offset_x
		Local midY:Float = centerY + map.offset_y
	
		applyIntColor(color)
		SetBlend ALPHABLEND
		SetAlpha 1
		DrawImage image, midX, midY
		
		If effectDuration[EFFECT_POISON]
			SetColor 0, 255, 0
			SetAlpha 0.5
			SetBlend LIGHTBLEND
			SetScale 1.2, 1.2
			DrawImage image, midX, midY
			SetScale 1, 1
			SetAlpha 1
			SetBlend ALPHABLEND
		End If
		
		If effectDuration[EFFECT_VULNERABLE]
			SetColor 128, 0, 255
			SetAlpha 0.5
			SetBlend LIGHTBLEND
			SetScale 1.2, 1.2
			DrawImage image, midX, midY
			SetScale 1, 1
			SetAlpha 1
			SetBlend ALPHABLEND
		End If
		
		If effectDuration[EFFECT_FREEZE]
			SetColor 0, 128, 255
			SetAlpha 0.5
			SetBlend LIGHTBLEND
			SetScale 1.2, 1.2
			DrawImage image, midX, midY
			SetScale 1, 1
			SetAlpha 1
			SetBlend ALPHABLEND
		End If
		
		
		Local hpbarOffsetX:Int = (-HPBARLENGHT) * 0.5 + midX
		Local hpbarOffsetY:Int = midy - image.height * 0.5 - 2 * HPBARHEIGHT
		Local scale:Float = hp / maxhp
		If scale < 0 scale = 0
		
		
		SetColor 255, 0, 0
		DrawRect hpbarOffsetX + HPBARLENGHT * scale, hpbarOffsetY, HPBARLENGHT * (1 - scale), HPBARHEIGHT
		
		SetColor 0, 255, 0
		DrawRect hpbarOffsetX, hpbarOffsetY, HPBARLENGHT * scale, HPBARHEIGHT
		
		SetColor 255, 255, 255
	End Method
	
	Method process(dt:Double, map:TTileMap)
		For Local i:Int = 0 Until effectDuration.Length
			effectDuration[i]:-dt
			If effectDuration[i] < 0
				effectDuration[i] = 0
				effectAmount[i] = 0
			EndIf
		Next
		
		Local dProgress:Double = dt * speed
		If effectDuration[EFFECT_FREEZE]
			dProgress:*1 / (1.0 + Log(1 + effectAmount[EFFECT_FREEZE]))
		EndIf
		
		progress:+dProgress
		
		If Ceil(progress) >= way.Length
			map.leftThrough:+1
			remove()
			Return
		End If
		
		If effectDuration[EFFECT_POISON]
			Self.receiveDamage(effectAmount[EFFECT_POISON] * dt / 1000.0, $00ff00)
		EndIf
		
		If hp <= 0
			map.kills:+1
			map.points:+credits
			map.credits:+credits
			TParticleExplosionEmitter.Create(enemyTemplate.explosionImage, enemyTemplate.explosionColorGradient, centerX, centerY, 0.04, 500, 1500, ALPHABLEND)
			
			remove()
			Return
		End If
		
		Local lastPos:Int[] = Int[] (way[Floor(progress)])
		Local nextPos:Int[] = Int[] (way[Ceil(progress)])
		Local tmpProgress:Double = progress Mod 1
		
		l = lastPos[0] + (nextPos[0] - lastPos[0]) * tmpProgress
		r = lastPos[1] + (nextPos[1] - lastPos[1]) * tmpProgress
		
		map.collision[l, r].AddLast(Self)
	End Method
	
	Method remove()
		isDead = True
		RemoveLink Self.link
	End Method
End Type
