'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc: like a bullet but affected by gravity and without straight target
End Rem
Type TGravityBomb Extends TShootEffect
	Field image:TImage
	Field x:Double, y:Double
	Field tx:Double, ty:Double
	Field speed:Double, acc:Double
	Field progress:Double
	Field dir:Double
	Field totaldistance:Double
	Field impactEffect:TParticleEmitter
	Field areaEffectDamage:TAreaDamageEffect
	Field inited:Byte = False
	
	Method process(dt:Double, map:TTileMap)
		Local dx:Double = tx - x
		Local dy:Double = ty - y
		Local dist:Double = Sqr(dx * dx + dy * dy)
		
		If Not inited
			totaldistance = dist
			inited = True
		End If
		progress = 1.0 - (dist / totaldistance)
		
		'normieren
		dx:/dist
		dy:/dist
		
		speed:+acc*dt
		
		dx:*dt * speed
		dy:*dt * speed

		
		dir = ATan2(dx, -dy)
		
		'check for arrival
		If (dist * dist < dx * dx + dy * dy) 'arrived
			explode(map)
		Else
			x:+dx
			y:+dy
		EndIf
	End Method
	
	Method explode(map:TTileMap)
		If areaEffectDamage
			Local l:Int, r:Int
			areaEffectDamage.r = map.getLRforXYNoOffset(x, y, l, r)
			areaEffectDamage.l = l
			areaEffectDamage.r = r
			areaEffectDamage.go()
		End If
		
		If impactEffect
			impactEffect.x = x
			impactEffect.y = y
			impactEffect.go()
		End If
		remove()
	End Method
	
	Method draw(offset_x:Double, offset_y:Double)
		SetRotation dir
		SetColor 255, 255, 255
		DrawImage image, x + offset_x, y + offset_y - Sin(progress * 180) * totaldistance
	End Method
	
	Method remove()
		image = Null
		impactEffect = Null
		areaEffectDamage = Null
		Super.remove()
	End Method

End Type
