'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:just for rendering poison shots
End Rem
Type TPoisonEffect Extends TShootEffect
	Field image:TImage
	Field target:TEnemy
	
	Field x:Double, y:Double
	Field totalduration:Double
	
	
	'will be refreshed every process if target is still alive
	Field tx:Double, ty:Double
	Field duration:Double
	
	Function Create:TPoisonEffect(x0:Double, y0:Double, target:TEnemy, image:TImage, duration:Double)
		Local le:TPoisonEffect = New TPoisonEffect
		le.x = x0
		le.y = y0
		le.target = target
		le.tx = target.centerX
		le.ty = target.centerY
		le.totalduration = duration
		le.duration = duration
		le.image = image		
		Return le
	End Function
	

	Method process(dt:Double, map:TTileMap)
		duration:-dt
		If duration < 0 remove()
		If target = Null Return
		If Not target.isDead
			tx = target.centerX
			ty = target.centerY
		EndIf
	End Method
	
	
	Method draw(offset_x:Double, offset_y:Double)
		SetColor 255, 255, 255
		SetAlpha Sin((duration / totalduration) * 180)
		SetBlend LIGHTBLEND
		drawSpecialImageLine(image, x + offset_x, y + offset_y, tx + offset_x, ty + offset_y)
		SetBlend ALPHABLEND
		SetAlpha 1
	End Method
	
	Method drawSpecialImageLine(image:TImage, x0:Double, y0:Double, x1:Double, y1:Double)
		Local dx:Double = x1 - x0
		Local dy:Double = y1 - y0
		Local dist:Double = Sqr(dx * dx + dy * dy) * 2'closer together
		dx:/dist
		dy:/dist
		SetRotation(dist)
		For Local i:Int = image.height Until dist
			DrawImage image, x0 + i * dx, y0 + i * dy
			i:+image.height - 1
		Next
		SetRotation 0
	End Method
	
	Method remove()
		image = Null
		target = Null
		Super.remove()
	End Method
End Type
