﻿'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
	
	
	'ToDO:
	Enemies & Waves
	Basis-Tower
	Schüsse und Effekte
	Punktesystem
	
End Rem
Type TTileMap
	Const TILE_W:Int = 64
	Const TILE_H:Int = 32

	Field RSIZE:Int
	Field LSIZE:Int

	Field offset_x:Float
	Field offset_y:Float
	
	Field minOffset_x:Float, maxOffset_x:Float
	Field minOffset_y:Float, maxOffset_y:Float
	
	'Image Ressources
	Field baseTiles:TImage[7]
	Field towerimage:TImage[1]
	Field way:TImage
	
	
	'Draw Layer
	Field base:Int[LSIZE, RSIZE] 'Ground Tile (like Gras etc. just for the look)
	Field towerObject:TTower[LSIZE, RSIZE] 'static building or enviroment image (Towers, Obstacles, Way, also just for the look)
	
	'Data Layers
	Field pathfindingCost:Float[LSIZE, RSIZE] 'travel-cost, -1 if not passable, should be generated based on map status
	
	Field fieldoptions:Int[LSIZE, RSIZE]'constant base map settings
	Const FIELDOPTION_ISPASSABLE:Int = 1
	Const FIELDOPTION_ALLOWBUILD:Int = 2
	
	Field BUILDINGALLOWED:Int 'set to true by ViewGameMap
	
	Field path:Object[] 'path out of ints
	Field collision:TList[LSIZE, RSIZE]
	Field enemies:TList = New TList
	
	'Stats
	Field points:Int
	Field kills:Int
	Field leftThrough:Int
	Field totalSpawnedEnemies:Int
	Field credits:Int
	
	Field leftThroughTolleranceAbsolute:Int = 10 '-1 = dont care, all other values are absolute counts
	Field leftThroughTolleranceRelative:Float = -1 '-1 = dont care, all other values are leftThrough/totalSpawnedEnemies
	
	Field gameover:Byte = False
	
	
	Method remove()
		TPath.reset()
		TEnemyTemplate.reset()
		TEnemy.removeAll()
		TWave.reset()
		TAreaDamageEffect.reset()
		TTower.reset()
	End Method
	
	Function Create:TTilemap(file:Object)
		Local t:TTileMap = New TTileMap
		t.loadLevel(file)
		t.checkPath()
		Return t
	End Function

	
	Method New()
	
		Local l:Int, r:Int
		
		baseTiles[0] = LoadImage("res/waytile.png")'pfad
		baseTiles[1] = LoadImage("res/wayslottile.png") 'slot & pfad
		baseTiles[2] = LoadImage("res/slottile.png") 'slot
		
		baseTiles[3] = LoadImage("res/grund1.png")
		baseTiles[4] = LoadImage("res/grund2.png")
		baseTiles[5] = LoadImage("res/grund3.png")
		baseTiles[6] = LoadImage("res/grund4.png")
		
		
		TParticleEmitter.init()
		TTower.reset()
		TTowerType.init()
		TTower.LoadTowers()
		
		TPath.reset()
		TEnemyTemplate.reset()
		TWave.reset()
		TShootEffect.reset()
	End Method
	
	rem
		bbdoc: returns 1 if everything was ok. Otherwise:
		-1 if buildingallowed = false
		-2 if there is already a tower on that field
	end rem
	Method addTower:Int(id:Int, l:Int, r:Int)
		If Not BUILDINGALLOWED And (fieldoptions[l, r] & FIELDOPTION_ISPASSABLE) Return - 1
		If towerObject[l, r] Return - 2
		Return setTower(id, l, r)
	End Method
	
	rem
		bbdoc: returns 1 if everything was ok. Otherwise:
		-3 if it isn't allowed to build on this field
		-4 if there is not enaugh money to build this tower
		-5 if the building would block a path
	end rem
	Method setTower:Int(id:Int, l:Int, r:Int)
		If (fieldoptions[l, r] & FIELDOPTION_ALLOWBUILD = False) Return - 3
		removeTower(l, r)
		
		Local towerType:TTowerType = TTowerType.getInfo(id)
		
		If towerType.cost > credits
			Return - 4
		End If
		
		Local tower:TTower = TTowerType.CreateTower(id)
		tower.l = l
		tower.r = r
		towerObject[l, r] = tower
		
		getXYforLRNoOffset(tower.l, tower.r, tower.x, tower.y)
		
		'check if checkPath() is still true
		If checkPath() = False
			'undo building tower
			removeTower(l, r)
			Return - 5
		End If
		credits:-towerType.cost
		Return True
	End Method
	
	Method removeTower(l:Int, r:Int, creditsback:Byte = False)
		If towerObject[l, r]
			if creditsback credits:+towerObject[l,r].cost*0.75
			towerObject[l, r].remove()
			towerObject[l, r] = Null
		End If
	End Method
	
	Method setMapSize(RSIZE:Int, LSIZE:Int)
		Local l:Int, r:Int
		Self.RSIZE = RSIZE
		Self.LSIZE = LSIZE
		base = New Int[LSIZE, RSIZE]
		collision = New TList[LSIZE, RSIZE]
		towerObject = New TTower[LSIZE, RSIZE]
		For L = 0 Until LSIZE
			For r = 0 Until RSIZE
				collision[l, r] = New TList
			Next
		Next
		fieldoptions = New Int[LSIZE, RSIZE]
		pathfindingCost = New Float[LSIZE, RSIZE]
		
		offset_x = 0
		offset_y = 0

		
		Local GUI_BAR_HEIGHT:Int = 50
		Local BORDER_W:Int = 100 'So it scrolls a litte further than just to the most left / right pixel of the map
		Local BORDER_H:Int = 100
		
		minOffset_x = -TILE_W * RSIZE * 0.5 + TProgramSettings.GFX_WIDTH * 0.5 - BORDER_W
		maxOffset_x = TILE_W * LSIZE * 0.5 - TProgramSettings.GFX_WIDTH * 0.5 + BORDER_W
		minOffset_y = -TILE_H * Max(RSIZE, LSIZE) + TProgramSettings.GFX_HEIGHT * 0.5 - GUI_BAR_HEIGHT - BORDER_H
		maxOffset_y = TILE_H * 0.5 - TProgramSettings.GFX_HEIGHT * 0.5 + BORDER_H
		
		'set offset into the middle:
		offset_x = (maxOffset_x + minOffset_x) * 0.5
		offset_y = (maxOffset_y + minOffset_y) * 0.5
	End Method
	
	'loads a level-xml file into this map
	Method loadLevel(url:Object)
		Local stream:TStream = ReadFile(url)
		Assert stream <> Null, "TTileMap.loadLevel() url=" + String(url) + " doesn't exist"
		Local xmlNode:TXMLNode = TXMLReader.ReadXML(stream)
		CloseStream stream
		
		xmlNode = TXMLNode(xmlNode.children.First())
		If xmlNode.name = "level"
			Local mappath:String = xmlNode.getValue("map")
			loadMapFromPng(mappath)
			Self.credits = Int(xmlNode.getValue("startcredits"))
			Local text:String = xmlNode.getValue("leftthroughtoleranceabsolute")
			If text = "" leftThroughTolleranceAbsolute = -1;Else leftThroughTolleranceAbsolute = Int(text) ;
			text:String = xmlNode.getValue("leftthroughtolerancerelative")
			If text = "" leftThroughTolleranceRelative = -1;Else leftThroughTolleranceRelative = Float(text) ;
		EndIf
		
		loadLevelContent(xmlNode)
		
		Assert checkPath(), "TTileMap.loadLevel(" + String(url) + ") paths are wrong: Cannot find path from start to finish"
	End Method
	
	Method loadLevelContent(xmlNode:TXMLNode)
		For Local node:TXMLNode = EachIn xmlNode.children
			Select node.name
				Case "path"
					TPath.Create(node.getValue("name"), Int(node.getValue("startx")), Int(node.getValue("starty")), Int(node.getValue("endx")), Int(node.getValue("endy")))
				Case "enemy"
					TEnemyTemplate.Create(node.getValue("name"), node.getValue("image"), Int(node.getValue("color")), Int(node.getValue("credits")), Double(node.getValue("hp")), Double(node.getValue("speed")))
				Case "wave"
					Local wave:TWave = TWave.Create(node.getValue("displayname"), Int(node.getValue("credits")))
					
					For Local node2:TXMLNode = EachIn node.children
						If node2.name = "spawn"
							wave.addSpawner(TSpawner.Create(node2.getValue("enemy"), node2.getValue("path"), Int(node2.getValue("amount")), Double(node2.getValue("startms")), Int(node2.getValue("msbetween"))))
						End If
					Next
				Case "include"
					Local stream:TStream = ReadFile(node.getValue("path"))
					Assert stream <> Null, "TTileMap.loadLevelContent() url=" + node.getValue("path") + " doesn't exist"
					Local node2:TXMLNode = TXMLReader.ReadXML(stream)
					CloseStream stream
					loadLevelContent(node2)
			End Select
		Next
	End Method
	
	Method loadMapFromPng(url:Object)
		Local l:Int, r:Int, color:Int
		Local pixmap:TPixmap
	
		pixmap = LoadPixmapPNG:TPixmap(url)
		setMapSize(pixmap.width, pixmap.height)
		
		For l = 0 Until LSIZE
			For r = 0 Until RSIZE
				color = pixmap.ReadPixel(r, l)
				
				
				'Make the color selection more robust:
				'closest color:
				Local best:Int = 0
				Local val:Double = 0
				Local bestVal:Double = 1'max distance, 
				
				val = calcColorDistance(color, $ffffffff)
				If bestVal > val best = $ffffffff; bestVal = val
				
				val = calcColorDistance(color, $ff007f00)
				If bestVal > val best = $ff007f00; bestVal = val
				
				val = calcColorDistance(color, $ff7F7F7F)
				If bestVal > val best = $ff7F7F7F; bestVal = val
				
				val = calcColorDistance(color, $00000000)
				If bestVal > val best = $00000000; bestVal = val
				
				color = best

				
				'select the tile function by the choosen color:
				Select color
					Case $ffffffff 'weiß, 255,255,255
						base[l, r] = 0'Path, just for the looks
						fieldoptions[l, r] = FIELDOPTION_ISPASSABLE
					Case $ff007f00 'grün, 0,127,0
						base[l, r] = 2'Building place, just for the looks
						fieldoptions[l, r] = FIELDOPTION_ALLOWBUILD
					Case $ff7F7F7F 'grau, 128,128,128
						base[l, r] = 1'Path & Bulding Place (maze area), just for the looks
						fieldoptions[l, r] = FIELDOPTION_ISPASSABLE | FIELDOPTION_ALLOWBUILD
					Default
						base[l, r] = Rand(3, 6)'No building, no path area , just for the looks
						fieldoptions[l, r] = 0
				End Select
			Next
		Next
	End Method
	
	'checks if enemy still can reach the target.
	Method checkPath:Int()
		Return TPath.checkPaths(Self)
	End Method
	
	Method updatePathfindingCost()
		Local l:Int, r:Int
		For L = 0 Until LSIZE
			For r = 0 Until RSIZE
				If (fieldoptions[L, R] & FIELDOPTION_ISPASSABLE)
					If towerObject[L, R]
						pathfindingCost[L, R] = - 1
					Else
						pathfindingCost[L, R] = 1
					End If
				Else
					pathfindingCost[L, R] = - 1
				EndIf
			Next
		Next
	End Method
	
	Method getLRforXY(x:Float, y:Float, L:Int Var, R:Int Var)
		x = x - TProgramSettings.GFX_WIDTH * 0.5 - offset_x
		y = y - TProgramSettings.GFX_HEIGHT * 0.5 - offset_y
		

		l = 0.5 + y / TILE_H - x / TILE_W
		R = 0.5 + y / TILE_H + x / TILE_W
		
		If L < 0 L = 0
		If R < 0 R = 0
		If L >= LSIZE L = -1 + LSIZE
		If r >= RSIZE r = -1 + RSIZE
	End Method
	
	Method getXYforLR(L:Float, R:Float, x:Float Var, y:Float Var)
		x = ((R - L - 1) * TILE_W + TProgramSettings.GFX_WIDTH) * 0.5 + offset_x
		y = ((R + L - 1) * TILE_H + TProgramSettings.GFX_HEIGHT) * 0.5 + offset_y
	End Method
	
	Method getLRforXYNoOffset(x:Float, y:Float, L:Int Var, R:Int Var)
		x = x - TProgramSettings.GFX_WIDTH * 0.5
		y = y - TProgramSettings.GFX_HEIGHT * 0.5
		

		l = 0.5 + y / TILE_H - x / TILE_W
		R = 0.5 + y / TILE_H + x / TILE_W
		
		If L < 0 L = 0
		If R < 0 R = 0
		If L >= LSIZE L = -1 + LSIZE
		If r >= RSIZE r = -1 + RSIZE
	End Method
	
	Method getXYforLRNoOffset(L:Float, R:Float, x:Float Var, y:Float Var)
		x = ((R - L - 1) * TILE_W + TProgramSettings.GFX_WIDTH) * 0.5
		y = ((r + l - 1) * TILE_H + TProgramSettings.GFX_HEIGHT) * 0.5
	End Method
	
	Method CheckGameOver:Int()
		If gameover Return gameover
		If leftThroughTolleranceAbsolute >= 0 And leftThrough >= leftThroughTolleranceAbsolute gameover = True
		If leftThroughTolleranceRelative >= 0 And (leftThrough / Float(totalSpawnedEnemies)) >= leftThroughTolleranceRelative gameover = True
		Return gameover
	End Method
	
	Method process(dt:Double)
		
		Local l:Int, r:Int
		'Clear Collision List (will be filled in Enemy.process()
		For l = 0 Until LSIZE
			For r = 0 Until RSIZE
				If collision[l, r]
					collision[l, r].Clear()
				EndIf
			Next
		Next
	
		TEnemy.processAll(dt, Self)
		TTower.ProcessAll(dt, Self)
		TShootEffect.processAll(dt, Self)
		TAreaDamageEffect.processAll(dt, Self)
		TParticleEmitter.processAll(dt)
		
		If offset_x < minOffset_x offset_x = minOffset_x
		If offset_x > maxOffset_x offset_x = maxOffset_x
		If offset_y < minOffset_y offset_y = minOffset_y
		If offset_y > maxOffset_y offset_y = maxOffset_y
		CheckGameOver()
	End Method

	Method draw()
		Local x:Int, y:Int
		Local objectDrawList:TList = New TList
		Local ml:Int, mr:Int
		Local minRow:Int, maxRow:Int, minR:Int, maxR:Int
		Local row:Int, R:Int, L:Int
		
		setIntColor($FFFFFFFF)
		SetBlend ALPHABLEND
		
		getLRforXY(MouseX(), MouseY(), ml, mr)
		
		minRow:Int = 1 + (-offset_y * 2 - TProgramSettings.GFX_HEIGHT) / TILE_H - 1
		maxRow:Int = 1 + ((TProgramSettings.GFX_HEIGHT - offset_y) * 2 - TProgramSettings.GFX_HEIGHT) / TILE_H + 1

		'von L + R = minimum bis maximum
		For row:Int = minRow Until maxRow
			minR:Int = 0.5 * (row + 1 + (-offset_x * 2 - TProgramSettings.GFX_WIDTH) / TILE_W)
			minR = Min(Max(minR, 0), RSIZE - 1)
			maxR:Int = 0.5 * (row + 1 + ((TProgramSettings.GFX_WIDTH - offset_x) * 2 - TProgramSettings.GFX_WIDTH) / TILE_W)
			maxR = Min(Max(maxR, 0), RSIZE - 1)
			
			'Von R = minimum bis R maximum
			For R:Int = minR To maxR
				L:Int = row - R
				
				If L < 0 Continue
				If L > LSIZE-1 Continue
				
				x = ((R - L - 1) * TILE_W + TProgramSettings.GFX_WIDTH) * 0.5 + offset_x
				y = ((R + L - 1) * TILE_H + TProgramSettings.GFX_HEIGHT) * 0.5 + offset_y
				
				If R = mr And L = ml
					SetColor 128, 128, 128
					DrawImage baseTiles[base[l, r]], x, y
					SetColor 255, 255, 255
				Else
					DrawImage baseTiles[base[l, r]], x, y
				EndIf
			Next
		Next
		
		For Local e:TEnemy = EachIn TEnemy.list
			getXYforLRNoOffset(e.L, e.R, e.x, e.y)
			objectDrawList.AddLast(e)
		Next
		
		For Local t:TTower = EachIn TTower.list
			getXYforLRNoOffset(t.L, t.R, t.x, t.y)
			objectDrawList.AddLast(t)
		Next
		
		For Local e:TAreaDamageEffect = EachIn TAreaDamageEffect.list
			getXYforLRNoOffset(e.L, e.R, e.x, e.y)
			objectDrawList.AddLast(e)
		Next
		
		objectDrawList.Sort(True, TTileMapDrawObject.CompareFunction)
		

		For Local do:TTileMapDrawObject = EachIn objectDrawList
			do.draw(Self)
		Next
		
		TShootEffect.drawAll(offset_x, offset_y)
		TParticleEmitter.drawAll(offset_x, offset_y)
		
		
		SetColor 255, 255, 255
		SetAlpha 1
		SetBlend ALPHABLEND
		SetRotation 0
	End Method
End Type