'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TCarrierTower Extends TTower
	Field color:Int = $ffffffff
	
	Global image:TImage
	Global fighterimage:TImage
	Global fighterlaser:TImage
	
	Field fighersCapacity:Int = 3
	Field fighters:TList = New TList
	Field _init:Byte = True


	Method process(dt:Double, map:TTileMap)
		If _init'just to jump the first process call
			_init = False
			Return
		EndIf
		
		If fighters.Count() < fighersCapacity
			spawnFighter()
		End If
	End Method
	
	Method spawnFighter()
		Local f:TFighter = New TFighter
		f.x = Self.x + 32
		f.y = Self.y - 16
		f.clock = Rand(3600)
		
		'select a color
		f.color = getSaturatedColor(Rnd(0, 6))
		f.speed = 0.15
		f.tower = Self
		f.image = fighterimage
		f._towerLink = fighters.AddLast(f)
	End Method
	

	
	Method draw(map:TTileMap)
		setIntColor(color)
		DrawImage image, x + map.offset_x, y + map.offset_y
	End Method
	
	Method remove()
		For Local f:TFighter = EachIn fighters
			f.remove()
		Next
		Super.remove()
	End Method
End Type



Type TFighter Extends TShootEffect
	Field x:Double, y:Double, dir:Double
	Field tower:TCarrierTower
	Field _towerLink:TLink
	Field image:TImage
	Field clock:Double
	Field speed:Double
	
	Field damage:Double = 30
	Field color:Int = $ffffffff'random
	
	Field loadTime:Double = 1000
	Field nextShot:Double
	Field drawShot:Int
	
	Field state:Int
	
	Field target:TEnemy
	
	Method process(dt:Double, map:TTileMap)
		clock:+dt
		drawShot:-dt
		
		Select state
			Case 0 'flying around tower
				flyTo(dt, tower.x + 32 + Sin(clock * 0.1) * map.TILE_W * 2, tower.y - 16 + Cos(clock * 0.1) * map.TILE_H * 2)
				If (clock Mod 1000) > 500 state = 1
			Case 1 'looking for target
				flyTo(dt, tower.x + 32 + Sin(clock * 0.1) * map.TILE_W * 2, tower.y - 16 + Cos(clock * 0.1) * map.TILE_H * 2)
				Local list:TList = tower.getTargetsInRange(8, map)
				
				Local bestEnemy:TEnemy, e:TEnemy
			
				For e:TEnemy = EachIn list
					If Not e.isDead
						Local swap:Byte = False
						
						If bestEnemy = Null
							swap = True
						Else
							If e.hp / calcColorDistance(Self.color, e.color) < bestEnemy.hp / calcColorDistance(Self.color, bestEnemy.color)
								swap = True
							End If
						EndIf
						If swap
							bestEnemy = e
						End If
					EndIf
				Next
				
				target = bestEnemy
				
				
				
				If target And Not target.isDead
					state = 2
				Else
					target = Null
					state = 0
				End If
			Case 2 'follow and attack target
				If target.isDead
					target = Null
					state = 0
					drawShot = -1
				Else
					flyTo(dt, target.centerX + Sin(clock * 0.1) * map.TILE_W * 4, target.centerY + Cos(clock * 0.05) * map.TILE_H * 2)
					nextShot:-dt
					If nextShot < 0 And distance(x, y, target.centerX, target.centerY) < 100
						drawShot = loadTime * 0.25
						target.receiveDamage(damage, color)
						nextShot = loadTime
					End If
				EndIf
			Case 3
		End Select
	End Method
	
	Method flyTo(dt:Double, tx:Double, ty:Double)
		Local dx:Double = tx - x
		Local dy:Double = ty - y
		Local dist:Double = Sqr(dx * dx + dy * dy)
		'normieren
		dx:/dist
		dy:/dist
		
		dx:*dt * speed
		dy:*dt * speed
		

		dir = ATan2(dx, -dy)
		
		'check for arrival
		If (dist * dist < dx * dx + dy * dy) 'arrived
			x = tx
			y = ty
		Else
			x:+dx
			y:+dy
		EndIf
	End Method
	
	
	Method draw(offset_x:Double, offset_y:Double)
		If drawShot And target
			setIntColor(color)
			SetAlpha drawShot / (loadTime * 0.25)
			Local sx:Double = x + offset_x
			Local sy:Double = y + offset_y
			Local tx:Double = target.centerX + offset_x
			Local ty:Double = target.centerY + offset_y
			SetScale 1, 1
			DrawImageLine(tower.fighterlaser, sx, sy, tx, ty)
			SetScale 0.9, 0.9
			SetColor 255, 255, 255
			DrawImageLine(tower.fighterlaser, sx, sy, tx, ty)
			SetScale 1, 1
		EndIf
	
		SetAlpha 1
		SetRotation dir
		setIntColor(color)
		DrawImage image, x + offset_x, y + offset_y
	End Method
	
	Method remove()
		tower = Null
		_towerLink = Null
		image = Null
		Super.remove()
	End Method
End Type