'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc: Base Tower type
End Rem
Type TTower Extends TTileMapDrawObject Abstract
	Global list:TList = New TList
	
	Function reset()
		For Local t:TTower = EachIn list
			t.remove()
		Next
		list.Clear()
	End Function
	
	Function LoadTowers()
		TBasicTower.image = LoadImage("res/tower0.png")
		TBasicTower.image.handle_y = 32
		TBasicTower.bulletimage = LoadImage("res/bullet.png")
		MidHandleImage(TBasicTower.bulletimage)
		
		TFreezeTower.image = LoadImage("res/tower1.png")
		TFreezeTower.image.handle_y = 32
		TFreezeTower.laserimage = LoadImage("res/frostlaser.png")
		TFreezeTower.laserimage.handle_x = TFreezeTower.laserimage.width * 0.5
		
		TPoisonTower.image = LoadImage("res/tower2.png")
		TPoisonTower.image.handle_y = 32
		TPoisonTower.laserimage = LoadImage("res/poison.png")
		MidHandleImage(TPoisonTower.laserimage)
		
		TSplashTower.image = LoadImage("res/tower3.png")
		TSplashTower.image.handle_y = 32
		TSplashTower.explosionImage = LoadImage("res/expl1.png")
		MidHandleImage(TSplashTower.explosionImage)
		TSplashTower.explosionColorGradient = TParticleEmitter.LoadColorGradient("res/explosionFarbverlauf.png")
		TSplashTower.bulletimage = LoadImage("res/firebomb.png")
		MidHandleImage(TSplashTower.bulletimage)
		
		
		TWeakenTower.image = LoadImage("res/tower4.png")
		TWeakenTower.image.handle_y = 32
		
		TFocusTower.image = LoadImage("res/tower5.png")
		TFocusTower.image.handle_y = 32
		TFocusTower.laserimage = LoadImage("res/laser.png")
		TFocusTower.laserimage.handle_x = TFocusTower.laserimage.width * 0.5
		
		TMagneticTower.image = LoadImage("res/tower0.png")
		TMagneticTower.image.handle_y = 32
		TMagneticTower.laserimage = LoadImage("res/magnetic.png")
		MidHandleImage(TMagneticTower.laserimage)
		
		TCarrierTower.image = LoadImage("res/tower7.png")
		TCarrierTower.image.handle_y = 32
		TCarrierTower.fighterimage = LoadImage("res/fighter.png")
		MidHandleImage(TCarrierTower.fighterimage)
		TCarrierTower.fighterlaser = LoadImage("res/fighterlaser.png")
		TCarrierTower.fighterlaser.handle_x = TCarrierTower.fighterlaser.width * 0.5
		
		TChameleonTower.image = LoadImage("res/tower8Bottom.png")
		TChameleonTower.image.handle_y = 32
		TChameleonTower.imageTop = LoadImage("res/tower8Top.png")
		TChameleonTower.imageTop.handle_y = 32
		TChameleonTower.laserimage = LoadImage("res/chameleonlaser.png")
		TChameleonTower.laserimage.handle_x = TFreezeTower.laserimage.width * 0.5
		
		TVulcanTower.image = LoadImage("res/tower9.png")
		TVulcanTower.image.handle_y = 32
		TVulcanTower.explosionImage = LoadImage("res/expl1.png")
		MidHandleImage(TVulcanTower.explosionImage)
		TVulcanTower.explosionColorGradient = TParticleEmitter.LoadColorGradient("res/explosionFarbverlauf.png")
		TVulcanTower.bulletimage = LoadImage("res/lava.png")
		MidHandleImage(TVulcanTower.bulletimage)
		
		TBlackHoleTower.image0 = LoadImage("res/tower10a.png")
		TBlackHoleTower.image0.handle_y = 32
		TBlackHoleTower.image1 = LoadImage("res/tower10b.png")
		TBlackHoleTower.image1.handle_y = 32
		TBlackHoleTower.image2 = LoadImage("res/tower10c.png")
		TBlackHoleTower.image2.handle_y = 32
		
		TBlackHoleTower.laserimage = LoadImage("res/blacklaser.png")
		TBlackHoleTower.laserimage.handle_x = TBlackHoleTower.laserimage.width * 0.5
		

	End Function
	
	Function ProcessAll(dt:Double, map:TTileMap)
		For Local t:TTower = EachIn list
			t.process(dt, map)
		Next
	End Function
	
	Field cost:Int'set by TTowerType
	Field link:TLink
	Field l:Float, r:Float
	
	Method New()
		link = list.AddLast(Self)
	End Method
	
	
	Method remove()
		RemoveLink link
		link = Null
	End Method

	Method process(dt:Double, map:TTileMap) Abstract
	


	'Some general helper functions
	Method getTargetsInRange:TList(range:Float, map:TTileMap)
		Local targetList:TList = New TList
		For Local il:Int = Self.l - range Until Self.l + range
			For Local ir:Int = Self.r - range Until Self.r + range
				If il < 0 Or il >= map.LSIZE Continue
				If ir < 0 Or ir >= map.RSIZE Continue
				Local range2:Float = range * range
				If (il - l) * (il - l) + (ir - r) * (ir - r) < range2
					If Not map.collision[il, ir].isEmpty()
						For Local e:TEnemy = EachIn map.collision[il, ir]
							If (e.l - l) * (e.l - l) + (e.r - r) * (e.r - r) < range2 And Not e.isDead targetList.addlast(e)
						Next
					EndIf
				EndIf
			Next
		Next
		Return targetList
	End Method
	
	Method getRandomTargetInRange:TEnemy(range:Float, map:TTileMap)
		Local list:TList = getTargetsInRange(range, map)
		If list.IsEmpty() Return Null
		Return TEnemy(list.ValueAtIndex(Rand(0, list.Count() - 1)))
	End Method
	
End Type
