'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:The most Basic Tower. Everything at this tower is basic ;)
End Rem
Type TWeakenTower Extends TTower
	Field nextShot:Double
	Field range:Int = 4
	Field damage:Int = 2
	Field color:Int = $ff8822ff
	
	Field loadTime:Float = 1000
	
	Field drawShot:Int
	Field lastShotTarget:Float[2]
	Field lastShotTargetE:TEnemy
	
	Global image:TImage

	Method process(dt:Double, map:TTileMap)
		nextShot:-dt
		If nextShot < 0
			Local targets:TList = getTargetsInRange(range, map)
			Local bestEnemy:TEnemy, e:TEnemy
			
			For e:TEnemy = EachIn targets
				If Not e.isDead
					Local swap:Byte = False
					
					If bestEnemy = Null
						swap = True
					Else
						If e.effectAmount[TEnemy.EFFECT_VULNERABLE] / (1 + calcColorDistance(Self.color, e.color)) < bestEnemy.effectAmount[TEnemy.EFFECT_VULNERABLE] / (1 + calcColorDistance(Self.color, bestEnemy.color))
							swap = True
						End If
					EndIf
					If swap
						bestEnemy = e
					End If
				EndIf
			Next
			
			e = bestEnemy
			
			
			If e
				e.receiveDamage(damage, color)
				e.receiveEffect(4, 10000, color, TEnemy.EFFECT_VULNERABLE)
				nextShot:+loadTime
				drawShot = 15
				lastShotTarget[0] = e.x + e.centerX - map.offset_x
				lastShotTarget[1] = e.y + e.centerY - map.offset_y
				lastShotTargetE = e
			Else
				nextShot = 0
			EndIf
		EndIf
		
		If lastShotTargetE
			lastShotTarget[0] = lastShotTargetE.centerX
			lastShotTarget[1] = lastShotTargetE.centerY
			If lastShotTargetE.isDead lastShotTargetE = Null
		EndIf
	End Method
	

	
	Method draw(map:TTileMap)
		setIntColor(color)
		DrawImage image, x + map.offset_x, y + map.offset_y
		
		If drawShot
			drawShot:-1

			Local startX:Float = x + 32
			Local startY:Float = y - 16
			
			Local diffX:Float = lastShotTarget[0] - startX
			Local diffY:Float = lastShotTarget[1] - startY
			
			startX:+map.offset_x
			startY:+map.offset_y
			
			Local dist:Double = Sqr(diffX * diffX + diffY * diffY)
			SetColor 50, 255, 50
			'SetAlpha drawShot / 50.0
			
			Local STEPS:Int = 10
			
			Local fade:Float = drawShot / 15.0
			
			SetBlend LIGHTBLEND
			For Local d:Double = 0 Until dist Step 10
				Local x0:Float = startX + diffX * d / dist + Sin(drawShot + d * 360 / dist) * 5
				Local y0:Float = startY + diffY * d / dist + Cos(drawShot + d * 360 / dist) * 5
				Local x1:Float = startX + diffX * (d + STEPS) / dist + Sin(drawShot + (d + STEPS) * 360 / dist) * 5
				Local y1:Float = startY + diffY * (d + STEPS) / dist + Cos(drawShot + (d + STEPS) * 360 / dist) * 5
				
				applyIntColor(color)
				SetAlpha 0.5 * fade
				DrawLine x0 + 1, y0, x1 + 1, y1
				DrawLine x0 - 1, y0, x1 - 1, y1
				DrawLine x0, y0 + 1, x1, y1 + 1
				DrawLine x0, y0 - 1, x1, y1 - 1
				SetAlpha fade
				SetColor 255, 255, 255
				DrawLine x0, y0, x1, y1
				
			Next
			SetBlend ALPHABLEND
			SetAlpha 1
		EndIf
		SetColor 255, 255, 255
	End Method
End Type
