Type TBullet
  Global list:TList = New TList
  Const size% = 10
  Method New()
    Self.list.addLast Self
  End Method
  Field tower:TTower, x#, y#, vX#, vY#, ttl%, sense:TEnemy, dir#
  Field dead% = False
  Function Create:TBullet(tower:TTower, tX%, tY%, x%, y%, sense:TEnemy = Null)
    Local result:TBullet = New TBullet
    result.tower = tower
    result.x = tX
    result.y = tY
    Local dist# = Sqr((tX-x)^2+(tY-y)^2)
    result.vX = (x-tX)/dist*tower.getBulletSpeed()
    result.vY = (y-tY)/dist*tower.getBulletSpeed()
    result.ttl = tower.getRange()/tower.getBulletSpeed()
    result.sense = sense
    result.dir = ATan2(ty-y, tx-x)
    Return result
  End Function
  Method update()
    Self.ttl :- 1
    If Self.ttl <= 0 Then
      Self.destroy
      Return
    EndIf
    Self.x :+ Self.vX
    Self.y :+ Self.vY
    If Self.sense Then
      If Self.sense.dead Then
        Self.sense = Null
      ElseIf Self.checkEnemy(Self.sense) Then
        Return
      EndIf
    EndIf
    For Local enemy:TEnemy = EachIn TEnemy.list
      If Self.checkEnemy(enemy) Then Exit
    Next
  End Method
  Method draw()
    Self.tower.kind.drawBullet Self
  End Method
  Function drawAll()
    For Local bullet:TBullet = EachIn Self.list
      bullet.draw
    Next
  End Function
  Function updateAll()
    For Local bullet:TBullet = EachIn Self.list
      bullet.update
    Next
  End Function
  Method checkEnemy%(enemy:TEnemy)
    If Self.dead Then RuntimeError "cannot hit twice"
    If Self.x+Self.size >= enemy.x-enemy.kind.size/2 And..
         Self.y+Self.size >= enemy.y-enemy.kind.size/2 And..
         Self.x-Self.size <= enemy.x+enemy.kind.size/2 And..
         Self.y-Self.size <= enemy.y+enemy.kind.size/2 Then
      enemy.checkHit Self.tower.getPower()
      Self.tower.checkDetonate Self.x, Self.y
      Self.dead = True
      Self.destroy
      Return True
    EndIf
  End Method
  Method destroy()
    Self.list.remove Self
  End Method
End Type
