Type TDetonation
  Global list:TList = New TList
  Method New()
    Self.list.addLast Self
  End Method
  Const EXTEND_SPEED% = 5
  Field x%, y%, radius# = 0.0, maxRadius%, power%
  Function Create:TDetonation(x%, y%, maxRadius%, power%)
    Local result:TDetonation = New TDetonation
    result.x = x
    result.y = y
    result.maxRadius = maxRadius
    result.power = power
    Return result
  End Function
  Method update()
    Self.radius :+ Self.EXTEND_SPEED
    Self.checkCollisions
    If Self.radius > Self.maxRadius Then Self.destroy
  End Method
  Method checkCollisions()
    Local cmp# = Self.radius*Self.radius
    For Local enemy:TEnemy = EachIn TEnemy.list
      Local dist2# = (enemy.x-Self.x)^2+(enemy.y-Self.y)^2
      If dist2 < cmp Then
        enemy.checkHit Self.power
      EndIf
    Next
  End Method
  Method draw()
    SetBlend LIGHTBLEND
    If Self.radius < Self.maxRadius/2 Then
      For Local i%=1 To Self.radius
        SetColor 50, 50, 50-50*i/Self.radius
        DrawOval Self.x-i, Self.y-i, i*2, i*2
      Next
    Else
      For Local i%=1 To Self.radius
        If i < Self.maxRadius/2 Then
          SetColor 50, 50, 50-50*i/(Self.maxRadius/2)
        Else
          SetColor 50, 50-50*(i-Self.maxRadius/2)/(Self.maxRadius/2), 0
        EndIf
        DrawOval Self.x-i, Self.y-i, i*2, i*2
      Next
    EndIf
    SetBlend ALPHABLEND
  End Method
  Function updateAll()
    For Local detonation:TDetonation = EachIn Self.list
      detonation.update
    Next
  End Function

  Function drawAll()
    For Local detonation:TDetonation = EachIn Self.list
      detonation.draw
    Next
  End Function

  Method destroy()
    Self.list.remove Self
  End Method
End Type







