Function drawEditorGame()
  setGameDraw
  Cls
  If bg Then
    SetBlend SOLIDBLEND
    SetColor 255, 255, 255
    DrawImage bg, 0, 0
    SetBlend ALPHABLEND
  EndIf
  SetColor 0, 255, 0
  For Local i%=1 Until wayPoints.Count()
    Local p1:TWayPoint = TWayPoint(wayPoints.valueAtIndex(i-1))
    Local p2:TWayPoint = TWayPoint(wayPoints.valueAtIndex(i  ))
    DrawLine p1.x, p1.y, p2.x, p2.y
  Next
  If editorMarkedWP >= 0 Then
    Local point:TWayPoint = TWayPoint(wayPoints.valueAtIndex(editorMarkedWP))
    DrawOval point.x-2, point.y-2, 5, 5
  EndIf
  If Not wayPoints.isEmpty() Then
    SetColor 0, 128, 0
    Local p1:TWayPoint = TWayPoint(wayPoints.Last())
    Repeat
      Local p2:TWayPoint = p1.previous
      If Not p2 Then Exit
      DrawLine p1.x, p1.y, p2.x, p2.y
      p1 = p2
    Forever
  EndIf

  SetColor 255, 0, 0
  SetAlpha .5
  For Local x%=0 Until TILESET_WIDTH
    For Local y%=0 Until TILESET_HEIGHT
      If buildLock[x][y] Then
        DrawRect x*TILE_SIZE, y*TILE_SIZE, TILE_SIZE, TILE_SIZE
      EndIf
    Next
  Next
  SetAlpha 1
  Plot 100, 590
  Flip
End Function
Function drawEditorMenu1()
  setMenu1Draw
  Cls
  DrawText "background-", 0, 0
  DrawText "image"      , 0, 16
  DrawText "waypoints"  , 0, 30
  DrawText "build-locks", 0, 60
  DrawText "save"       , 0, 100
  Flip
End Function
Global editorAction% = -1
Const EDITOR_BGIMAGE%    = 0
Const EDITOR_WAYPOINTS%  = 1
Const EDITOR_BUILDLOCKS% = 2
Const EDITOR_SAVE%       = 3
Global editorMarkedWP% = -1
Global editorWPaction% = -1
Global editorLastBL%[] = [-1, -1]
Const WP_INSERT_FIRST% = 0
Const WP_INSERT_AFTER% = 1
Const WP_MOVE%         = 2
Function drawEditorMenu2()
  setMenu2Draw
  Cls
  SetColor 255, 255, 255
  Select editorAction
   Case EDITOR_BGIMAGE
    DrawText "[choose image]", 0, 0
   Case EDITOR_WAYPOINTS
    DrawText "Insert first", 0, 0
    DrawText "Insert after selected", 0, 20
    DrawText "Move selected", 400, 0
    DrawText "Delete selected", 400, 20
   Case EDITOR_BUILDLOCKS
    DrawText "[click to change lock]", 0, 0
   Case EDITOR_SAVE
    DrawText "[file saved]", 0, 0
  End Select
  Flip
End Function

Function checkEditorAction%()
  Select CurrentEvent.id
   Case EVENT_APPTERMINATE
    End
   Case EVENT_KEYDOWN
    Select CurrentEvent.data
     Case KEY_ESCAPE
      End
     Case KEY_LEFT
      If Not wayPoints.isEmpty() Then
        editorMarkedWP :- 1
        If editorMarkedWP < 0 Then editorMarkedWP = wayPoints.Count()-1
      EndIf
     Case KEY_RIGHT
      If Not wayPoints.isEmpty() Then
        editorMarkedWP :+ 1
        If editorMarkedWP > wayPoints.Count()-1 Then editorMarkedWP = 0
      EndIf
    End Select
   Case EVENT_MOUSEDOWN
    If CurrentEvent.x <= MENU1_WIDTH Then  'menu1-action
      If CurrentEvent.y < 25 Then
        editorAction = EDITOR_BGIMAGE
        Local filename$ = RequestFile("Select background-image", "Image Files:png,jpg,bmp", False, AppDir)
        If filename Then
          bgFileName = filename
          bg = LoadImage(filename)
          SetImageHandle bg, 0, 0
        EndIf
      ElseIf CurrentEvent.y < 55 Then
        editorAction = EDITOR_WAYPOINTS
      ElseIf CurrentEvent.y < 75 Then
        editorAction = EDITOR_BUILDLOCKS
        editorLastBL = [-1, -1]
      ElseIf CurrentEvent.y > 95 And CurrentEvent.y < 120 Then
        Local filename$ = RequestFile("Save file destination", "", True, AppDir+"/levels")
        If filename Then
          Local stream:TStream = WriteFile(filename)
          saveMap stream
          CloseFile stream
        EndIf
      EndIf
      Return 1
    ElseIf CurrentEvent.y >= sy-Menu2_HEIGHT Then     'menu2-action
      Select editorAction
       Case EDITOR_WAYPOINTS
        If CurrentEvent.x < 390+MENU1_WIDTH Then
          If CurrentEvent.y < 20+sy-Menu2_HEIGHT Then
            editorWPAction = WP_INSERT_FIRST
          Else
            editorWPAction = WP_INSERT_AFTER
          EndIf
        Else
          If CurrentEvent.y < 20+sy-Menu2_HEIGHT Then
            editorWPAction = WP_MOVE
          Else
            If editorMarkedWP >= 0 Then
              wayPoints.remove wayPoints.valueAtIndex(editorMarkedWP)
              If Not wayPoints.isEmpty() Then
                If editorMarkedWP = 0 Then
                  TWayPoint(wayPoints.First()).previous = Null
                ElseIf editorMarkedWP < wayPoints.Count()-2
                  TWayPoint(wayPoints.valueAtIndex(editorMarkedWP)).previous = ..
                                             TWayPoint(wayPoints.valueAtIndex(editorMarkedWP-1))
                EndIf
              EndIf
              editorMarkedWP = -1
              Return 1
            EndIf
          EndIf
        EndIf
      End Select
    Else          'gamefield-action
      Select editorAction
       Case EDITOR_WAYPOINTS
        Select editorWPAction
         Case WP_INSERT_FIRST
          Local point:TWayPoint = New TWayPoint
          point.x = CurrentEvent.x-MENU1_WIDTH
          point.y = CurrentEvent.y

          If Not wayPoints.isEmpty() Then
            TWayPoint(wayPoints.First()).previous = point
            TWayPoint(wayPoints.First()).calcFields
          EndIf
          wayPoints.addFirst point
         Case WP_INSERT_AFTER
          If editormarkedWP >= 0 Then
            If editorMarkedWP = wayPoints.Count()-1 Then
              TWayPoint.Create(CurrentEvent.x-MENU1_WIDTH, CurrentEvent.y)
            Else
              Local before:TWayPoint = TWayPoint(wayPoints.valueAtIndex(editorMarkedWP  ))
              Local after:TWayPoint  = TWayPoint(wayPoints.valueAtIndex(editorMarkedWP+1))
              Local point:TWayPoint = New TWayPoint
              point.x = CurrentEvent.x-MENU1_WIDTH
              point.y = CurrentEvent.y
              point.previous = before
              after.previous = point
              wayPoints.insertBeforeLink point, wayPoints.findLink(after)
            EndIf
          EndIf
         Case WP_MOVE
          If editormarkedWP >= 0 Then
            Local point:TWayPoint = TWayPoint(wayPoints.valueAtIndex(editorMarkedWP))
            point.x = CurrentEvent.x-MENU1_WIDTH
            point.y = CurrentEvent.y
          EndIf
        End Select
      End Select
    EndIf
   Case EVENT_MOUSEMOVE
    If editorAction = EDITOR_BUILDLOCKS And MouseDown(MOUSE_LEFT) And CurrentEvent.x > MENU1_WIDTH And..
                CurrentEvent.y < sy-MENU2_HEIGHT Then
      Local x% = (CurrentEvent.x-MENU1_WIDTH)/TILE_SIZE
      Local y% = (CurrentEvent.y            )/TILE_SIZE
      If (x <> editorLastBL[0] Or y <> editorLastBL[1]) And..
                          x >= 0 And x < TILESET_WIDTH And y >= 0 And y < TILESET_HEIGHT Then
        buildLock[x][y] = Not buildLock[x][y]
        editorLastBL[0] = x
        editorLastBL[1] = y
      EndIf
    EndIf
    Return 1
  End Select
  Return 0
End Function
Function showEditor()
  drawEditorMenu1
  drawEditorMenu2
  drawEditorGame
  Repeat
    WaitEvent
    If checkEditorAction() Then drawEditorMenu2
    If CurrentEvent.id = EVENT_MOUSEMOVE Then
      mx = CurrentEvent.x
      my = CurrentEvent.y
      drawEditorMenu1
    EndIf
    drawEditorGame
  Forever
End Function