Global introTower:TTowerKind = New TTowerKind
introTower.range = 400
introTower.reloadTime = 10
introTower.maxCapacity = 0
introTower.shootCapacity = 0
introTower.bulletSpeed = 1
introTower.price = -1
introTower.power = 1
introTower.image = Null

TTowerKind.list.remove introTower

Function drawIntroTower(tower:TTower)
  SetColor 0, 0, 0
  DrawOval tower.x*TILE_SIZE, tower.y*TILE_SIZE, TILE_SIZE, TILE_SIZE
End Function

Function drawIntroBullet(bullet:TBullet)
  SetColor 0, 0, 0
  DrawOval bullet.x-5, bullet.y-5, 10, 10
End Function

introTower.draw       = drawIntroTower
introTower.drawBullet = drawIntroBullet

Global introEnemy:TEnemyKind = New TEnemyKind
introEnemy.speed = .3
introEnemy.health = 20
introEnemy.size = 40
introEnemy.image = LoadImage(IMG_DIR+"introEnemy.png")

TEnemyKind.list.remove introEnemy

Function drawIntroEnemy(enemy:TEnemy)
  SetColor 0, 0, 0
  SetRotation enemy.getDir()
  DrawImage introEnemy.image, enemy.x, enemy.y
  SetRotation 0
End Function

introEnemy.draw = drawIntroEnemy



Const INTRO_STR$ = "infraTD", INTRO_ZOOM# = 3
Function showIntro()
  unsetViewPort
  SetClsColor 0, 0, 0
  timer = CreateTimer(60)
  Local radius% = 0
  Local x% = sx/2-TextWidth(INTRO_STR)/2*INTRO_ZOOM, y% = sy/2-TextHeight(INTRO_STR)/2*INTRO_ZOOM
  getIntroWay
  Local towers:TList = New TList
  Repeat
    WaitEvent
    Select CurrentEvent.id
     Case EVENT_MOUSEMOVE
      mx = CurrentEvent.x
      my = CurrentEvent.y
     Case EVENT_TIMERTICK
      Cls
      SetColor 20, 20, 20
      DrawOval mx-50, my-50, 100, 100
      SetColor 0, 0, 0
      SetScale INTRO_ZOOM, INTRO_ZOOM
      DrawText INTRO_STR, x, y
      SetScale 1, 1
      DrawText "[Press any key to exit]", 0, 0
      For Local tower:TTower = EachIn towers
        tower.draw
      Next
      TBullet.drawAll
      TEnemy.drawAll
      Flip
      radius :+ 1
      If Rand(0, 1000) = 0 Then
        towers.addLast TTower.Create(Rand(0, sx/TILE_SIZE-1), Rand(0, sy/TILE_SIZE-1), introTower, 1)
      EndIf
      If Rand(0, 200) = 0 Then
        TEnemy.Create(introEnemy)
      EndIf
      TEnemy.updateAll
      For Local tower:TTower = EachIn towers
        tower.update
      Next
      TBullet.updateAll
     Case EVENT_KEYDOWN
      If CurrentEvent.data = 1 Then End
      Exit
     Case EVENT_APPTERMINATE
      End
    End Select
  Forever
  StopTimer timer
  timer = Null
  TEnemy.list.Clear
  wayPoints.Clear
  SetClsColor 128, 128, 128
End Function

Function getBorderPoint%[]()
  Local border% = Rand(1, 4)
  Local result%[2]
  Select border
   Case 1
    result[0] = 0
    result[1] = Rand(0, sy-1)
   Case 2
    result[0] = Rand(0, sx-1)
    result[1] = 0
   Case 3
    result[0] = sx-1
    result[1] = Rand(0, sy-1)
   Case 4
    result[0] = Rand(0, sx-1)
    result[1] = sy-1
  End Select
  Return result
End Function

Function getIntroWay()
  Local point%[] = getBorderPoint()
  Local dist%
  Local totalDist% = Rand(1000, 10000)
  Repeat
    TWayPoint.Create(point[0], point[1])
    Local p%[] = [Rand(0, sx-1), Rand(0, sy-1)]
    dist :+ Sqr((p[0]-point[0])^2+(p[1]-point[1])^2)
    point = p
  Until dist >= totalDist
  TWayPoint.Create(point[0], point[1])
  point = getBorderPoint()
  TWayPoint.Create(point[0], point[1])
End Function
