Function levelEditor()
  Local cmd$, argument$
  If Not currentLevel Then
    currentLevel = New TLevel
  EndIf
  levelEditorHelp
  Repeat
    Print ""
    Local response$ = Input()
    cmd = response
    argument = ""
    If Instr(cmd, " ") Then
      cmd = Left(cmd, Instr(cmd, " ")-1)
      argument = Right(response, Len(response)-Instr(response, " "))
    EndIf
    Select cmd
     Case "save"
      If BankSize(currentLevel.map) = 0 Then
        If currentLevel.waves.isEmpty() Then
          Print "need to set at least a wave and the map"
        Else
          Print "need to set a map"
        EndIf
      ElseIf currentLevel.waves.isEmpty()
        Print "need to set at least a wave"
      EndIf
      If BankSize(currentLevel.map) > 0 And Not currentLevel.waves.isEmpty() Then
        Local stream:TStream = WriteFile(argument)
        saveLevel stream, currentLevel
        CloseFile stream
        Print "level saved"
      EndIf
     Case "del"
      currentLevel = New TLevel
     Case "addWave"
      If FileType(argument) <> 1 Then
        Print "file '"+argument+"' not found"
      Else
        Local stream:TStream = ReadFile(argument)
        currentLevel.addWave loadWave(stream)
        CloseFile stream
        Print "wave loaded"
      EndIf
     Case "setMap"
      If FileType(argument) <> 1 Then
        Print "file '"+argument+"' not found"
      Else
        Local stream:TStream = ReadFile(argument)
        loadMap stream
        CloseFile stream
        currentLevel.readMap
        Print "map set"
      EndIf
     Case "stat"
      If BankSize(currentLevel.map) > 0 Then
        Print "a map has been set"
      Else
        Print "no map has been set"
      EndIf
      Print currentLevel.waves.Count()+" waves have been set"
     Case "esc"
      Return
     Case "help"
      levelEditorHelp
     Default
      Print "unknown command: "+cmd
      Print "enter 'help' to see the help"
    End Select
    Print ""
  Until cmd = "esc"
End Function
Function levelEditorHelp()
  Print "level editor"
  Print "enter 'save filename' to save the current level"
  Print "enter del to delete the level"
  Print "enter 'addWave filename' to add a wave"
  Print "enter 'setMap filename' to set the map"
  Print "enter 'stat' to see the level's status"
  Print "enter 'help' to see this help"
  Print ""
  Print "enter 'esc' to escape"
End Function
