Function checkPlayerAction%()
  updateTooltip
  If CurrentEvent.id <> EVENT_MOUSEDOWN Then
    If tooltip Then Return 1
    If CurrentEvent.x > MENU1_WIDTH-CURSOR_WIDTH And..
                     CurrentEvent.y > sy-MENU2_HEIGHT-CURSOR_HEIGHT Then
      Return 1
    EndIf
    Return 0
  EndIf
  If CurrentEvent.x <= MENU1_WIDTH Then
    playerUpgradeTower = Null
    playerChoosenTower = Null
    playerChoosenWire = Null
    If CurrentEvent.y < 15 Then
      playerAction = ACTION_TOWERS
      Return 1
    ElseIf CurrentEvent.y < 35 Then
      playerAction = ACTION_WIRES
      Return 1
    ElseIf CurrentEvent.y > 45 And CurrentEvent.y < 65 Then
      Return -1
    EndIf
    If CurrentEvent.x > MENU1_WIDTH-CURSOR_WIDTH And..
                                  CurrentEvent.y > sy-MENU2_HEIGHT-CURSOR_HEIGHT Then
      Return 1
    EndIf
    Return 0
  ElseIf CurrentEvent.y > sy-MENU2_HEIGHT Then
    Select playerAction
     Case ACTION_TOWERS
      Local col% = (mx-MENU1_WIDTH)/TILE_SIZE
      Local row% = (my-sy+MENU2_HEIGHT)/TILE_SIZE
      Local index% = row*(sx-MENU1_WIDTH)/TILE_SIZE+col
      If index >= 0 And index < TTowerKind.list.Count() Then
        playerChoosenTower = TTowerKind(TTowerKind.list.valueAtIndex(index))
      Else
        playerChoosenTower = Null
      EndIf
     Case ACTION_WIRES
      Local col% = (mx-MENU1_WIDTH)/TILE_SIZE
      Local row% = (my-sy+MENU2_HEIGHT)/TILE_SIZE
      Local index% = row*(sx-MENU1_WIDTH)/TILE_SIZE+col
      If index >= 0 And index < TWireKind.list.Count() Then
        playerChoosenWire = TWireKind(TWireKind.list.valueAtIndex(index))
      Else
        playerChoosenWire = Null
      EndIf
     Case ACTION_UPGRADE
      If playerUpgradeTower Then
        If CurrentEvent.x < MENU1_WIDTH + (sx-MENU1_WIDTH)/4 Then
          If CurrentEvent.y > sy-MENU2_HEIGHT+20 Then
            TTower.list.remove playerUpgradeTower
            money :+ playerUpgradeTower.getSellValue()
            playerUpgradeTower = Null
            Return 1
          EndIf
        Else
          Local col% = (CurrentEvent.x - MENU1_WIDTH - (sx-MENU1_WIDTH)/4) / ((sx-MENU1_WIDTH)/4)
          Local row% = (CurrentEvent.y-sy+MENU2_HEIGHT)/20
          Local index% = row*3+col
          Local state% = playerUpgradeTower.getState(index)
          If state < 5 And TTower.getPrice(state+1) <= money Then
            playerUpgradeTower.upgrade index
            money :- TTower.getPrice(state+1) 
            Return 1
          EndIf
        EndIf
      EndIf
    End Select
    Return 1
  Else
    Select playerAction
     Case ACTION_TOWERS
      If playerChoosenTower Then
        If playerChoosenTower.price <= money Then
          Local tower:TTower = TTower.Create((CurrentEvent.x-MENU1_WIDTH)/TILE_SIZE,..
                                               CurrentEvent.y/TILE_SIZE, playerChoosenTower)
          If tower Then
            tower.register
            money :- playerChoosenTower.price
          EndIf
        EndIf
      EndIf
     Case ACTION_WIRES
      If playerChoosenWire Then
        If playerChoosenWire.price <= money Then
          Local wire:TWire = TWire.Create((CurrentEvent.x-MENU1_WIDTH)/TILE_SIZE,..
                                                   CurrentEvent.y/TILE_SIZE, playerChoosenWire)
          If wire Then 
            wire.register
            money :- playerChoosenWire.price
          EndIf
        EndIf
      EndIf
     Case ACTION_UPGRADE
      If playerUpgradeTower Then
        If (CurrentEvent.x-MENU1_WIDTH)/TILE_SIZE <> playerUpgradeTower.x Or..
                                            CurrentEvent.y/TILE_SIZE <> playerUpgradeTower.y Then
          playerUpgradeTower = Null
          Return 1
        EndIf
      EndIf
    End Select
    If Not playerChoosenTower And (playerAction <> ACTION_UPGRADE Or Not playerUpgradeTower) Then
      Local tower:TTower
      Local x% = (CurrentEvent.x-MENU1_WIDTH)/TILE_SIZE
      Local y% = CurrentEvent.y              /TILE_SIZE
      For tower = EachIn TTower.list
        If tower.x = x And tower.y = y Then
          playerUpgradeTower = tower
          playerAction = ACTION_UPGRADE
          Return 1
        EndIf
      Next
    EndIf
    If CurrentEvent.y > sy-MENU2_HEIGHT-CURSOR_HEIGHT Then Return 1
  EndIf
  Return 0
End Function
Function updateTooltip()
  If CurrentEvent.id = EVENT_MOUSEMOVE Then
    tolltipMouseMove
    Return
  EndIf
  If lastMouseMove+300 > MilliSecs() Then Return
  If mx <= MENU1_WIDTH Then
    If my < 15 Then
      setTooltip "buy towers"
      Return
    ElseIf my < 35 Then
      setTooltip "buy wires/power-stations"
      Return
    ElseIf my > 45 And my < 65 Then
      setTooltip "end game"
    EndIf
    Return
  ElseIf my > sy-MENU2_HEIGHT Then
    Select playerAction
     Case ACTION_TOWERS
      Local col% = (mx-MENU1_WIDTH)/TILE_SIZE
      Local row% = (my-sy+MENU2_HEIGHT)/TILE_SIZE
      Local index% = row*(sx-MENU1_WIDTH)/TILE_SIZE+col
      If index >= 0 And index < TTowerKind.list.Count() Then
        setTooltip TTowerKind(TTowerKind.list.valueAtIndex(index)).tooltip
      EndIf
     Case ACTION_WIRES
      Local col% = (mx-MENU1_WIDTH)/TILE_SIZE
      Local row% = (my-sy+MENU2_HEIGHT)/TILE_SIZE
      Local index% = row*(sx-MENU1_WIDTH)/TILE_SIZE+col
      If index >= 0 And index < TWireKind.list.Count() Then
        setTooltip TWireKind(TWireKind.list.valueAtIndex(index)).tooltip
      EndIf
     Case ACTION_UPGRADE
      If playerUpgradeTower Then
        If mx < MENU1_WIDTH + (sx-MENU1_WIDTH)/4 Then
          If my > sy-MENU2_HEIGHT+20 Then
            setTooltip "sell this tower"
            Return
          EndIf
        Else
          Local col% = (mx - MENU1_WIDTH - (sx-MENU1_WIDTH)/4) / ((sx-MENU1_WIDTH)/4)
          Local row% = (my-sy+MENU2_HEIGHT)/20
          Local index% = row*3+col
          Local state% = playerUpgradeTower.getState(index)
          If state < 5 Then
            If TTower.getPrice(state+1) <= money Then
              Local name$ = TTower.names[index]
              setTooltip "upgrade the tower's "+name
            Else
              setTooltip "you don't have enough money"
            EndIf
          Else
            setTooltip "maximum"
          EndIf
        EndIf
      EndIf
    End Select
    Return
  Else
    Select playerAction
     Case ACTION_TOWERS
      If playerChoosenTower Then
        If playerChoosenTower.price <= money Then
          Local x% = (mx-MENU1_WIDTH)/TILE_SIZE
          Local y% = my/TILE_SIZE
          If buildLock[x][y] Then
            setTooltip "cannot build here"
          ElseIf TTower.index[x][y] Then
            setTooltip "another tower allready here"
          ElseIf TWire.index[x][y] Then
            setTooltip "a wire/power-station here"
          Else
            setTooltip "can build here"
          EndIf
        Else
          setTooltip "you don't have enough money"
        EndIf
      EndIf
     Case ACTION_WIRES
      If playerChoosenWire Then
        If playerChoosenWire.price <= money Then
          Local x% = (mx-MENU1_WIDTH)/TILE_SIZE
          Local y% = my/TILE_SIZE
          If buildLock[x][y] Then
            setTooltip "cannot build here"
          ElseIf TWire.index[x][y] Then
            setTooltip "another wire/power-station here"
          ElseIf TTower.index[x][y] Then
            setTooltip "a tower allready here"
          Else
            setTooltip "can build here"
          EndIf
        Else
          setTooltip "you don't have enough money"
        EndIf
      EndIf
     Case ACTION_UPGRADE
      If playerUpgradeTower Then
        If (mx-MENU1_WIDTH)/TILE_SIZE <> playerUpgradeTower.x Or..
                                            my/TILE_SIZE <> playerUpgradeTower.y Then
          setTooltip "unselect tower"
        EndIf
      EndIf
    End Select
    If Not playerChoosenTower And (playerAction <> ACTION_UPGRADE Or Not playerUpgradeTower) Then
      Local tower:TTower
      Local x% = (mx-MENU1_WIDTH)/TILE_SIZE
      Local y% = my              /TILE_SIZE
      For tower = EachIn TTower.list
        If tower.x = x And tower.y = y Then
          If tower.capacity Then
            setTooltip "select this tower"
          Else
            setTooltip "this tower has no electricity"
          EndIf
          Return
        EndIf
      Next
    EndIf
  EndIf
  Return
End Function


Global playerAction% = -1
Const ACTION_TOWERS% = 0
Const ACTION_WIRES%  = 1
Const ACTION_UPGRADE% = 2
Const PREVIEW_HEIGHT% = 20
Global playerChoosenTower:TTowerKind, playerChoosenWire:TWireKind
Global playerUpgradeTower:TTower
Function drawMenu1()
  setMenu1Draw
  Cls
  SetColor 255, 255, 255
  DrawText "Towers", 0, 0
  DrawText "Wires" , 0, 20
  DrawText "Quit"  , 0, 50
  DrawText lives   , 20, 100
  DrawText money   , 20, 120
  DrawImage livesImg, 0, 100
  DrawImage moneyImg, 0, 120
  Flip
End Function
Function drawMenu2()
  setMenu2Draw
  Cls
  SetColor 255, 255, 255
  Select playerAction
   Case ACTION_TOWERS
    Local row% = 0, col% = 0, mCol% = (mx-MENU1_WIDTH)/TILE_SIZE
    Local mRow% = (my-sy+MENU2_HEIGHT)/TILE_SIZE
    Local hoverTower:TTowerKind
    For Local tower:TTowerKind = EachIn TTowerKind.list
      If row = mRow And col = mCol Then
        hoverTower = tower
        SetAlpha 1
      ElseIf tower = playerChoosenTower Then
        SetAlpha 1
        DrawRect col*TILE_SIZE, row*TILE_SIZE, TILE_SIZE, TILE_SIZE
      ElseIf tower.price > money Then
        SetAlpha .3
      Else
        SetAlpha .8
      EndIf
      DrawImage tower.image, col*TILE_SIZE+TILE_SIZE/2, row*TILE_SIZE+TILE_SIZE/2
      col :+ 1
      If col > (sx-MENU1_WIDTH)/TILE_SIZE Then
        row :+ 1
        col = 0
      EndIf
    Next
    SetAlpha 1
    If hoverTower Then
      DrawText "price: "+hoverTower.price, 0  , MENU2_HEIGHT-PREVIEW_HEIGHT
      DrawText "power: "+hoverTower.power, 200, MENU2_HEIGHT-PREVIEW_HEIGHT
      DrawText "range: "+hoverTower.range, 400, MENU2_HEIGHT-PREVIEW_HEIGHT
    EndIf
   Case ACTION_WIRES
    Local row% = 0, col% = 0
    Local mCol% = (mx-MENU1_WIDTH)/TILE_SIZE, mRow% = (my-sy+MENU2_HEIGHT)/TILE_SIZE
    Local hoverWire:TWireKind
    For Local wire:TWireKind = EachIn TWireKind.list
      If row = mRow And col = mCol Then
        hoverWire = wire
        SetAlpha 1
      ElseIf wire = playerChoosenWire Then
        SetAlpha 1
        DrawRect col*TILE_SIZE, row*TILE_SIZE, TILE_SIZE, TILE_SIZE
      ElseIf wire.price > money Then
        SetAlpha .3
      Else
        SetAlpha .8
      EndIf
      DrawImage wire.image, col*TILE_SIZE+TILE_SIZE/2, row*TILE_SIZE+TILE_SIZE/2
      col :+ 1
      If col > (sx-MENU1_WIDTH)/TILE_SIZE Then
        row :+ 1
        col = 0
      EndIf
    Next
    SetAlpha 1
    If hoverWire Then
      DrawText "price: "+hoverWire.price, 0  , MENU2_HEIGHT-PREVIEW_HEIGHT
      DrawText "capacity: "+hoverWire.maxCapacity, 200, MENU2_HEIGHT-PREVIEW_HEIGHT
      DrawText "leekage: "+Int(hoverWire.leekage*100)+"%", 400, MENU2_HEIGHT-PREVIEW_HEIGHT
      If hoverWire.production > 0.0001 Then
        DrawText "production: "+hoverWire.production, 500, MENU2_HEIGHT-PREVIEW_HEIGHT
      EndIf
    EndIf
   Case ACTION_UPGRADE
    If playerUpgradeTower Then
      DrawText "upgrades:", 0, 0
      DrawText "sell"      , 0, 20
      Local col%=0, row%=0, index%
      For index=0 To 5
        Local x% = (sx-MENU1_WIDTH)/4*(col+1), y% = row*20
        Local value% = playerUpgradeTower.getState(index)
        SetColor 0, 0, 0
        DrawRect x, y, (sx-MENU1_WIDTH)/5*value/5, 20
        SetColor 255, 255, 255
        If value < 5 Then
          If TTower.getPrice(value+1) > money Then
            SetAlpha .6
          Else
            SetAlpha 1
          EndIf
        Else
          SetAlpha .4
        EndIf
        DrawText TTower.getName(index), x, y
        SetAlpha 1
        col :+ 1
        If col > 2 Then
          row :+ 1
          col = 0
        EndIf
      Next
    Else
      DrawText "[click on a tower to select it]", 0, 0
    EndIf
  End Select
  Flip
End Function

Global newPlayerIndex% = -1, newPlayerName$
Const DEL_OFFSET% = 70

Function showPlayers()
  DrawImage generalBG, 0, 0
  SetColor 255, 255, 255
  For Local no%=0 To TPlayer.MAX_NO-1
    Local y% = no*sy/TPlayer.MAX_NO
    DrawLine 0, y, sx, y
    If TPlayer.list[no] Then
      Local player:TPlayer = TPlayer.list[no]
      DrawText player.name, 10, y+10
      If player.storyDone Then
        DrawText "[done]", 400, y+10
      EndIf
      DrawText "[Delete]", sx-DEL_OFFSET, y+10
    Else
      If no = newPlayerIndex Then
        DrawText "Input name >"+newPlayerName, 10, y+10
      Else
        DrawText "[new]", 10, y+10
      EndIf
    EndIf
  Next
  Flip
End Function
Function checkPlayerChooseAction%()
  If CurrentEvent.id = EVENT_MOUSEDOWN Then
    Local index% = CurrentEvent.y / (sy/TPlayer.MAX_NO)
    If newPlayerIndex >= 0 Then
      If newPlayerIndex = index Then
        currentPlayer = TPlayer.Create(newPlayerName, index)
        newPlayerIndex = -1
        newPlayerName = ""
        Return 2
      Else
        newPlayerIndex = -1
        newPlayerName = ""
        Return 1
      EndIf
    Else
      If TPlayer.list[index] Then
        If CurrentEvent.x > sx-DEL_OFFSET Then
          TPlayer.list[index] = Null
          Return 1
        Else
          currentPlayer = TPlayer.list[index]
          Return 2
        EndIf
      EndIf
      newPlayerIndex = index
      newPlayerName = ""
      Return 1
    EndIf
  ElseIf CurrentEvent.id = EVENT_KEYCHAR Then
    If CurrentEvent.data = 8 Then                                    'BS
      newPlayerName = newPlayerName[..Len(newPlayerName)-1]
    ElseIf CurrentEvent.data = 10 Or CurrentEvent.data = 13 Then     'LF/CR
      currentPlayer = TPlayer.Create(newPlayerName, newPlayerIndex)
      newPlayerIndex = -1
      newPlayerName = ""
      Return 2
    ElseIf CurrentEvent.data > 32 Then
      newPlayerName :+ Chr(CurrentEvent.data)
    EndIf
    Return 1
  EndIf
End Function

Function choosePlayer()
  unsetViewport
  currentPlayer = Null
  showPlayers
  Repeat
    WaitEvent
    If CurrentEvent.id = EVENT_APPTERMINATE Then End
    If CurrentEvent.id = EVENT_KEYDOWN And EventData() = KEY_ESCAPE Then
      Return
    EndIf
    Select checkPlayerChooseAction()
     Case 1
      showPlayers
     Case 2
      Return
    End Select
    If CurrentEvent.id = EVENT_MOUSEMOVE Then
      mx = CurrentEvent.x
      my = CurrentEvent.y
      showPlayers
    EndIf
  Forever
End Function

Function showCheat()
  RuntimeError "cheater!"
End Function

Const LC_SIZE% = 50
Function showLevelChoice()
  DrawImage generalBG, 0, 0
  Local col%, row%
  For Local i%=1 To TLevel.list.Count()
    SetColor 255, 255, 255
    If i <= currentPlayer.currentLevel Then
      DrawImage levelEnabled , col*LC_SIZE+LC_SIZE/2, row*LC_SIZE+LC_SIZE/2
      SetColor 0, 0, 255
    Else
      DrawImage levelDisabled, col*LC_SIZE+LC_SIZE/2, row*LC_SIZE+LC_SIZE/2
      SetColor 200, 200, 200
    EndIf
    DrawText i, col*LC_SIZE+LC_SIZE/2-TextWidth(i)/2, row*LC_SIZE+LC_SIZE/2-TextHeight(i)/2
    col :+ 1
    If col >= sx/LC_SIZE Then
      row :+ 1
      col = 0
    EndIf
  Next
  Flip
End Function
Function checkLevelChoiceAction%()
  If CurrentEvent.id = EVENT_MOUSEDOWN Then
    Local col% = CurrentEvent.x/LC_SIZE
    Local row% = CurrentEvent.y/LC_SIZE
    Local index% = row*(sx/LC_SIZE)+col
    If index < currentPlayer.currentLevel Then
      currentLevel = TLevel(TLevel.list.valueAtIndex(index))
      Return 1
    EndIf
  EndIf
End Function
Function chooseLevel()
  unsetViewport
  currentLevel = Null
  showLevelChoice
  Repeat
    WaitEvent
    If checkLevelChoiceAction() Then Return
    Select CurrentEvent.id
     Case EVENT_APPTERMINATE
      End
     Case EVENT_KEYDOWN
      If CurrentEvent.data = KEY_ESCAPE Then Return
     Case EVENT_MOUSEMOVE
      mx = CurrentEvent.x
      my = CurrentEvent.y
      showLevelChoice
    End Select
  Forever
End Function