Function drawWaveEditor()
  DrawImage generalBG, 0, 0
  SetColor 255, 255, 255
  DrawText "money: "+currentWave.money, 0, 0
  Local row%=0, col%=0
  For Local i%=1 To currentWave.steps.Count()
    DrawText "Step "+i, col*100, row*100+20
    col :+ 1
    If col >= 8 Then
      row :+ 1
      col = 0
    EndIf
  Next
  Flip
End Function
Global currentStep:TStep
Function checkWaveEditorAction%()
  If CurrentEvent.id = EVENT_KEYDOWN Then
    Local keys1%[] = [KEY_0, KEY_1, KEY_2, KEY_3, KEY_4, KEY_5, KEY_6, KEY_7, KEY_8, KEY_9]
    Local keys2%[] = [KEY_NUM0, KEY_NUM1, KEY_NUM2, KEY_NUM3, KEY_NUM4, KEY_NUM5, KEY_NUM6, KEY_NUM7,..
                                                                                      KEY_NUM8, KEY_NUM9]
    For Local i%=0 To 9
      If keys1[i] = CurrentEvent.data Or keys2[i] = CurrentEvent.data Then
        currentWave.money :* 10
        currentWave.money :+ i
        Return 0
      EndIf
    Next
    If CurrentEvent.data = KEY_BACKSPACE Then
      currentWave.money :/ 10
      Return 0
    EndIf
    If CurrentEvent.data = KEY_S Then
      Local filename$ = RequestFile("Select file to save wave", "", True, AppDir)
      If filename Then
        Local stream:TStream = WriteFile(filename)
        saveWave stream, currentWave
      EndIf
      Return 0
    EndIf
    If CurrentEvent.data = KEY_A Then
      currentStep = New TStep
      currentWave.steps.addLast currentStep
    EndIf
  ElseIf CurrentEvent.id = EVENT_MOUSEDOWN Then
    Local col% = CurrentEvent.x/100, row% = (CurrentEvent.y-20)/100
    Local index% = row*8+col
    If index >= 0 And index < currentWave.steps.Count() Then
      currentStep = TStep(currentWave.steps.valueAtIndex(index))
    EndIf
    Return 1
  EndIf
  Return -1
End Function
Global stepEditorOffset% = 0, stepEditorSelect% = -1
Function drawStepEditor()
  DrawImage generalBG, 0, 0
  DrawText "Pause before: "+currentStep.pauseBefore, 0, 0
  DrawText "enemy time: "+currentStep.enemyTime, 0, 20
  If currentStep.randomize Then
    DrawText "randomize", 0, 40
  Else
    DrawText "don't randomize", 0, 40
  EndIf
  Local enemy:TEnemyKind, index% = 0
  For enemy = EachIn currentStep.enemies
    If index = stepEditorSelect Then
      SetAlpha 1
    Else
      SetAlpha .2
    EndIf
    SetScale Float(TILE_SIZE)/ImageWidth(enemy.image), Float(TILE_SIZE)/ImageHeight(enemy.image)
    DrawImage enemy.image, index*TILE_SIZE-stepEditorOffset+TILE_SIZE/2, 80'+TILE_SIZE/2
    index :+ 1
  Next
  SetScale 1, 1
  SetAlpha 1
  Local row%=0, col%=0
  For enemy = EachIn TEnemyKind.list
    SetScale Float(TILE_SIZE)/ImageWidth(enemy.image), Float(TILE_SIZE)/ImageHeight(enemy.image)
    DrawImage enemy.image, col*TILE_SIZE+TILE_SIZE/2, row*TILE_SIZE+100'+TILE_SIZE/2
    col :+ 1
    If (col+1)*TILE_SIZE+TILE_SIZE/2 >= sx Then
      row :+ 1
      col = 0
    EndIf
  Next
  SetScale 1, 1
  Flip
End Function
Function checkStepEditorAction%()
  If CurrentEvent.id = EVENT_KEYDOWN Then
    Select CurrentEvent.data
     Case KEY_UP
      If KeyDown(KEY_P) Then
        currentStep.pauseBefore :+ 1
      ElseIf KeyDown(KEY_E) Then
        currentStep.enemyTime :+ .1
      EndIf
     Case KEY_DOWN
      If KeyDown(KEY_P) Then
        currentStep.pauseBefore = Max(0, currentStep.pauseBefore-1)
      ElseIf KeyDown(KEY_E) Then
        currentStep.enemyTime = Max(.1, currentStep.enemyTime-.1)
      EndIf
     Case KEY_PAGEUP
      If KeyDown(KEY_P) Then
        currentStep.pauseBefore :+ 10
      ElseIf KeyDown(KEY_E) Then
        currentStep.enemyTime :+ 1
      EndIf
     Case KEY_PAGEDOWN
      If KeyDown(KEY_P) Then
        currentStep.pauseBefore = Max(0, currentStep.pauseBefore-10)
      ElseIf KeyDown(KEY_E) Then
        currentStep.enemyTime = Max(.1, currentStep.enemyTime-1)
      EndIf
     Case KEY_0
      If KeyDown(KEY_P) Then
        currentStep.pauseBefore = 0
      ElseIf KeyDown(KEY_E) Then
        currentStep.enemyTime = .1
      EndIf
     Case KEY_LEFT
      stepEditorOffset = Max(0, stepEditorOffset-5*TILE_SIZE)
     Case KEY_RIGHT
      stepEditorOffset = Min(currentStep.enemies.Count()*TILE_SIZE-sx, stepEditorOffset+5*TILE_SIZE)
     Case KEY_DELETE
      If stepEditorSelect >= 0 Then    'remove from list. Needed to hack BlitzMax (TLink._succ/_pred)
        If currentStep.enemies.Count() < 2 Then
          currentStep.enemies.Clear
          stepEditorSelect = -1
        ElseIf currentStep.enemies.Count() = 2 Then
          Local value:Object = currentStep.enemies.valueAtIndex(stepEditorSelect)
          currentStep.enemies.Clear
          currentStep.enemies.addLast value
          stepEditorSelect = -1
        Else
          Local link:TLink = currentStep.enemies.firstLink()
          For Local i%=0 To stepEditorSelect-1
            link = link._succ
          Next
          link.remove
          stepEditorSelect = -1
        EndIf
      EndIf
     Case KEY_R
      currentStep.randomize = Not currentStep.randomize
     Default
      Return -1
    End Select
    Return 0
  ElseIf CurrentEvent.id = EVENT_MOUSEDOWN Then
    If CurrentEvent.y > 70 And CurrentEvent.y < 90 Then
      Local index% = (CurrentEvent.x+stepEditorOffset)/TILE_SIZE
      If index >= 0 And index < currentStep.enemies.Count() Then
        Local clicked:TEnemyKind = TEnemyKind(currentStep.enemies.valueAtIndex(index))
        If stepEditorSelect = index Then
          stepEditorSelect = -1
        ElseIf stepEditorSelect >= 0 Then
          If currentStep.enemies.Count() < 2 Then
            currentStep.enemies.Clear
          Else  'change positions. Needed to hack BlitzMax (TLink._succ/_pred)
            Local link1:TLink, link2:TLink
            Local tmp:TLink = currentStep.enemies.firstLink()
            For Local i%=0 To Max(stepEditorSelect, index)
              If i = stepEditorSelect Then
                link1 = tmp
              ElseIf i = index Then
                link2 = tmp
              EndIf
              tmp = tmp._succ
            Next
            Local temp:Object = link1._value
            link1._value = clicked
            link2._value = temp  
          EndIf
        Else
          stepEditorSelect = index
        EndIf
      EndIf
    ElseIf CurrentEvent.y > 100-TILE_SIZE/2 Then
      Local col% = (CurrentEvent.x    )/TILE_SIZE
      Local row% = (CurrentEvent.y-100)/TILE_SIZE
      Local index% = row*sx/TILE_SIZE+col
      If index >= 0 And index < TEnemyKind.list.Count() Then
        Local enemy:TEnemyKind = TEnemyKind(TEnemyKind.list.valueAtIndex(index))
        If stepEditorSelect >= 0 Then     'change value. Needed to hack BlitzMax (TLink._succ/_pred)
          Local link:TLink = currentStep.enemies.firstLink()
          For Local i%=0 To stepEditorSelect-1
            link = link._succ
          Next
          link._value = enemy
        Else
          currentStep.enemies.addLast enemy
        EndIf
      EndIf
    EndIf
  EndIf
  Return -1
End Function






Function editWave()
  loadGeneralGFX
  unsetViewport
  If Not currentWave Then currentWave = TWave.Create(1000)
  drawWaveEditor
  Repeat
    WaitEvent
    If Not currentStep Then
      If checkWaveEditorAction() = 0 Or CurrentEvent.id = EVENT_MOUSEMOVE Then
        drawWaveEditor
      ElseIf CurrentEvent.id = EVENT_APPTERMINATE Then
        End
      ElseIf CurrentEvent.id = EVENT_KEYDOWN And CurrentEvent.data = KEY_ESCAPE Then
        Return
      ElseIf currentStep Then
        stepEditorSelect = -1
        drawStepEditor
      EndIf
    Else
      If checkStepEditorAction() = 0 Or CurrentEvent.id = EVENT_MOUSEMOVE Then
        drawStepEditor
      ElseIf CurrentEvent.id = EVENT_APPTERMINATE Then
        End
      ElseIf CurrentEvent.id = EVENT_KEYDOWN And CurrentEvent.data = KEY_ESCAPE Then
        currentStep = Null
        stepEditorSelect = -1
      EndIf
    EndIf
    If CurrentEvent.id = EVENT_MOUSEMOVE Then
      mx = CurrentEvent.x
      my = CurrentEvent.y
    EndIf
  Forever
End Function
