﻿Rem
	TFrame kümmert sich um das laden der grafiken per inidateien (momentan Unit und Tower)
	Es werden diverse TFrame-sets erstellt, die global über TFrame verüfgbar sind. Gespeichert wird in Arrays.
	
	author: PhillipK
End Rem

Const FRAMESET_UNIT:Int = 0
Const FRAMESET_TOWER:Int = 1

Type TFrame
	Global list:TFrame[][] 'frameset-slot / Index
	Global texture:Int[] ' frameset-slot
	
	Field w:Float, h:Float 'auf float vorgecastet um beim zeichnen einen speedboost zu haben.
	Field uv:Float[]
	
	Field pngPos:Int[]
	
	Field ox:Float, oy:Float 'offsets um zeichnen zu positionieren.
	
	Field spos:Float[] = New Float[8]
	
	Rem
		bbdoc: DrawBySlot zeichnet einen Frame anhand seiner Tile-position (im array). Die tilepos sind Int-genau.
		anmerkung: die Tilepositionen müssen vorhaner -camx und -camy verrechnet werden!
		author: phillipk
	end rem
	Method DrawBySlot:Int(x:Int, y:Int, shadow:Int = 1)
	
	'Zeichnen nötig, oder ausserhalb des bildschirms?
		If MDisti(0, 0, x, y) > 18 Then Return 0 'nein -> nix.
		
		Local posx:Int = (x * (32)) - (y * (32)) - 32 ' x wert bestimmen - hier die gängige formel. -32 als X offset (zentrieren der kachel)
		Local posy:Int = (x * (16)) + (y * (16)) - 16 ' y wert bestimmmen.
		
		Draw(posx, posy, shadow) ' > Draw aufruf (nimmt screenX, screenY)
	End Method
	Rem
		bbdoc: DrawBySlot zeichnet einen Frame anhand seiner Tile-position (im array). Die tilepos sind float-genau.
		anmerkung: die Tilepositionen müssen vorhaner -camx und -camy verrechnet werden!
		author: phillipk
	end rem
	Method DrawBySlotf:Int(x:Float, y:Float, shadow:Int = 1)
	
	'Siehe DrawBySlot()
		If MDisti(0, 0, x, y) > 18 Then Return 0
		Local posx:Int = (x * (32)) - (y * (32)) - 32
		Local posy:Int = (x * (16)) + (y * (16)) - 16
		Draw(posx, posy, shadow)
	End Method
	
	Rem
		bbdoc: DrawBySlot zeichnet einen Frame anhand seiner Tile-position (im array). Die tilepos sind Int-genau. Es ist zusätzlich möglich, einen frame in einer farbe zu zeichnen.
		anmerkung: die Tilepositionen müssen vorhaner -camx und -camy verrechnet werden! col muss übergeben werden!
		author: phillipk
	end rem
	Method DrawBySlotfCOL:Int(x:Float, y:Float, col:Float[], sizeX:Float, sizeY:Float, shadow:Int = 1)
	
	'Siehe DrawBySlot()
		If MDisti(0, 0, x, y) > 18 Then Return 0
		Local posx:Int = (x * (32)) - (y * (32)) - 32
		Local posy:Int = (x * (16)) + (y * (16)) - 16
		
		DrawCOL(posx, posy, col, sizeX, sizeY, shadow) '-> Ist mit Draw() identisch, nur mit dem Color[] und skalier-size - zusatz!

	End Method
	
	Rem
		bbdoc: DrawCOL zeichnet einen Frame und eventuell seinen schatten. 
		parameter: posx = screenposition, posy = screenposition
				   col:float[] -> float[4] mit RGBA
				   sizeX:float, sizeY:float -> float zum skalieren.
		author: Philllipk
	end rem
	Method DrawCOL:Int(posx:Int, posy:Int, col:Float[] = Null, sizeX:Float = 1.0, sizeY:Float = 1.0, shadow:Int = 1)
	
		If Not col Then
			col = [1.0, 1.0, 1.0, 1.0]
		EndIf

	'Step 1.1 -> Locals
		posx:+(ox * sizeX) 'sizeX/sizeY zeugs ist meist ein float bis 1.0 -> skalieren der offsets. (ox,oy, w, h)
		posy:+(oy*sizeY)
		Local w:Float = Self.w * sizeX
		Local h:Float = Self.h * sizeY
	
	
		glBegin(GL_QUADS)
		
		'Step 2.1 -> Schatten 
			If shadow Then
				glColor4f(shadowCol[0], shadowCol[1], shadowCol[2], shadowCol[3])
			
				Local uvMinus:Float = 0'-h * 0.1 / 1024.0
				glTexCoord2d(uv[0], uv[1])
				glVertex3d(spos[0] * sizeX + posx, spos[1] * sizeY + posy, -999)
				
				glTexCoord2d(uv[2], uv[1])
				glVertex3d(spos[2] * sizeX + posx, spos[3] * sizeY + posy, -999)
				
				glTexCoord2d(uv[2], uv[3] - uvMinus)
				glVertex3d(spos[4] * sizeX + posx, spos[5] * sizeY + posy, -999)
				
				glTexCoord2d(uv[0], uv[3] - uvMinus)
				glVertex3d(spos[6] * sizeX + posx, spos[7] * sizeY + posy, -999)

				
			EndIf
		'Step 2.2 -> Frame selbst
		'anmerkung: Schatten hat z = -999. Sonstiges hat z = (posy + h)*2
			glColor4f(col[0], col[1], col[2], col[3])
			
			glTexCoord2d(uv[0], uv[1])
			glVertex3d(posx, posy, (posy + h) * 2)
			
			glTexCoord2d(uv[2], uv[1])
			glVertex3d(posx + w, posy, (posy+h) * 2)
			
			glTexCoord2d(uv[2], uv[3])
			glVertex3d(posx + w, posy + h, (posy + h) * 2)
			
			glTexCoord2d(uv[0], uv[3])
			glVertex3d(posx, posy + h, (posy + h) * 2)
		
			glColor4f(1.0, 1.0, 1.0, 1.0) 'color zurücksetzen.
		glEnd()
	End Method
	Method Draw:Int(posx:Int, posy:Int, shadow:Int = 1)

		posx:+ox
		posy:+oy
	
		glBegin(GL_QUADS)
		
			If shadow Then
				glColor4f(shadowCol[0], shadowCol[1], shadowCol[2], shadowCol[3])
			
				Local uvMinus:Float = 0'-h * 0.1 / 1024.0
				glTexCoord2d(uv[0], uv[1])
				glVertex3d(spos[0] + posx, spos[1] + posy, -999)
				
				glTexCoord2d(uv[2], uv[1])
				glVertex3d(spos[2] + posx, spos[3] + posy, -999)
				
				glTexCoord2d(uv[2], uv[3] - uvMinus)
				glVertex3d(spos[4] + posx, spos[5] + posy, -999)
				
				glTexCoord2d(uv[0], uv[3] - uvMinus)
				glVertex3d(spos[6] + posx, spos[7] + posy, -999)

				glColor4f(1, 1, 1, 1)		
			EndIf
			glTexCoord2d(uv[0], uv[1])
			glVertex3d(posx, posy, (posy + h) * 2)
			
			glTexCoord2d(uv[2], uv[1])
			glVertex3d(posx + w, posy, (posy+h) * 2)
			
			glTexCoord2d(uv[2], uv[3])
			glVertex3d(posx + w, posy + h, (posy + h) * 2)
			
			glTexCoord2d(uv[0], uv[3])
			glVertex3d(posx, posy + h, (posy + h) * 2)
		
		glEnd()
	End Method
	
	Function GetByID:TFRame(id:Int, slot:Int = FRAMESET_UNIT)
		If Len(list) > slot And Len(list[slot]) > id Then
			Return list[slot][id]
		EndIf
		Return Null
	End Function
	Function GetUnitFrameByID:TFrame(id:Int)
		If Len(list) > FRAMESET_UNIT And Len(list[FRAMESET_UNIT]) > id Then
			Return list[FRAMESET_UNIT][id]
		End If
		Return Null
	End Function
	Function GetTowerFrameByID:TFrame(id:Int)
		If Len(list) > FRAMESET_TOWER And Len(list[FRAMESET_TOWER]) > id Then
			Return list[FRAMESET_TOWER][id]
		End If
		Return Null
	End Function
	
	Function LoadFrames:Int(file:String, slot:Int = FRAMESET_UNIT)
		If FileType(file) = 0 Then RuntimeError("Konnte datei " + file + " nicht laden!")
		
		Local ini:TInifile = TInifile.Load(file)
		
		Local pix:TPixmap = LoadPixmap(ini.gets("General", "png"))
		
		
		
		If Not pix Then RuntimeError("Konnte PNG nicht laden. Dateipfad: " + ini.gets("General", "png"))
		
		'hat alles soweit geklappt. array slicen! :)
		If Len(list) <= slot Then
			list = list[..slot + 1]
		EndIf
		If Len(texture) <= slot Then
			texture = texture[..slot + 1]
		End If
		
		texture[slot] = GLTexFromPixmap(pix)
		
		Local _w:Float = Float(ini.geti("General", "width")) ' auf diese größen wurden die frames gespeichert.
		Local _h:Float = Float(ini.geti("General", "height")) 'dh : Diese werte zum berechnen der uv's nutzen!
		
		
		For Local header:TIniheader = EachIn ini.data.values()
			If header.name = "General" Then Continue 'header überspringen
			
			Local h:String = header.name
			
			Local frame:TFrame = New TFrame
			
			frame.ox = ini.geti(h, "ox")
			frame.oy = ini.geti(h, "oy")
			
			If slot = FRAMESET_TOWER Then
				Print "Frame: " + h + " wurde geladen."
				Print "-> OffsetX: "+frame.ox+" / OffsetY: "+frame.oy
			EndIf
			
			frame.h = ini.geti(h, "height")
			frame.w = ini.geti(h, "width")
		
			Local x:Int = ini.geti(h, "x")
			Local y:Int = ini.geti(h, "y")
			
			frame.pngPos = [x, y, Int(frame.w), Int(frame.h)]
			
			frame.uv = [x / _w, y / _h, (x + frame.w) / _w, (y + frame.h) / _h]
			
			Local id:Int = h.ToInt()
			
			
			
			If Len(list[slot]) <= id Then
				list[slot] = list[slot][..id + 1]
			EndIf
			
			list[slot][id] = frame
			
			
			'schattenpos berechnung.
			frame.calcShadow(shadowAngle, shadowLen)
			
		Next
	End Function
'	
	Method calcShadow(angle:Float, laenge:Float)
		Local _sin:Float = Sin(angle)
		Local _cos:Float = Cos(angle)
		
		Local x:Float = w * 0.5
		Local y:Float = h * 0.75
		
		
		'W / H offset berechnen:
		
		Local _xO:Float = (-_sin * (w * 0.5))
		Local _yO:Float = (_cos * (w * 0.5))
		Local _xo2:Float = (-_sin * (w * 0.5)) * laenge
		Local _yo2:Float = (_cos * (w * 0.5)) * laenge
		
	
		
		Local _wo:Float = (_cos * h) * laenge '* 2
		Local _ho:Float = (_sin * h) * laenge
	
			spos[0] = _xo2 + x + _wo
			spos[1] = _yo2 + y + _ho '+ (oy * 0.5)
			
			spos[2] = - _xo2 + x + _wo
			spos[3] = - _yo2 + y + _ho '+ (oy * 0.5)

			spos[6] = _xO + x
			spos[7] = _yO + y '+ (oy * 0.5)

			spos[4] = - _xO + x
			spos[5] = - _yO + y '+ (oy * 0.5)
	End Method

End Type