﻿Rem
	author: PhillipK
end rem

Type TInifile

	Field data:TMap = CreateMap()
	Field changed:Int = 0
	Field file:String = ""
	Field HeaderCount:Int = 0
		
	Function Load:TInifile(file:String)
		Local stream:TStream = ReadFile(file)
		
		Local headerc:Int = 0
		Local datac:Int = 0
		Assert stream, "Konnte ~q" + file + "~q nicht laden!"
		
		Local ini:TInifile = New Tinifile
		
		ini.file = file
		
		Local lastHeader:TIniheader
		
		
		While Not Eof(stream)
			Local line:String = ReadLine(stream)
			
			If line.Contains("[") And line.Contains("]") Then
				if lastHeader Then lastheader.dataCount = datac
				line = line.Replace("[", "")
				line = line.Replace("]", "")
				line = line.Trim()
			'	Print "lade: " + line
				
				Local h:TIniheader = New TIniheader
				h.name = line
				
				ini.data.Insert(line, h)
				datac = 0
				headerc:+1
				lastHeader = h
			Else
				If line.Contains("=") Then 'value!
					Local pos:Int = Line.Find("=")
					
					If lastHeader Then
						datac:+1
						Local val:TInidata = New TInidata
						val.name = Left(line, pos).Trim()
						val.val = Right(line, Len(line) - (pos + 1)).Trim()
						
						lastHeader.data.Insert(val.name, val)
					End If
				EndIf
			EndIf
		Wend
		
		ini.HeaderCount = headerc
		Return ini
	End Function
	
	Method gets:String(header:String, val:String, _default:String = "")
		Local ret:String = _default
		
		If data.Contains(header) Then
			Local h:TIniheader = tiniheader(data.ValueForKey(header))
	
			If h Then
				If h.data.Contains(val) Then
					Local d:TInidata = TInidata(h.data.ValueForKey(val))
					
					If d Then
						ret = d.val
					EndIf
				End If
			End If
		End If
		
		Return ret
	End Method
	Method getsArray:String[] (header:String, val:String, seperator:String = ";")
		Local ret:String[]
		
		If data.Contains(header) Then
			Local h:TIniheader = Tiniheader(data.ValueForKey(header))
			
			If h Then
				If h.data.Contains(val) Then
					Local d:TInidata = TInidata(h.data.ValueForKey(val))
					
					If d Then
						Local sp:String[] = d.val.Split(seperator)
						
						For Local i:Int = 0 Until Len(sp)
							If Len(sp) > 0 Then
								ret:+[sp[i]]
							End If
						Next
						
						Return ret
					End If
 				EndIf
			End If
		End If
	End Method
	Method getiArray:Int[] (header:String, val:String, seperator:String = ";")
		Local ret:Int[]
		
		If data.Contains(header) Then
			Local h:TIniheader = Tiniheader(data.ValueForKey(header))
			
			If h Then
				If h.data.Contains(val) Then
					Local d:TInidata = TInidata(h.data.ValueForKey(val))
					
					If d Then
						Local sp:String[] = d.val.Split(seperator)
						
						For Local i:Int = 0 Until Len(sp)
							If isNumerical(sp[i]) Then
						'	If Len(sp) > 0 Then
								ret:+[sp[i].ToInt()]
							End If
						Next
						
						Return ret
					End If
 				EndIf
			End If
		End If
		
		Function isNumerical:Int(str:String)
			Local cM:Int = 0
			Local cV:Int = 0
			If Len(str) < 1 Then Return 0
			For Local i:Int = 0 Until Len(str)
				If i = 0 And str[0] = 45 Then
					'minuszeichen
					cM = 1
				ElseIf str[i] >= 48 And str[i] <= 57 Then
					'es ist eine zahl.
				Else
					Return 0
				End If
			Next
			If Len(str) = 1 And cM Then Return 0
			Return 1
		End Function
		
	End Method
	
	Method getfArray:Float[] (header:String, val:String, seperator:String = ";")
		Local ret:Float[]
		
		If data.Contains(header) Then
			Local h:TIniheader = Tiniheader(data.ValueForKey(header))
			
			If h Then
				If h.data.Contains(val) Then
					Local d:TInidata = TInidata(h.data.ValueForKey(val))
					
					If d Then
						Local sp:String[] = d.val.Split(seperator)
						
						For Local i:Int = 0 Until Len(sp)
							If Len(sp) > 0 Then
								ret:+[sp[i].ToFloat()]
							End If
						Next
						
						Return ret
					End If
 				EndIf
			End If
		End If
	End Method
	Method geti:Int(header:String, val:String, _default:Int = 0)
		Local ret:Int = _default
		
		If data.Contains(header) Then
			Local h:TIniheader = tiniheader(data.ValueForKey(header))
	
			If h Then
				If h.data.Contains(val) Then
					Local d:TInidata = TInidata(h.data.ValueForKey(val))
					
					If d Then
						ret = d.val.ToInt()
					EndIf
				End If
			End If
		End If
		
		Return ret
	End Method
	
	Method getf:Float(header:String, val:String, _default:Float = 0.0)
		Local ret:Float = _default
		
		If data.Contains(header) Then
			Local h:TIniheader = tiniheader(data.ValueForKey(header))
	
			If h Then
				If h.data.Contains(val) Then
					Local d:TInidata = TInidata(h.data.ValueForKey(val))
					
					If d Then
						ret = d.val.Tofloat()
					EndIf
				End If
			End If
		End If
		
		Return ret
	End Method
	
	Method sets(header:String, val:String, wert:String)
		If data.Contains(header) Then
			Local h:TIniheader = tiniheader(data.ValueForKey(header))
	
			If h Then
				If h.data.Contains(val) Then
					Local d:TInidata = TInidata(h.data.ValueForKey(val))
					
					If d Then
						d.val = wert
					EndIf
				Else
					'wert nicht vorhanden - einfügen.
					Local _val:tinidata = New tinidata
					_val.name = val
					_val.val = wert
					h.data.Insert(val, _val)
				End If
			End If
		Else
			Local newH:TIniheader = New tiniheader
			
			newH.name = header
			Local newval:TInidata = New TInidata
			
			newval.name = val
			newval.val = wert
			
			newH.data.Insert(val, newval)
			
			data.insert(header, newH)
		End If
		
		changed = 1
	End Method

	Method seti(header:String, val:String, wert:Int)
		If data.Contains(header) Then
			Local h:TIniheader = tiniheader(data.ValueForKey(header))
	
			If h Then
				If h.data.Contains(val) Then
					Local d:TInidata = TInidata(h.data.ValueForKey(val))
					
					If d Then
						d.val = String.fromint(wert)
					EndIf
				Else
					'wert nicht vorhanden - einfügen.
					Local _val:tinidata = New tinidata
					_val.name = val
					_val.val = String.fromint(wert)
					h.data.Insert(val, _val)
				End If
			End If
		Else
			Local newH:TIniheader = New tiniheader
			
			newH.name = header
			Local newval:TInidata = New TInidata
			
			newval.name = val
			newval.val = String.fromint(wert)
			
			newH.data.Insert(val, newval)
			
			data.insert(header, newH)
		End If
		
		changed = 1
	End Method
	
	Method setf(header:String, val:String, wert:Float)
		If data.Contains(header) Then
			Local h:TIniheader = tiniheader(data.ValueForKey(header))
	
			If h Then
				If h.data.Contains(val) Then
					Local d:TInidata = TInidata(h.data.ValueForKey(val))
					
					If d Then
						d.val = String.FromFloat(wert)
					EndIf
				Else
					'wert nicht vorhanden - einfügen.
					Local _val:tinidata = New tinidata
					_val.name = val
					_val.val = String.FromFloat(wert)
					h.data.Insert(val, _val)
				End If
			End If
		Else
			Local newH:TIniheader = New tiniheader
			
			newH.name = header
			
			Local newval:TInidata = New TInidata
			
			newval.name = val
			newval.val = String.FromFloat(wert)
			
			newH.data.Insert(val, newval)
			
			data.insert(header, newH)
		End If
		
		changed = 1
	End Method
	
	Method Save()
		If changed Then
			Local stream:TStream = WriteFile(file)
			
			For Local header:TIniheader = EachIn data.values()
				If header.name = "" Then Continue
				stream.WriteLine("[" + header.name + "]")
			'	Print "Schreibe HEader: " + header.name
				
				For Local data:TInidata = EachIn header.data.values()
					stream.WriteLine(data.name + " = " + data.val)
			'		Print "Schreibe wert: " + data.name
				Next
				
				stream.WriteLine("")
			Next
			
			stream.Close()
		EndIf
	End Method
End Type

Type TIniheader
	Field name:String
	Field data:TMap = CreateMap()
	Field dataCount:Int = 0
End Type

Type TInidata
	Field name:String
	Field val:String
End Type