﻿rem
	author: PhillipK
end rem

TKachel.LoadData()

Const InRange_TREE:Int = 1
Const InRange_STONE:Int = 2
Const InRange_WATER:Int = 4
Const InRange_TOWER:Int = 8


Type TLandschaft

	Global map:TLandschaft

	Field blocks:Byte[,]
	Field houses:Byte[,]
	Field buildings:Tbuilding[,]
	Field __wegsucheMap:Byte[,]
	Field colors:TMapColormarker[,]
	
	Field wegpunkte:TWegpunkt[,]
	
	Field sizeX:Int
	Field sizeY:Int
	
	Field update:Int = 1
	Field markerList:TList = CreateList()
	Field towermarkerList:TList = CreateList()
	
	Field minimap:Int
	
	Field _onBuild:Int = 0
	
	Method UpdateTowersInRange()
		Local x:Int, y:Int
		Local col:TMapColorMarker
		For Local t:TTower = EachIn TTower.activetower
			For x = t.posx - 4 To t.posx + 4
				If x < 0 Or x >= sizeX Then Continue
			For y = t.posy - 4 To t.posy + 4
				If y < 0 Or y >= sizeY Then Continue
				
				If Pythi(x, y, t.posx, t.posy) <= 4 Then
					col = colors[x, y]
					
					If col Then
						If (col.inRange & InRange_TOWER) <> InRange_TOWER Then
							col.inRange = col.inRange | InRange_TOWER
						End If
					End If
				End If
			Next
			Next
		Next
		For Local h:THouse = EachIn THouse.activeHouse
			If h.id = 127 Then
				For x = h.posx - 8 To h.posx + 8
					If x < 0 Or x >= sizeX Then Continue
				For y = h.posy - 8 To h.posy + 8
					If y < 0 Or y >= sizeY Then Continue
					
					If Pythi(x, y, h.posx, h.posy) <= 8 Then
						col = colors[x, y]
						
						If col Then
							If (col.inRange & InRange_TOWER) <> InRange_TOWER Then
								col.inRange = col.inRange | InRange_TOWER
							End If
						End If
					End If
				Next
				Next
			End If
		Next
	End Method
	Method SetMapColor:Int(col:Byte)
		Memsetb(colors, col, sizeX * sizeY)
	End Method
	Method SetBuildcolor:Int(tower:Tbuilding)

	End Method
	Method SetBuilding:Int(x:Int, y:Int, building:TBuilding)
		If TTower(building) Then
			If SetTower(x, y, TTower(building)) Then
				tgame.stats_buildt:+1
				__wegsucheMap[x, y] = 1
				Tbuilding.UpdatePositionArray()
				TLandschaft.map.update = 1
				Return 2
			EndIf
		ElseIf THouse(building) Then
			If SetHouse(x, y, THouse(building)) Then
				tgame.stats_buildh:+1
				__wegsucheMap[x, y] = 1
				Tbuilding.UpdatePositionArray()
				TLandschaft.map.update = 1
				Return 1
			EndIf
		Else
			Return - 1
		EndIf
	End Method
	Method SetTower:Int(x:Int, y:Int, tower:ttower)
		If x < 0 Or y < 0 Or x >= sizeX Or y >= sizeY Then Return - 1
		
		If Tressource.doBuild(tower) Then
		
			Self.buildings[x, y] = TTower.CopyTowerBySrc(tower)
			Self.buildings[x, y].posx = x
			Self.buildings[x, y].posy = y
			
			
			Local str:String = "TOWE" + tower.id
		
			Local _tmp:TBuildedHelper
			
			If TMapData.buildedList.contains(str) Then
				_tmp = TBuildedHelper(TMapData.buildedList.valueForKey(str))
			EndIf
			
			If _tmp Then _tmp.builded:+1

			UpdateTowersInRange()

			Return 1
		
		EndIf
		
		Return 0
	End Method
	
	Method CheckUnitForBuildrange:Int(x:Int, y:Int)
		Local sekX:Int = x / 8
		Local sekY:Int = y / 8
		
		Local _x:Int, _y:Int
	
		For _y = sekY - 2 To sekY + 2
		For _x = sekX - 2 To sekX + 2
			If _x < 0 Or _y < 0 Or _x >= sizeX / 8 Or _y >= sizeY / 8 Then Continue
				
			For Local tuc:TUnitController = EachIn TUnitSektor.sektors[_x, _y].list
				If Int(tuc.slotx) = x And Int(tuc.sloty) = y Then Return 1
			Next
		Next
		Next
		Return 0
	End Method
	
	Method BuildPossible:Int(x:Int, y:Int, building:TBuilding, checkRes:Int = 1)
		If checkRes And Tressource.CheckBuild(building) = 0 Then
			REASON_BUILD_NOT_POSSIBLE = "Nicht genug Res."
			Return 0
		EndIf
		
		If x < 0 Or y < 0 Or x >= sizeX Or y >= sizeY Then Return 0
		
		Local col:TMapColorMarker = colors[x, y]
		
		If col Then
			If col.col Then Return 0 'im moment ist col.col von den units gesetzt - heißt: Wenn eine unit in der nähe ist, darf nicht gebaut werden!
			
			If col.baumode = 0 Then Return 0 'baumode 0 heißt, nix is :D
		
			If THouse(building) Then
				If (col.inRange & InRange_TOWER) <> InRange_TOWER Then
					REASON_BUILD_NOT_POSSIBLE = "Distanz zu anderen gebäuden ist zu groß."
					Return 0
				EndIf
				Select THouse(building).id
					Case 100, 101, 102, 103 'minen
					Default
						If col.baumode <> 1 Then
							REASON_BUILD_NOT_POSSIBLE = "Baugrund belegt."
							Return 0 'alles andere braucht baumode 1.
						EndIf
				End Select
				
				
				Select THouse(building).id
					Case 0 'holzfäller
						If (col.inRange & InRange_TREE) <> InRange_TREE Then
							REASON_BUILD_NOT_POSSIBLE = "Keine Bäume in der nähe."
							Return 0
						EndIf
					Case 1 'steinmetz
						If (col.inRange & InRange_STONE) <> InRange_STONE Then
							REASON_BUILD_NOT_POSSIBLE = "Keine Stein in der nähe."
							Return 0
						EndIf
				End Select
			End If
		End If
	
		If TTower(building) Then Return BuildPossible_tower(x, y, TTower(building))
		If THouse(building) Then Return BuildPossible_house(x, y, THouse(building))
	End Method
	
	Method BuildPossible_tower:Int(x:Int, y:Int, tower:TTower)
		Local str:String = "TOWE" + tower.id
		
		Local _tmp:TBuildedHelper
		
		If TMapData.buildedList.contains(str) Then
			_tmp = TBuildedHelper(TMapData.buildedList.valueForKey(str))
		EndIf
		
		If _tmp And _tmp.possible() = 0 Then
			REASON_BUILD_NOT_POSSIBLE = "Bauverbot!"
			Return 0
		EndIf
		Return isBlocked(x, y) = 0
	End Method
	Method buildPossible_house:Int(x:Int, y:Int, house:Thouse)
	
		Local str:String = "HOUS" + (house.id + 128)
		
		Local _tmp:TBuildedHelper
		
		If TMapData.buildedList.contains(str) Then
			_tmp = TBuildedHelper(TMapData.buildedList.valueForKey(str))
		EndIf
		
			Select house.id
				Case 100, 101, 102, 103 'eisenmine, goldmine!
					'braucht boden id 21 !
					
					Local x2:Int, y2:Int
					Local found:Int = 0
					For x2 = x - 1 To x + 1
						For y2 = y - 1 To y + 1
							If x2 < 0 Or y2 < 0 Or x2 >= sizeX Or y2 >= sizeY Then Continue
						
							Local col:TMapColorMarker = colors[x2, y2]
							
							If col And col.baumode = 2 Then
								If Not buildings[x2, y2] Then
									found = 1
									Exit
								End If
							End If
						Next
						
						If found = 1 Then Exit
					Next
					If found = 0 Then
						REASON_BUILD_NOT_POSSIBLE = "Keine Großen steine gefunden!"
						Return 0
					End If
					Return found
				Default
					If isBlocked(x, y) = 1 Then
						REASON_BUILD_NOT_POSSIBLE = "Baugrund blockiert."
						Return 0
					Else
						Select house.id
							Case 0, 1 'holz oder stein
								If FindArroud(house.id, x, y) = 1 Then
									REASON_BUILD_NOT_POSSIBLE = "Bereits zuviele " + house.name + " in der nähe!"
									Return 0
								End If
						End Select
						If _tmp
							If _tmp.possible() Then
								Return 1
							EndIf
						Else
							Return 1
						endif
						Return 0
					EndIf
			End Select
		Return 0
	End Method
	Method FindArroud:Int(houseID:Int, x:Int, y:Int) ' sucht die 8 felder um x,y ab, ob dort schonmal houseID vorkommt! 1 -> ja, 0 -> nein 
		Local x2:Int, y2:Int
		For x2 = x - 1 To x + 1
			If x2 < 0 Or x2 >= sizeX Then Continue
			
			For y2 = y - 1 To y + 1
				If y2 < 0 Or y2 >= sizeY Then Continue
				
				Local b:Tbuilding = Self.buildings[x2, y2]
				
				If b Then
					If THouse(b) Then
						If THouse(b).id = houseID Then Return 1
					End If
				End If
			Next
		Next
		
		Return 0
	End Method
	Method SetHouse:Int(x:Int, y:Int, house:THouse)
		If x < 0 Or y < 0 Or x >= sizeX Or y >= sizeY Then Return - 1
		
		Select house.id
			Case 100, 102 'eisenmine, goldmine!
				'braucht boden id 21 !
				Local x2:Int, y2:Int
				Local found:Int = 0
				For x2 = x - 1 To x + 1
					If x2 < 0 Or x2 >= sizeX Then Continue
				For y2 = y - 1 To y + 1
				
					If y2 < 0 Or y2 >= sizeY Then Continue
					
					If houses[x2, y2] = 21 Then
						If Not buildings[x2, y2] Then
							x = x2
							y = y2
							found = 1
							Exit
						End If
					End If
				Next
				If found = 1 Then Exit
				Next
				
				If Not found Then Return 0
		End Select

		

		
		If Tressource.doBuild(house) Then
		
		Local str:String = "HOUS" + (house.id + 128)
		
		Local _tmp:TBuildedHelper
		
		If TMapData.buildedList.contains(str) Then
			_tmp = TBuildedHelper(TMapData.buildedList.valueForKey(str))
		EndIf

		If _tmp Then _tmp.builded:+1
		
			Local nhouse:THouse = THouse.CopyBySrc(house)
		
			If house.id = 127 Then
				'eine burg soll gebaut werden.
				If tgame.Burg Then
				
					'die platzhalter löschen.
					For Local _x2:Int = tgame.Burg.posx - 1 To tgame.Burg.posx
						If _x2 < 0 Or _x2 >= sizeX Then Continue
						
						For Local _y2:Int = tgame.Burg.posy - 1 To tgame.Burg.posy
							If _y2 < 0 Or _y2 >= sizeY Then Continue
							
							If TBuilding_placeholder(Self.buildings[_x2, _y2]) Then
								Self.buildings[_x2, _y2] = Null
							EndIf
						Next
					Next
				
					Tbuilding.KillBuilding(tgame.burg)
					
					
				End If
				tgame.Burg = nhouse
			EndIf
		
			For Local res:Tressource = EachIn tgame.Ressources
				Tressource.AddProducer(nhouse)
			Next
			
			Self.buildings[x, y] = nhouse
			Self.buildings[x, y].posx = x
			Self.buildings[x, y].posy = y
			
			Select nhouse.id
				Case 100, 101, 102, 103, 127
					Local p1:TBuilding_placeholder = New TBuilding_placeholder
					Local p2:TBuilding_placeholder = New TBuilding_placeholder
					Local p3:TBuilding_placeholder = New TBuilding_placeholder
					
					p1.real_posx = x
					p1.real_posY = y
					p2.real_posx = x
					p2.real_posY = y
					p3.real_posx = x
					p3.real_posY = y
	
					p1.building = nhouse
					p2.building = nhouse
					p3.building = nhouse
					
					Self.buildings[x - 1, y - 1] = p1
					Self.buildings[x - 1, y] = p2
					Self.buildings[x, y - 1] = p3
					If nhouse.id = 127 Then
						UpdateTowersInRange()
					End If
			End Select

			Return 1
		EndIf
		
		Return 0
	End Method
	Method SetBlock:Int(x:Int, y:Int, id:Int)
		If x < 0 Or y < 0 Or x >= sizeX Or y >= sizeY Then Return 0
		
		If id > 50 Then
			houses[x, y] = id
		Else
			blocks[x, y] = id
		EndIf
		
		Return 1
	End Method
	Method GetBuilding:TBuilding(x:Int, y:Int)
		If x < 0 Or y < 0 Or x >= sizeX Or y >= sizeY Then Return Null

		Local ret:Tbuilding = buildings[x, y]
		
		If TBuilding_placeholder(ret) Then
			ret = TBuilding_placeholder(ret).building
		EndIf
		Return ret
	End Method
	Method GetBlock:Int[] (x:Int, y:Int)
		If x < 0 Or y < 0 Or x >= sizeX Or y >= sizeY Then Return Null
		
		Local ret:Int[] = New Int[2]
		ret[0] = blocks[x, y]
		If buildings[x, y] Then
		'	ret = ret[..3]
			ret[1] = buildings[x, y].id + 128 - (Not Tbuilding(buildings[x, y]) * 128)
		Else
			ret[1] = - 1
		EndIf


		Return ret
	End Method
	Method GetGround:Int(x:Int, y:Int)
		If x < 0 Or y < 0 Or x >= sizeX Or y >= sizeY Then Return - 1
		
		Return blocks[x, y]
	End Method
	Method isBlocked:Int(x:Int, y:Int)
		If x < 0 Or y < 0 Or x >= sizeX Or y >= sizeY Then Return 1

		If buildings[x, y] Then
			Return 1
		ElseIf houses[x, y] Then
			Return 1
		ElseIf blocks[x, y] >= 20 Or blocks[x, y] = 0 Or blocks[x, y] = 10 Then Return 1
		
	
		endif
		Return 0
	End Method
	
	Function LoadMap:Tlandschaft(file:String = "map.png")
		Local pix:TPixmap = LoadPixmap(file)
		
		If pix Then Print "Lade : " + file
		
		Local map:TLandschaft = New TLandschaft
		
		map.sizeX = pix.width
		map.sizeY = pix.height
		
		TUnitSektor.PrepareUnitSektors(map.sizeX / 8, map.sizeY / 8)
		
		SeedRnd(FileSize(file) * 2 + FileTime(file))
		map.blocks = New Byte[pix.width, pix.height]
		map.houses = New Byte[pix.width, pix.height]
		map.buildings = New Tbuilding[pix.width, pix.height]
		map.__wegsucheMap = New Byte[pix.width, pix.height]
		map.colors = New TMapColorMarker[pix.width, pix.height]
		
		
			
		'Liste bekannter farben erstellen:
		Local colors:Int[][]
		
		Local _index:Int = 0
		For Local i:Int = 0 Until Len(TKachel.list)
			If TKachel.list[i] Then
				_index = Len(colors)
				colors = colors[.._index + 1]
				
				colors[_index] = New Int[2]
				colors[_index][0] = TKachel.list[i].col
				colors[_index][1] = i
				
			EndIf
		Next
		
		_index:Int = 0
		Local _cnt:Int = 0
		Local _found:Int = 0
		
		SeedRnd(MilliSecs() + FileSize("map.png"))
		
		TUnitController.burgX = pix.width / 2
		TUnitController.burgY = pix.width /2
		
		For Local x:Int = 0 Until pix.width
		For Local y:Int = 0 Until pix.height
			Local pixel:Int = pix.ReadPixel(x, y)
			_found = 0
			Local sp:Int = CheckSpawnPlace(pixel)
			If sp > 0 Then
				Select sp
					Case 1 'erde kachel +spawnpunkt
						map.blocks[x, y] = 1
						TWave.spawnPlace:+[[x, y]]
					Case 2 'grass kachel + spawnpunkt
					map.blocks[x, y] = 2
					TWave.spawnPlace:+[[x, y]]
				End Select
			Else
			
			For _index = 0 Until Len(colors)
				If colors[_index][0] = pixel Then
					If colors[_index][1] > 50 Then
						'debug - burg!
						map.blocks[x, y] = 2 'grass
						map.colors[x, y] = TMapColorMarker.Create(1)
					ElseIf colors[_index][1] = 25 Then
						map.blocks[x, y] = 2 'grass
						map.houses[x, y] = 25
					Else
						map.blocks[x, y] = colors[_index][1]
						
						If map.blocks[x, y] > 10 Then
							map.colors[x, y] = TMapColorMarker.Create(0)
						End If
					End If
					
					_found = 1
					Exit
				End If
			Next
			
			If Not _found Then
				map.colors[x, y] = TMapColorMarker.Create(2)
				map.blocks[x, y] = 2 'grass
			EndIf
			
			End If
		Next
		Next
		
		Local size:Int = 4 'nur durch 2 teilbare werte möglich!
		
		Local img:TImage = CreateImage(pix.width * size * 2, pix.height * size * 2)
		Local mmap:TPixmap = LockImage(img)
		mmap.ClearPixels($00000000)
		'genug platz eingeräumt.
		
		Local zentrum:Int = img.width / 2
		Local px:Int, py:Int
		Local hid:Int, bid:Int
		
		
				
		For Local x:Int = 0 Until pix.width
		For Local y:Int = 0 Until pix.height
			px = -(x * size) + (y * size) + size + zentrum
			py = (x + y) * size / 2
			
			If px < 0 Or px >= mmap.width Or py < 0 Or py >= mmap.height Then Continue
			
			hid = map.houses[x, y]
			bid = map.blocks[x, y]
			
			If hid Then
				Local col:Int = TKachel.list[hid].col
				For Local i:Int = 0 Until size
				For Local j:Int = 0 Until size
					mmap.WritePixel(px + i, py + j, col)
				Next
				Next
			ElseIf bid Then
				Local col:Int = TKachel.list[bid].col
				For Local i:Int = 0 Until size
				For Local j:Int = 0 Until size
					mmap.WritePixel(px + i, py + j, col)
				Next
				Next
			End If
			
			
		Next
		Next

		
		Local __mm:TPixmap = map.DrawMinimapFULL(8)
		Local mmap2:TPixmap = ShrinkPixmap(__mm)
		
		map.minimap = GLTexFromPixmap(mmap2)
		map.PostLoadfilter()
		Return map
		
		Function CheckSpawnplace:Int(col:Int)
			Local r:Byte = (col & $00ff0000) Shr 16
			Local g:Byte = (col & $0000ff00) Shr 8
			Local b:Byte = (col & $000000ff)
			
			If r = 128 And g = 255 And b = 0 Then
				'grass + spawnpunkt.
				Return 2
			End If
			If r = 255 And g = 100 And b = 70 Then
				'erde + spawnpunkt
				Return 1
			End If
		End Function
		
		Function ShrinkPixmap:TPixmap(pix:TPixmap)
			Local x:Int, y:Int
			
			Local x1:Int = pix.width, x2:Int
			Local y1:Int = pix.height, y2:Int
			
			Local r:Byte, g:Byte, b:Byte, a:Byte
			
			
			For x = 0 Until pix.width
			For y = 0 Until pix.height
				Local col:Int = pix.ReadPixel(x, y)
				extractColor(r, g, b, a, col)
				
				If r + b + g > 0 Then
					If x < x1 Then x1 = x
					If x > x2 Then x2 = x
					If y < y1 Then y1 = y
					If y > y2 Then y2 = y
				
				Else
					pix.WritePixel(x, y, $00000000)
					
				End If
				
			Next
			Next
			
		Local newimg:TImage = CreateImage(x2 - x1, y2 - y1 + 1)
		Local newpix:TPixmap = LockImage(newImg)
		
		For y = y1 To y2
			Local bp:Byte Ptr = newpix.PixelPtr(0, y - y1)
			Local bp2:Byte Ptr = pix.PixelPtr(x1, y)
			
			MemCopy(bp, bp2, (x2 - x1) * 4)
		Next
		
		UnlockImage(newimg)
		Return newpix
	
			Function extractColor(r:Byte Var, g:Byte Var, b:Byte Var, a:Byte Var, color:Int)
				r = (color & $00ff0000) Shr 16
				g = (color & $0000ff00) Shr 8
				b = (color & $000000ff)
				a = (color & $ff000000) Shr 24

			End Function
		
		End Function
	End Function
	
	Method PostLoadfilter:Int()
		Local x:Int, y:Int
		Local _inRangeID:Int = 0
		
		SeedRnd(sizeX * sizeY)
		
		For x = 0 Until sizeX
		For y = 0 Until sizeY
			If blocks[x, y] = 20 Then
				_inRangeID = InRange_STONE
				Local cnt:Int = 1
				For Local x2:Int = x To x + 1
				For Local y2:Int = y To y + 1
					If x2 < 0 Or y2 < 0 Or x2 >= sizeX Or y2 >= sizeY Then Continue
					
					If blocks[x2, y2] = 20 Then cnt:+1
				Next
				Next
				
				If cnt > 4 And Rand(0, 1) = 0 Then
					'2x2 steine sind hier.
					houses[x + 1, y + 1] = 21
					blocks[x + 1, y + 1] = 0
					blocks[x + 1, y] = 0
					blocks[x, y + 1] = 0
					blocks[x, y] = 0
					
					colors[x + 1, y + 1] = TMapColorMarker.Create(2, Null, _inRangeID)
					colors[x, y + 1] = TMapColorMarker.Create(2, Null, _inRangeID)
					colors[x + 1, y] = TMapColorMarker.Create(2, Null, _inRangeID)
					colors[x, y] = TMapColorMarker.Create(2, Null, _inRangeID)
					
				End If
			ElseIf houses[x, y] = 25 Then
				_inRangeID = InRange_TREE
				blocks[x, y] = 2 'grass underlay 
				houses[x, y] = 26 'erstmal nur die dicken bäume! :)
				colors[x, y] = TMapColorMarker.Create(0, Null, _inRangeID)
			ElseIf blocks[x, y] = 10 Then
				colors[x, y] = TMapColorMarker.Create(0)
			ElseIf blocks[x, y] = 0 Then
				If Not colors[x, y] Then colors[x, y] = TMapColorMarker.Create(0)
			ElseIf blocks[x, y] = 21 Then
				'nix tun, sollte oben gesetzt sein :O
			ElseIf blocks[x, y] <= 10 Then
				colors[x, y] = TMapColorMarker.Create(1)
			Else
				colors[x, y] = TMapColorMarker.Create(0)
			EndIf
			
			'bissl hardcore shit =)
			
		Next
		Next
		
		'nochmal ordentlich hardcode. Zulasten der ladezeit, aber es verfolg höhere ziele!
		'die id's für steine etc auch im "umfeld" eintragen, um bauabhängigkeiten zu realisieren (und das ohne viel runtime-aufwand!)
		SeedRnd(MilliSecs())
		For Local x:Int = 0 Until sizeX
		For Local y:Int = 0 Until sizeY
			Local inrange:Int = 0
			
			Select houses[x, y]
				Case 0 'nixtun
				Case 25, 26 'bäume
					inrange = InRange_TREE
				Case 20, 21 'steine
					inrange = InRange_STONE
			End Select
			
			If inrange > 0 Then
			
				For Local x2:Int = x - 4 To x + 4
					If x2 < 0 Or x2 >= sizeX Then Continue
					For Local y2:Int = y - 4 To y + 4
						If y2 < 0 Or y2 >= sizeY Then Continue
						
						If Pythi(x, y, x2, y2) <= 4 Then
							
								Local c:TMapColorMarker = colors[x2, y2]
								
								If c Then
									If (c.inrange & inrange) = 0 Then
								
										c.inrange = c.inrange | inrange
								
									EndIf
								Else
									colors[x2, y2] = TMapColorMarker.Create(0, Null, inrange)
								End If
							
						End If
					Next
				Next
			End If
			
		
		Next
		Next
	End Method
	
	Method DrawList:Int()
		
		For Local tkm:TFieldmarker = EachIn Self.markerList
				tkm.Draw()
		Next
	End Method

	Method DrawMinimapFULL:TPixmap(scale:Float)
		Local x:Int, y:Int
		Local _x:Int, _y:Int
		Local ox:Float = 0.0
		Local oy:Float = 0.0
		
		Local posx:Float, posy:Float, w:Float, h:Float
		
		Local k:TKachel
		
		Local houseList:TList = CreateList()
		

		
		'matrix zoomen
		zoomMatrix(scale * 2)
		
		SetClsColor(200, 200, 200)
		SetMaskColor(200, 200, 200)
		Cls 'krams löschen.
		glDisable(GL_DEPTH_TEST)
		For _x:Int = 0 Until sizeX
			For _y:Int = 0 Until sizeY
			If _x < 0 Or _y < 0 Or _x >= sizeX Or _y >= sizeY Then Continue
			
			x = _x - (sizeX / 2) '- camX
			y = _y - (sizeY / 2) '- camY
			
			posx = (x * (32)) - (y * (32)) + ox
			posy = (x * (16 )) + (y * (16)) + oy
			
			
			
			Local id:Int = blocks[_x, _y]
			Local id_house:Int = houses[_x, _y]
				TKachel.list[id].Draw(posx, posy)
				
				markerList.AddLast(TKachelMarker.Create(posx, posy, TKachel.list[id]))
				
				If id_house Then houseList.AddLast(TKachelMarker.Create(posx, posy, TKachel.list[id_house])) 'TKachel.list[id_house].Draw(posx, posy)
	
			

			Next
		Next
		
		For Local tkm:TKachelMarker = EachIn houseList
			tkm.Draw()
			markerList.AddLast(tkm)
		Next
		
		Local img:TImage = CreateImage(resx, resy, 1)
		GrabImage(img, 0, 0)
		Local ret:TPixmap = LockImage(img)
		
		
		zoomMatrix(1)
		SetClsColor(0, 0, 0)
		Cls
		glEnable(GL_DEPTH_TEST)
		Return ret
	End Method
	
	Method Draw:Int()
		If update = 0 And _onBuild = 0 Then
			Return Self.DrawList()
		Else
			Self.markerList.Clear()
			Self.towermarkerList.Clear()
		End If
		
		Local x:Float = 0.0
		Local y:Float = 0.0
		Local _x:Float = 0.0
		Local _y:Float = 0.0
		
		Local _posx:Float, _posy:Float, w:Float, h:Float
		
		Local k:TKachel
		
		Local houseList:TList = CreateList()
		Local towerlist:TList = CreateList()
		
		Local useColors:Int = 0
		Local baumode:Int = 0
		Local border:Int = 0
		Local inRange:Int = 0
		Local sA:Int = -1 'search arround.
		If _onBuild = 1 Then
			useColors = 1
			
			Local tow:TBuilding = TBuilding(TGamecontrol.extra)
			
			If tow Then
				baumode = 1
				
				If THouse(tow) Then
					Select THouse(tow).id
						Case 100, 101, 102, 103
							baumode = 2
						Case 0, 1
							baumode = 1
							sA = THouse(tow).id
						Default
							baumode = 1
					End Select
					Select THouse(tow).id
						Case 0 'holzfäller
							inRange = InRange_TREE
						Case 1' steinmetz
							inRange = InRange_STONE
					End Select
				End If
			End If
		EndIf
		For _x:Float = camX - (25.0) Until camX + (25.0)
			If _x < 0 Or _x >= sizeX Then Continue
			
			For _y:Float = camY - 25.0 Until camY + 25.0
			If _y < 0 Or _y >= sizeY Then Continue
			
			x = Int(_x) - (camX)
			y = Int(_y) - (camY)
		
			_posx = (x * (32.0)) - (y * (32.0)) - 32.0
			_posy = (x * (16.0)) + (y * (16.0)) - 16.0
		
			If _posx < - (resXHalf) - 64 Or _posy < - (resYHalf) - 64 Or _posx > (resXHalf) + 64 Or _posy > (resYHalf) + 64 Then Continue
			
			Local __col:Float[]
			
			If useColors Then
				
				Local _c:TMapColorMarker = Self.colors[_x, _y]
				
			
				If _c And _c.col Then
					__col = _c.col
					glColor3f(_c.col[0], _c.col[1], _c.col[2])
					_c.change:-1
					If _c.change <= 0 Then _c.col = Null
				ElseIf _c
					If (_c.inRange & InRange_TOWER) <> InRange_TOWER Then
						glColor3f(0.25, 0.25, 0.25)
						__col = [0.25, 0.25, 0.25]
					ElseIf inRange > 0 Then
						If sA > - 1 And FindArroud(sA, _x, _y) = 1 Then
							glColor3f(0.25, 0.25, 0.25)
							__col = [0.25, 0.25, 0.25]
						ElseIf (_c.inRange & inRange) = inRange Then
							Select _c.baumode
								Case baumode
									glColor3f(1.0, 1.0, 1.0)
									__col = [1.0, 1.0, 1.0]
								Default
									glColor3f(0.25, 0.25, 0.25)
									__col = [0.25, 0.25, 0.25]
							End Select
						Else
					
							glColor3f(0.25, 0.25, 0.25)
							__col = [0.25, 0.25, 0.25]
						
						EndIf
					ElseIf inRange = 0
						Select _c.baumode
							Case baumode
							'	Print "Baumode " + baumode
								glColor3f(1.0, 1.0, 1.0)
								__col = [1.0, 1.0, 1.0]
							Default
								glColor3f(0.25, 0.25, 0.25)
								__col = [0.25, 0.25, 0.25]
						End Select
					Else
						glColor3f(1.0, 0.25, 0.25)
						__col = [0.25, 0.25, 0.25]
					EndIf
				Else
					glColor3f(0.5, 1.0, 0.0)
					__col = [0.5, 1.0, 1.0]
				End If
			End If


			Local id:Int = blocks[_x, _y]
			Local id_house:Int = houses[_x, _y]
			Local tower:TBuilding = buildings[_x, _y]
			
					
					TKachel.list[id].Draw(_posx, _posy)
			
				
				Local wp:TWegpunkt = wegpunkte[_x, _y]
				
				markerList.AddLast(TKachelMarker.Create(_posx, _posy, TKachel.list[id], wp))
				If id_house Then
					houseList.AddLast(TKachelMarker.Create(_posx, _posy, TKachel.list[id_house], Null, 0, __col))
				EndIf
				If tower Then
					houseList.addLast(TBuildingMarker.Create(_posx, _posy, Tower))
				EndIf
				
			

			Next
		Next
		
		For Local tkm:TFieldmarker = EachIn houseList
				tkm.Draw()
				markerList.AddLast(tkm)
		Next
		
		towerlist.clear()
		houseList.Clear()
		update = 0
	End Method
End Type

rem
	Hält temporäre hilfsinformationen wärend des baumodus.
	Grund hierfür ist die anzeige der "Bebaubarkeit" des bodens, bedingt durch unitentfernung.
end rem
Type TMapColorMarker
	
	Field baumode:Int = 1
	
	Field inRange:Int 'verschiedene bits setzbar für sachen die in der umgebung sind.
					  'benutzbar für alles: bauabhängigkeiten, und äh ja, bauabhängigkeiten.
	
	Field col:Float[]
	Field change:Int = 10
	Function Create:TMapColorMarker(mode:Int, color:Float[] = Null, inRange:Int = 0)
		Local tmcm:TMapColorMarker = New tmapcolormarker
		tmcm.baumode = mode
		If color Then
			tmcm.col = color[..3]
		EndIf
		tmcm.inRange = inRange
		Return tmcm
	End Function
End Type

Type TKachel
	Global list:TKachel[]
	
	Field name:String
	Field uv:Float[]
	Field w:Float
	Field h:Float
	Field ox:Float = 0.0
	Field oy:Float = 0.0
	Field col:Int = 0
	Field spos:Int[] = New Int[8]
	
	Method Draw(posx:Float, posy:Float) Abstract
	
	Method DrawAsBorder(posx:Float, posy:Float, borderVal:Int) Abstract
	
	Method calcShadow(angle:Float, laenge:Float)
		Local _sin:Float = Sin(angle)
		Local _cos:Float = Cos(angle)
		
		Local x:Float = w * 0.5
		Local y:Float = h * 0.75
		
		
		'W / H offset berechnen:
		
		Local _xO:Float = (-_sin * (w * 0.5))
		Local _yO:Float = (_cos * (w * 0.5))
		Local _xo2:Float = (-_sin * (w * 0.5)) * laenge
		Local _yo2:Float = (_cos * (w * 0.5)) * laenge
		
	
		
		Local _wo:Float = (_cos * w) * laenge '*2
		Local _ho:Float = (_sin * h) * laenge
	
			spos[0] = _xo2 + x + _wo
			spos[1] = _yo2 + y + _ho '+ (oy * 0.5)
			
			spos[2] = - _xo2 + x + _wo
			spos[3] = - _yo2 + y + _ho '+ (oy * 0.5)

			spos[6] = _xO + x
			spos[7] = _yO + y '+ (oy * 0.5)

			spos[4] = - _xO + x
			spos[5] = - _yO + y '+ (oy * 0.5)
	End Method
	
	Function LoadData(path:String = "Blockdata\Data.ini")
		Local ini:TInifile = Tinifile.Load(path)
		
		TKachel.list = TKachel.list[..1]
		
		For Local header:TIniheader = EachIn ini.data.Values()
			If header.name.ToInt() > 999 Then Continue 'unit!
			
			Print "lade header: " + header.name
			If header.name.ToInt() >= Len(TKachel.list) Then
				TKachel.list = TKachel.list[..header.name.toInt() + 1]
			EndIf
			
			Local id:Int = header.name.ToInt()
	
					TKachel.list[id] = TKachel.Create(header.name, ini)
			
			
		Next
		
	End Function
	
	Function Create:TKachel(h:String, ini:Tinifile)
		Local w:Float = 1024.0
		Local _h:Float = 1024.0
		
		Local x:Int = ini.geti(h, "x")
		Local y:Int = ini.geti(h, "y")
		Local sx:Int = ini.geti(h, "width")
		Local sy:Int = ini.geti(h, "height")
		
		
		Local id:Int = h.ToInt()
		
		Local k:TKachel
		
		If id < 15 Then
		
				k = New TKachel_Floor

		Else
			k = New TKachel_HOUSE
		End If
		
		k.name = ini.gets(h, "Name")
		k.uv = [x / w, y / _h, (x + sx) / w, (y + sy) / _h]
		k.w = sx
		k.h = sy
		k.ox = Float(ini.geti(h, "offsetX"))
		k.oy = Float(ini.geti(h, "offsetY"))
		
		If k.w > 64 Then
			k.ox = -(k.w - 64.0) * 0.5
		End If
		If k.oy = 0 then
			k.oy = -(k.h - 32.0) * 1.20
		EndIf
		
		Local r:Byte = ini.geti(h, "r")
		Local g:Byte = ini.geti(h, "g")
		Local b:Byte = ini.geti(h, "b")
		
		k.calcShadow(shadowAngle, shadowLen)

		k.col = (255 Shl 24) | (r Shl 16) | (g Shl 8) | (b)
		
		Return k
	End Function
End Type

'TKachel_floor_border -> Zeichnet 2 kacheln - unterliegende farbe, oberliegende farbe!

Type TKachel_Floor Extends Tkachel
	Method Draw(posx:Float, posy:Float)
		posx:+ox
		posy:+oy
		Local col:Float[] = New Float[4]
		
		glGetFloatv(GL_CURRENT_COLOR, col)
		
			glBegin(GL_QUADS)
			
				glTexCoord2d(uv[0], uv[1])
				glVertex3d(posx, posy, -999.5)
	
				glTexCoord2d(uv[2], uv[1])
				glVertex3d(posx + w, posy, -999.5)
	
				glTexCoord2d(uv[2], uv[3])
				glVertex3d(posx + w, posy + h, -999.5)
	
				glTexCoord2d(uv[0], uv[3])
				glVertex3d(posx, posy + h, -999.5)
				
				
				glColor4f(col[0], col[1], col[2], col[3])
			glEnd()
	End Method
	Method DrawAsBorder(posx:Float, posy:Float, borderVal:Int)
		posx:+ox
		posy:+oy
			
			Local col:Float[] = New Float[4]
			glGetFloatv(GL_CURRENT_COLOR, col)
		
			glBegin(GL_QUADS)
				
				If borderVal & 1 Then
					glColor4f(col[0], col[1], col[2], 0.0)
				Else
					glColor4f(col[0], col[1], col[2], col[3])
				EndIf
				glTexCoord2d(uv[0], uv[1])
				glVertex3d(posx, posy, -999.5)
	
				If borderVal & 2 Then
					glColor4f(col[0], col[1], col[2], 0.0)
				Else
					glColor4f(col[0], col[1], col[2], col[3])
				EndIf
				
				glTexCoord2d(uv[2], uv[1])
				glVertex3d(posx + w, posy, -999.5)
	
				If borderVal & 4 Then
					glColor4f(col[0], col[1], col[2], 0.0)
				Else
					glColor4f(col[0], col[1], col[2], col[3])
				EndIf
				
				glTexCoord2d(uv[2], uv[3])
				glVertex3d(posx + w, posy + h, -999.5)
	
				If borderVal & 8 Then
					glColor4f(col[0], col[1], col[2], 0.0)
				Else
					glColor4f(col[0], col[1], col[2], col[3])
				EndIf
				
				glTexCoord2d(uv[0], uv[3])
				glVertex3d(posx, posy + h, -999.5)
				
				glColor4f(col[0], col[1], col[2], col[3])
			glEnd()
	End Method
End Type
Type TKachel_HOUSE Extends TKachel	

	Method Draw(posx:Float, posy:Float)
		posx:+ox
		posy:+oy
		Local offsetX:Float = w * 0.2
		Local offsetY:Float = 0'-h * 0.1
		
			'SCHATTEN!!

			
		Local col:Float[] = New Float[4]
		
		glGetFloatv(GL_CURRENT_COLOR, col)
			
		glBegin(GL_QUADS)
			
			glColor4f(shadowCol[0], shadowCol[1], shadowCol[2], shadowCol[3])
			
			Local uvMinus:Float = 0'-h * 0.1 / 1024.0
			glTexCoord2d(uv[0], uv[1])
			glVertex3d(spos[0] + posx, spos[1] + posy, -999)
			
			glTexCoord2d(uv[2], uv[1])
			glVertex3d(spos[2] + posx, spos[3] + posy, -999)
			
			glTexCoord2d(uv[2], uv[3] - uvMinus)
			glVertex3d(spos[4] + posx, spos[5] + posy, -999)
			
			glTexCoord2d(uv[0], uv[3] - uvMinus)
			glVertex3d(spos[6] + posx, spos[7] + posy, -999)

			glColor4f(col[0], col[1], col[2], col[3])
		
			'//SCHATTEN!!
		
			glTexCoord2d(uv[0], uv[1])
			glVertex3d(posx, posy, (posy + h) * 2 - 2)
			
			glTexCoord2d(uv[2], uv[1])
			glVertex3d(posx + w, posy, (posy + h) * 2 - 2)
			
			glTexCoord2d(uv[2], uv[3])
			glVertex3d(posx + w, posy + h, (posy + h) * 2 - 2)
			
			glTexCoord2d(uv[0], uv[3])
			glVertex3d(posx, posy + h, (posy + h) * 2 - 2)
		
			
		glEnd()
	End Method
	Method DrawAsBorder(posx:Float, posy:Float, borderVal:Int)

		posx:+ox
		posy:+oy
			
			Local col:Float[] = New Float[4]
			glGetFloatv(GL_CURRENT_COLOR, col)
		
			glBegin(GL_QUADS)
				
				If borderVal & 1 Then
					glColor4f(col[0], col[1], col[2], 0.0)
				Else
					glColor4f(col[0], col[1], col[2], col[3])
				EndIf
				glTexCoord2d(uv[0], uv[1])
				glVertex3d(posx, posy, (posy + h) * 2)
	
				If borderVal & 2 Then
					glColor4f(col[0], col[1], col[2], 0.0)
				Else
					glColor4f(col[0], col[1], col[2], col[3])
				EndIf
				
				glTexCoord2d(uv[2], uv[1])
				glVertex3d(posx + w, posy, (posy + h) * 2)
	
				If borderVal & 4 Then
					glColor4f(col[0], col[1], col[2], 0.0)
				Else
					glColor4f(col[0], col[1], col[2], col[3])
				EndIf
				
				glTexCoord2d(uv[2], uv[3])
				glVertex3d(posx + w, posy + h, (posy + h) * 2)
	
				If borderVal & 8 Then
					glColor4f(col[0], col[1], col[2], 0.0)
				Else
					glColor4f(col[0], col[1], col[2], col[3])
				EndIf
				
				glTexCoord2d(uv[0], uv[3])
				glVertex3d(posx, posy + h, (posy + h) * 2)
				
				glColor4f(col[0], col[1], col[2], col[3])
			glEnd()
	End Method
End Type
Type TKachel_TOWER Extends TKachel

	Method Draw(posx:Float, posy:Float)
		posx:+ox
		posy:+oy
			
			glBegin(GL_QUADS)

			glTexCoord2d(uv[0], uv[1])
			glVertex3d(posx, posy, posy)
			
			glTexCoord2d(uv[2], uv[1])
			glVertex3d(posx + w, posy, posy)
			
			glTexCoord2d(uv[2], uv[3])
			glVertex3d(posx + w, posy + h, posy + h)
			
			glTexCoord2d(uv[0], uv[3])
			glVertex3d(posx, posy + h, posy + h)
			
			

			
		glEnd()
	End Method
	Method DrawAsBorder(posx:Float, posy:Float, borderVal:Int)
		
	End Method
End Type

Type TbuildingMarker Extends TFieldmarker

	Field Tower:Tbuilding
	
	Function Create:TbuildingMarker(posx:Float, posy:Float, tower:Tbuilding)
		Local ttm:TbuildingMarker = New TbuildingMarker
		
		ttm.posx = posx
		ttm.posy = posy
		ttm.tower = tower
		
		Return ttm
	End Function
	
	Method draw()
		If Self.Tower Then
			Local fr:TFrame = Self.Tower.frame
			If fr Then
				glBindTexture(GL_TEXTURE_2D, TFrame.texture[FRAMESET_TOWER])
				fr.Draw(posx, posy)
				
				If Self.Tower = tgame.FocusObject Then
					glBlendFunc(GL_SRC_ALPHA, GL_ONE)
					
					fr.Draw(posx, posy)
					
					glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
				End If
			EndIf
		End If
	End Method
End Type

Type TFieldmarker
	Field posx:Float, posy:Float
	Field wp:TWegpunkt
	
	Field color:Float[]
	
	Method Draw() Abstract
End Type

Type TKachelMarker Extends TFieldmarker

	Field kachel:Tkachel
	Field isBorder:Int = 0 '1 bedeutet westen, 2 bedeutet norden, 4 bedeutet osten, 8 bedeutet süden.
	
	Function Create:TKachelMarker(posx:Float, posy:Float, kachel:Tkachel, wp:TWegpunkt = Null, hasBorder:Int = 0, color:Float[] = Null)
		Local tkm:TKachelMarker = New TKachelMarker
		tkm.posx = posx
		tkm.posy = posy
		tkm.kachel = kachel
		tkm.wp = wp
		tkm.color = color
		tkm.isBorder = hasBorder
		
		Return tkm
	End Function
	
	Method Draw()

		If Self.kachel Then
			glBindTexture(GL_TEXTURE_2D, tex)
		
			If color Then
				glColor3f(color[0], color[1], color[2])
				Self.kachel.Draw(posx, posy)
				glColor3f(1, 1, 1)
			Else
				Self.kachel.Draw(posx, posy)
			End If
			
		EndIf
	End Method
End Type