﻿Rem
	Ein Hilfs-type um maximale anzahl an gebäuden pro typ zu realisieren. 
	Liegt in TMapData in einer TMap
	
	author: PhillipK
end rem
Type TBuildedHelper
	Field builded:Int 'anzahl der bauten 
	Field maxBuilded:Int 'anzahl der maximalen bauten (wird nur bei "Capped" beachtet.")
	Field capped:Int
	
	Method possible:Int()
		If capped = 0 Then Return 1
		If builded < maxBuilded Then Return 1
		Return 0
	End Method
End Type

Rem
	Ein erster schritt richtung Mapdaten. Hier ein provisorischer loader, der mapdaten lädt.
	
	author: PhillipK
end rem
Type TMapData
	Global BurgX:Int
	Global BurgY:Int
	Global burg:TBuilding
	
	Global buildedList:TMap= CreateMap()
	
	Function LoadMapdata:TMapData(file:String)
		Local ini:TInifile = tinifile.Load(file)
		
		BurgX = ini.geti("General", "BurgX")
		BurgY = ini.geti("General", "BurgY")
		For Local header:TIniheader = EachIn ini.data.Values()
			If header.name = "General" Then
				For Local val:TInidata = EachIn header.data.Values()
					Select val.name
						Case "BurgX"
						'	TMapData.BurgX = val.val.ToInt()
						Case "BurgY"
						'	TMapData.BurgY = val.val.ToInt()
						Case "maxBuildings"
							FillMaxBuildingSlots(buildedList, val.val)
						
						Default
							FillRessourceByIniEntry(val.name, val.val)
							
					End Select
				Next
			
			Else
				TWave.CreateByIni(ini, header)
			EndIf
		Next
		Function FillMaxBuildingSlots:Int(list:TMap, str:String)
			Local sp:String[] = str.Split(";")
			
			Local entry:TBuildedHelper
			
			For Local i:Int = 0 Until Len(sp)
				If Len(sp[i]) > 0 Then 'kein leeres dingsi.
					If entry Then 'momentan ein eintrag offen der einen wert erwartet.
						entry.maxBuilded = sp[i].ToInt()
						entry = Null 'leeren
					Else
						'kein eintrag offen: id anlegen.
						entry = New TBuildedHelper
						entry.builded = 0
						entry.capped = 1
						Local preString:String
						
						Select True
							Case sp[i].ToInt() > 127 'eine THouse id.
								preString = "HOUS" + sp[i].ToInt()
							Case sp[i].ToInt() < 128 'eine TTower id.
								preString = "TOWE" + sp[i].ToInt()
						End Select
						
						list.Insert(preString, entry)
					EndIf
				EndIf
			Next
			
			Return 1
		End Function
		Function FillRessourceByIniEntry:tressource(name:String, value:String)
			Local res:Tressource = TRessource.GetByName(name)
			If Not res Then Return Null
		
			Local sp:String[] = value.Split("/")
			
			res.Actual = sp[0].ToInt()
			res._max = sp[1].ToInt()
			
		End Function
		
	End Function
End Type
