﻿Rem
	TTower verwaltet die Baubaren abwehrtürme. 
	Hier finden sich die informationen zu stärke etc, sowei mögliche kosten.
	
	TTower hält eine Globale liste mit den Türmen, sie sind über ihre id erhaltbar.
	
	author: PhillipK
End rem
Type Tbuilding
	Global list:TBuilding[][]
	
	Field id:Int
	Field name:String
	Field frame:TFrame
	
	Field posx:Int
	Field posy:Int
	
	Field maxhp:Int
	Field hp:Int
	Field defense:Int
	Field aggro:Int
	
	Field cost_wood:Int
	Field cost_metal:Int
	Field cost_gold:Int
	Field cost_population:Int
	Field cost_stone:Int
	
	Field isBuildable:Int = 1
	
	Field destroyed:Int = 0
	
	Field upgrades:Int[]
	
	Global PositionArray:Float[][][]
	
	Function GetByID:Tbuilding(id:Int)
		If id < 128 Then
			Return TTower.GetByID(id)
		Else
			Return THouse.GetByID(id - 128)
		End If
		Return null
	End Function
	
	Function UpdatePositionArray()
		PositionArray = Null
		PositionArray = PositionArray[..2] 'houses und tower
		
		
		For Local b:Tbuilding = EachIn THouse.activeHouse
			PositionArray[0]:+[[Float(b.posx), Float(b.posy)]]
		Next
		For Local b2:Tbuilding = EachIn TTower.activeTower
			PositionArray[1]:+[[Float(b2.posx), Float(b2.posy)]]
		Next
	End Function
	
	Method DoDamage:Int(val:Int, durchschlag:Float = 1.0)
	

		Local damage:Int = val * durchschlag

		hp:-damage
		tEffekt_numbers.Create(damage, [255, 0, 0], 10, 0, posx, posy, 0, 0, 500)
		
		If hp <= 0 Then
			Self.destroyed = 1
			TLandschaft.map.buildings[posx, posy] = Null
			If TTower(Self) Then
				For Local weapon:Tweapon = EachIn TTower(Self).weaponslots
					weapon.destroy()
				Next
				TTower(Self).weaponslots = Null
				TTower.activeTower.Remove(Self)
				
				
			End If
						
			TLandschaft.map.update = 1
			
		EndIf
	End Method
	
	Function KillBuilding:Int(building:Tbuilding)
		
		building.destroyed = 1
		TLandschaft.map.buildings[building.posx, building.posy] = Null
		TTower.activeTower.Remove(building)
		TLandschaft.map.update = 1
		
		Tressource.RemoveProducer(building)
		
		If tgame.FocusObject = building Then ClearFocus(1)
		
		If THouse(building) Then
			tgame.stats_losth:+1
			Local _h:THouse = THouse(building)
			
			THouse.activeHouse.Remove(_h)
		ElseIf TTower(building) Then
			tgame.stats_lostt:+1
			Local x:Int = building.posx
			Local y:Int = building.posy
			Local x2:Int, y2:Int
			Local col:TMapColorMarker
			
			For x2 = x - 4 To x + 4
				If x2 < 0 Or x2 >= TLandschaft.map.sizeX Then Continue
				
				For y2 = y - 4 To y + 4
					If y2 < 0 Or y2 >= TLandschaft.map.sizeY Then Continue
					
					If Pythi(x2, y2, x, y) <= 4 Then
						col = TLandschaft.map.colors[x2, y2]
						
						If col Then
							If (col.inRange & InRange_TOWER) = InRange_TOWER Then
								col.inRange = col.inRange - InRange_TOWER
							End If
						End If
					End If
				Next
			Next
			
			TLandschaft.map.UpdateTowersInRange()
		End If
		
		Local str:String = ""
		If THouse(building) Then
			str = "HOUS" + THouse(building).id
			If THouse(building).id = (138 - 128) Then tgame.Ressources[RES_POP]._Max:-2
		endif
		Local _tmp:TBuildedHelper = TBuildedHelper(TMapdata.buildedList.ValueForKey(str))
		Local cnt:Float
		
		If _tmp Then
			_tmp.builded:-1
		Else
			'wtf?
		End If
		
		UpdatePositionArray()
		
		tgame.Ressources[RES_GOLD].Minus(building.cost_population)
	End Function
End Type

Type TBuilding_placeholder Extends TBuilding
	Field real_posx:Int, real_posY:Int
	
	Field building:TBuilding
End Type

Const BUILDING_TOWER:Int = 0
Const BUILDING_HOUSE:Int = 1

Type THouse Extends TBuilding

	Global activeHouse:TList = CreateList()

	Field prod_w:Int
	Field prod_s:Int
	Field prod_p:Int
	Field prod_m:Int
	Field prod_g:Int
	
	Field updateRate:Int
	Field currUpdateRate:Int = Rand(0, 500)
	
	Function GetByID:THouse(id:Int)
		If Len(Tbuilding.list) <= BUILDING_HOUSE Then Return Null
		If Len(Tbuilding.list[BUILDING_HOUSE]) <= id Then Return Null
		If id < 0 Then Return Null
		
		Return THouse(Tbuilding.List[BUILDING_HOUSE][id])
	End Function
	
	Function CopyBySrc:THouse(h:thouse)
		Local t:THouse = New THouse
		
		t.cost_gold = h.cost_gold
		t.cost_metal = h.cost_metal
		t.cost_population = h.cost_population
		t.cost_stone = h.cost_stone
		t.cost_wood = h.cost_wood
		t.defense = h.defense
		t.hp = h.hp
		t.maxhp = h.maxhp
		t.id = h.id
		t.name = h.name
		t.prod_g = h.prod_g
		t.prod_m = h.prod_m
		t.prod_w = h.prod_w
		t.prod_s = h.prod_s
		t.prod_p = h.prod_p
		t.updateRate = h.updateRate
		t.frame = h.frame
		
		t.currUpdateRate = TGameControl.updateticks + Rand(200, 1000)
		
		activeHouse.addlast(t)
		
		Return t
	End Function
	
	Method GivesGold:Int()
		Return prod_g > 0
	End Method
	Method GivesMetal:Int()
		Return prod_m > 0
	End Method
	Method GivesWood:Int()
		Return prod_w > 0
	End Method
	Method GivesStone:Int()
		Return prod_s > 0
	End Method
	Method GivesPeople:Int()
		Return prod_p > 0
	End Method
	
	Function LoadData:Int(file:String)
		If FileType(file) = 0 Then
			RuntimeError("Konnte datei " + file + " nicht laden: Existiert nicht!")
		End If

		
		Local ini:TInifile = TInifile.Load(file)
		
		For Local header:TIniheader = EachIn ini.data.Values()
			Local h:String = header.name
			If h.ToInt() < 128 Then Continue
			
			Local t:thouse = New thouse
			
			t.frame = TFrame.GetTowerFrameByID(ini.geti(h, "Avatar"))
			t.name = ini.gets(h, "name")
			
			If Not t.frame Then RuntimeError("Konnte frame für Turm nicht laden. Towername: (" + h + ")" + t.name + " - FrameID: " + ini.geti(h, "Avatar"))
			
			t.id = h.ToInt() - 128
			
			t.defense = ini.geti(h, "Defense")
			t.hp = ini.geti(h, "HP")
			t.maxhp = t.hp
			
			t.cost_gold = ini.geti(h, "gold")
			t.cost_metal = ini.geti(h, "metal")
			t.cost_wood = ini.geti(h, "wood")
			t.cost_population = ini.geti(h, "population")
			t.cost_stone = ini.geti(h, "stone")
			
			t.prod_g = ini.geti(h, "ProdGold")
			t.prod_m = ini.geti(h, "ProdMetal")
			t.prod_p = ini.geti(h, "ProdPop")
			t.prod_s = ini.geti(h, "ProdStone")
			t.prod_w = ini.geti(h, "ProdWood")
			
			t.isBuildable = ini.geti(h, "isBuildable")
			
			
			
			t.updateRate = ini.geti(h, "URate")
			
			
			If Len(Tbuilding.list) <= BUILDING_HOUSE Then Tbuilding.list = Tbuilding.list[..BUILDING_HOUSE + 1]
			
			If Len(Tbuilding.list[BUILDING_HOUSE]) <= t.id Then
				Tbuilding.list[BUILDING_HOUSE] = Tbuilding.list[BUILDING_HOUSE][..t.id + 1]
			End If
			
			Tbuilding.list[BUILDING_HOUSE][t.id] = t
			
			Print "THouse " + t.name + " - id: " + t.id + " wurde geladen."
			Print "THouse produziert "+t.prod_g+"gold, "+t.prod_m+"metall, "+t.prod_p+"pop, "+t.prod_s+"stein, "+t.prod_w
		Next
	End Function
End Type

Type TTower Extends TBuilding
	
	Global activeTower:TList = CreateList()

	Global lastTower:TTower
	
	Field attack:Int

	Field weaponslots:tweapon[] 'länge = menge waffenlots 

	Field speed:Int
	Field rmin:Int
	Field rmax:Int

	Global updateTicks:Int = 0
	
	Global _stepper:Int = 0
	Global _cnt:Int = 7 'jeder 7te kriegt n update!
	
	Function Update:Int()
		Local _i:Int = 0
		Local i:Int = 0
		
		
		For Local tower:TTower = EachIn activeTower
			i = (i + 1) Mod _cnt
			
			If i <> _stepper Then Continue
			
			tower._update()
		
			_i:+len(tower.weaponslots)
		Next
		
		_stepper = (_stepper + 1) Mod _cnt
		wcount = _i
	End Function
	
	Global wcount:Int = 0
	
	Method _update:Int()
		If Self.hp <= 0 Then Return 0
		
		For Local I:Int = 0 Until Len(Self.weaponslots)
		    If Self.weaponslots[I] Then

				Self.weaponslots[I].Update()
		
			EndIf
		Next
		
		Return 1
	End Method
	
	Method AddWeapon:tweapon(WeaponID:Int)
		Local weapon:tweapon = tweapon.CreateFromID(WeaponID, Self)
		
		If Not weapon Then
			Return null
		EndIf
		For Local i:Int = 0 Until Len(weaponslots)
			If Not weaponslots[i] Then
				weaponslots[i] = weapon
				weapon.tower = Self
		
				Return weapon
			End If
		Next
		Return null
	End Method
	Method mountWeapon:Int(slot:Int, weapon:tweapon)
		If Not weapon Then Return - 1
		If Len(Self.weaponslots) <= slot Then Return 0
		
		Self.weaponslots[slot].tower = Null
		weapon.tower = Self
		Self.weaponslots[slot] = weapon
		
		Return 1
	End Method
	
	Function GetByID:TTower(id:Int)
		If Len(Tbuilding.list) <= BUILDING_TOWER Then Return Null
		If Len(Tbuilding.list[BUILDING_TOWER]) <= id Then Return Null
		If id < 0 Then Return Null
		
		Return TTower(Tbuilding.list[BUILDING_TOWER][id])
	End Function
	Function CopyTowerBySrc:TTower(src:TTower)
			Local ts:TTower = src
			Local td:TTower = New TTower
			
			td.id = ts.id
			td.name = ts.name
			td.frame = ts.frame
			td.attack = ts.attack
			td.defense = ts.defense
			td.hp = ts.hp
			td.maxhp = ts.hp
			td.speed = ts.speed
			td.rmax = ts.rmax
			td.rmin = ts.rmin
			
			td.aggro = ts.aggro
			td.cost_gold = ts.cost_gold
			td.cost_wood = ts.cost_wood
			td.cost_metal = ts.cost_metal
			td.cost_stone = ts.cost_stone
			td.cost_population = ts.cost_population
			td.weaponslots = ts.weaponslots[..]
			td.upgrades = ts.upgrades[..]
			
			If Len(td.upgrades) > 0 Then
				If td.upgrades[0] = - 1 Then
					td.upgrades = Null
				End If
			End If
			
			Print "UPGRADES gefunden: "
			For Local i:Int = 0 Until Len(td.upgrades)
				Print "Upgrade " + i + " -> " + td.upgrades[i]
			Next
			
			TTower.activeTower.AddLast(td)
			Return td
	End Function
	Function CopyTower:TTower(id:Int = -1, src:ttower = Null)
			Local ts:TTower = TTower(Tbuilding.list[BUILDING_TOWER][id])
			
			Local td:TTower = New TTower
			
			td.id = ts.id
			td.name = ts.name
			td.frame = ts.frame
			td.attack = ts.attack
			td.defense = ts.defense
			td.hp = ts.hp
			td.maxhp = ts.hp
			td.speed = ts.speed
			td.rmax = ts.rmax
			td.rmin = ts.rmin
			
			td.aggro = ts.aggro
			td.cost_gold = ts.cost_gold
			td.cost_wood = ts.cost_wood
			td.cost_metal = ts.cost_metal
			td.cost_stone = ts.cost_stone
			td.cost_population = ts.cost_population
			td.weaponslots = ts.weaponslots[..]
			
			td.upgrades = ts.upgrades[..]

			
			TTower.activeTower.AddLast(td)
			Return td
	
	End Function
	
	Method Upgrade:Int(toID:Int)
		Local ts:TTower = TTower.GetByID(toID)
		
		If ts Then
			Local td:TTower = Self
			
			td.id = ts.id
			td.name = ts.name
			td.frame = ts.frame
			td.attack = ts.attack
			td.defense = ts.defense
			td.hp = ts.hp
			td.maxhp = ts.hp
			td.speed = ts.speed
			td.rmax = ts.rmax
			td.rmin = ts.rmin
			
			td.aggro = ts.aggro
			td.cost_gold = ts.cost_gold
			td.cost_wood = ts.cost_wood
			td.cost_metal = ts.cost_metal
			td.cost_stone = ts.cost_stone
			td.cost_population = ts.cost_population
			
			td.weaponslots = td.weaponslots[..Len(ts.weaponslots)]
			
			td.upgrades = ts.upgrades[..]
			
			
			Return 1
		End If
		
		Return 0
	End Method

	Function LoadData:Int(file:String)
		If FileType(file) = 0 Then
			RuntimeError("Konnte datei " + file + " nicht laden: Existiert nicht!")
		End If
		
		Local ini:TInifile = TInifile.Load(file)
		
		For Local header:TIniheader = EachIn ini.data.Values()
			Local h:String = header.name
			
			If h.ToInt() > 127 Then Continue
			
			Local t:TTower = New TTower
			
			t.frame = TFrame.GetTowerFrameByID(ini.geti(h, "Avatar"))
			t.name = ini.gets(h, "name")
			
			If Not t.frame Then RuntimeError("Konnte frame für Turm nicht laden. Towername: (" + h + ")" + t.name + " - FrameID: " + ini.geti(h, "Avatar"))
			
			t.id = h.ToInt()
			t.attack = ini.geti(h, "Attack")
			t.defense = ini.geti(h, "Defense")
			t.speed = ini.geti(h, "Speed")
			t.hp = ini.geti(h, "HP")
			t.maxhp = t.hp
			
			t.rmin = ini.geti(h, "rangeMin")
			t.rmax = ini.geti(h, "rangeMax")
			
			t.cost_gold = ini.geti(h, "gold")
			t.cost_metal = ini.geti(h, "metal")
			t.cost_wood = ini.geti(h, "wood")
			t.cost_population = ini.geti(h, "population")
			t.cost_stone = ini.geti(h, "stone")
			
			t.upgrades = ini.getiArray(h, "upgrade", ";")
			t.isBuildable = ini.geti(h, "isBuildable")
	
			Local weaponslots:Int = ini.geti(h, "Waffenslots")
			
			t.weaponslots = New tweapon[weaponslots]
			
			If Len(Tbuilding.list) <= BUILDING_TOWER Then Tbuilding.list = Tbuilding.list[..BUILDING_TOWER + 1]
			
			If Len(Tbuilding.list[BUILDING_TOWER]) <= h.ToInt() Then
				Tbuilding.list[BUILDING_TOWER] = Tbuilding.list[BUILDING_TOWER][..h.toInt() + 1]
			End If
			
			Tbuilding.list[BUILDING_TOWER][h.ToInt()] = t
		Next
	End Function
End Type
