﻿rem
	TUmkreissuche ist ein Objekt was es ermöglicht, verschiedene dinge um umkreis zu finden.
	Hierfür wird die map und die startposition gebraucht. 
	Ziel ist es in erster linie, ein unit-nodesystem zu entwerfen, welches die steuerung übernimmt.
	
	author: PhillipK
end rem

Type TUmkreissuche
	
	Field list:TList = CreateList() 'Arbeitsliste. Hält TuksNodes
	
	Field sx:Int, sy:Int 'StartX, start.
	
	Field map:TLandschaft
	
	Field dirX:Int[] = [1, 0, -1, 0]
	Field diry:Int[] = [0, 1, 0, -1]
	
	Field visited:TUKSNode[,]
	Field offen:TUKSNode[,]
	
	Function Create:TUmkreissuche(sx:Int, sy:Int, map:TLandschaft)
		
		If map And (sx < 1 Or sy < 1 Or sx >= map.sizeX Or sy >= map.sizey) Then
			RuntimeError("Kritischer fehler: Die umkreissuche soll ausserhalb der map beginnen!")
			Return Null
		EndIf
		Local uks:TUmkreissuche = New TUmkreissuche
		
		uks.sx = sx
		uks.sy = sy
		
		uks.map = map
		
		uks.visited = New TUKSNode[uks.map.sizeX, uks.map.sizeY]
		uks.offen = New TUKSNode[uks.map.sizeX, uks.map.sizey]
		
		For Local x:Int = sx - 1 To sx
		For Local y:Int = sy - 1 To sy
			uks.visited[x, y] = TUKSNode.Create(x, y, 0, sx, sy, Null)
			uks.list.AddLast(uks.visited[x, y])
			uks.offen[x, y] = uks.visited[x, y]
		Next
		Next

		
		Return uks
	End Function
	
	Method Search:TWegpunkt[,] ()
	'	Local ms:Int = MilliSecs()
		Local node:TUKSNode
		Local x:Int, y:Int, dir:Int, nx:Int, ny:Int, dirIndex:Int, toAddNode:TUKSNode
		
	'Schritt 1: Schleife. solange wegpunkte zum abklappern vorliegen, tun sie dieses! :O
		While list.count() > 0
		
			node = TUKSNode(list.RemoveFirst())
			
			nx = node.x
			ny = node.y

			offen[node.x, node.y] = Null
			
		'Schritt 2: Umkreis durchgehen. 			
			For dirIndex = 0 Until 4
				x = dirX[dirIndex] + nx
				y = diry[dirIndex] + ny
				
				If x < 0 Or y < 0 Or x >= map.sizeX Or y >= map.sizeY Then Continue
				
				'Schritt 2.1: Schon irwo vorhanden?	
				If offen[x, y] Then
					'If offen[x, y].g_Cost <= node.g_Cost + 10 Then
					'	offen[x, y].g_Cost = node.g_Cost + 10
					'	offen[x, y].f_cost = offen[x, y].h_cost + offen[x, y].g_Cost
					'	offen[x, y]._prev = node
					'EndIf
					Continue
				End If
				
				If visited[x, y] Then
					'Schritt 2.1.1 -> schon vorhanden, raus hier.
					Continue
				EndIf
				
				'Schritt 2.2: Blockiert? (turm, haus, baum, stein, whatever?)
				If map.isBlocked(x, y) = 1 Then Continue
				If map.__wegsucheMap[x, y] = 1 Then Continue
				
				
			'Schritt 3: Eintragen.
				toAddNode = TUKSNode.Create(x, y, node.g_Cost + 10, sx, sy, node)
				
				visited[x, y] = toAddNode
				list.AddLast(toAddNode)
				offen[x, y] = toAddNode
		
			Next
		Wend
		
		'Schritt 4: Liste ist leer, dh alle erreichbaren punkte sind verfügbar.
		Local wp:TWegpunkt[,] = New TWegpunkt[map.sizeX, map.sizeY]
		
		Local _g:Int = $FFFF, _dir:Int
		Local passable:Int = 1
		
		Local tmpNode:TUKSNode
		
		Local i:Int, a:Int
		
		'durchlauf der mapdaten. 
		For nx = 0 Until map.sizeX
		For ny = 0 Until map.sizeY
			'Schonmal wegpunkt anlegen. 
			wp[nx, ny] = New TWegpunkt
			
			'g zurücksetzen.
			_g = $FFFF
			
			passable = 1
			
			'node holen.
			If Not visited[nx, ny] Then
				'node existierte nicht -> eine highcost node erstellen und unpassierbar flaggen.
				visited[nx, ny] = TUKSNode.Create(nx, ny, _g, sx, sy, Null, 0)
				passable = 0
			EndIf
			node = visited[nx, ny]
			
			'Schritt 4.1: _g kosten holen und in die best-array eintragen.
			_g = node.g_cost
			
			Local tmpStuff:TList = CreateList()
	
			
			For dirIndex = 0 Until 4
				x = nx + dirX[dirIndex]
				y = ny + diry[dirIndex]
				
				If dirX[dirIndex] Then
					_dir = dirX[dirIndex] + 1 '0 oder 2: Nord oder Süd
				Else
					_dir = diry[dirIndex] + 2 '1 oder 3: Ost oder West
				End If
				
				
				Local tmp:___tmpstuff
				
				If x < 0 Or y < 0 Or x >= map.sizeX Or y >= map.sizeY Then
					tmp = New ___tmpStuff.c(_dir, $ffff, 0)
					tmpStuff.AddLast(tmp)
					Continue
				EndIf
				
				tmpNode = visited[x, y]
				
				If Not tmpNode Then
					'Schritt 4.2: Node nicht vorhanden, punkt ist wohl blockiert. Wegkosten nicht bestimmbar.

					tmp = New ___tmpStuff.c(_dir, $ffff, 0)
				Else
					'Schritt 4.2: node vorhanden, eintragen.

					tmp = New ___tmpStuff.c(_dir, tmpNode.g_cost, tmpNode.passierbar)
				EndIf
				
				tmpStuff.AddLast(tmp)
			Next
			
			'Schritt 5: beste richtung sortieren.
			
			tmpStuff.Sort(True, ___tmpStuff.sortByCosts)
			
			'Schritt 6: Wegpunkt füllen.
			wp[nx, ny].Fill(tmpStuff, passable, node.g_Cost)
			
		Next
		Next
		
	'	Print "Highest F gefunden: " + TWegpunkt.highestF
		
		'Print "Dauer wegsuche zeugs: " + (MilliSecs() - ms) + "ms"
		Return wp
	End Method
End Type
Type TUmkreissuche_searchBuilding
	
	Field list:TList = CreateList() 'Arbeitsliste. Hält TuksNodes
	
	Field sx:Int, sy:Int 'StartX, start.
	
	Field map:TLandschaft
	
	Field dirX:Int[] = [1, 0, -1, 0]
	Field diry:Int[] = [0, 1, 0, -1]
	
	Field visited:TUKSNode[,]
	
	Field range:Int = 10
	
	Field target:Tbuilding
	
	Field targetWanted:TBuilding
	
	Function Create:TUmkreissuche_searchBuilding(sx:Int, sy:Int, range:Int, map:TLandschaft, target:Tbuilding = Null)
		
		If map And (sx < 1 Or sy < 1 Or sx >= map.sizeX Or sy >= map.sizey) Then Return Null
				
		Local uks:TUmkreissuche_searchBuilding = New TUmkreissuche_searchBuilding
		
		uks.sx = sx
		uks.sy = sy
		uks.range = range
		
		uks.map = map
		
		uks.targetWanted = target
		
		uks.visited = New TUKSNode[uks.map.sizeX, uks.map.sizeY]

		uks.visited[sx, sy] = TUKSNode.Create(sx, sy, 0, sx, sy, Null)
		uks.list.AddLast(uks.visited[sx, sy])
		
		Return uks
	End Function
	
	Method Search:Tnode[] ()
	'	Local ms:Int = MilliSecs()
		Local node:TUKSNode
		Local x:Int, y:Int, dir:Int, nx:Int, ny:Int, dirIndex:Int, toAddNode:TUKSNode
		
		Local found:Int = 0
	'Schritt 1: Schleife. solange wegpunkte zum abklappern vorliegen, tun sie dieses! :O
		While list.count() > 0
		
			node = TUKSNode(list.RemoveFirst())
			
			If node.g_Cost + 1 > range Then Continue 'abbrechen, wenn dieser punkt bereits zu weit weg ist.
			
			nx = node.x
			ny = node.y
		
		'Schritt 2: Umkreis durchgehen. 
			For dirIndex = 0 Until 4
				x = dirX[dirIndex] + nx
				y = diry[dirIndex] + ny
				
				If x < 0 Or y < 0 Or x >= map.sizeX Or y >= map.sizeY Then Continue
				
				'Schritt 2.1: Schon vorhanden?
				If visited[x, y] Then
					
'					If visited[x, y].g_Cost < (node.g_Cost + 1) Then
'						'die neue verlinkung wäre weg-kosten-günstiger. Ändern :)
'						visited[x, y].g_Cost = node.g_Cost + 1
'						visited[x, y]._prev = node
'					EndIf
					
					'Schritt 2.1.1 -> schon vorhanden, raus hier.
					Continue
				EndIf
				
				'Schritt 2.2.1: Gebäude hier? 
				Local building:Tbuilding = map.buildings[x, y]
				
				If building Then
					If targetWanted And building <> targetWanted Then Continue 'Hier ist zwar ein haus, aber es ist ebenfalls ein haus gewollt. Wenn das gewollte <> das gefundene ist, abbrechen.
					
					'gefunden - abbrechen.
				'	found = 1
					
					toAddNode = TUKSNode.Create(x, y, node.g_Cost + 1, sx, sy, node)
					target = building
					Local ret:TNode[] = CreateWaypoint(toAddNode)
			'		Print "Delay wegfindung: " + (MilliSecs() - ms)
					Return ret
				End If
				'Schritt 2.2.2: Blockiert? (turm, haus, baum, stein, whatever?)
				If map.__wegsucheMap[x, y] = 1 Then Continue
				if map.isBlocked(x,y) = 1 Then continue
				
			'Schritt 3: Eintragen.
				toAddNode = TUKSNode.Create(x, y, node.g_Cost + 1, sx, sy, node)
				
				visited[x, y] = toAddNode
				list.AddLast(toAddNode)
		
			Next
		Wend
		
		Return Null
	End Method
	
	Method CreateWaypoint:Tnode[] (lastNode:TUKSNode)
		Local ret:tnode[] = New tnode[lastnode.g_Cost + 1]
		Local i:Int = lastNode.g_cost
		Local ox:Int = lastnode.x
		Local oy:Int = lastnode.y
	'	lastNode = lastNode._prev
		While lastNode
			ret[i] = TNode.Create(ox, oy, lastNode.x, lastNode.y)
			ox = lastNode.x
			oy = lastNode.y
			
			lastNode = lastNode._prev
			
			i:-1
		Wend
		Return ret
	End Method
End Type

Type ___tmpStuff
	Field dir:Byte
	Field costs:Short
	Field p:Int
	
	Method c:___tmpStuff(dir:Byte, costs:Short, passierbar:Int)
		Self.dir = dir
		Self.costs = costs
		Self.p = passierbar
		
		Return Self
	End Method
	
	Function sortByCosts:Int(o1:Object, o2:Object)
		Local t1:___tmpStuff = ___tmpstuff(o1)
		Local t2:___tmpStuff = ___tmpstuff(o2)
		
		If t1 And t2 Then
		
			If t1.p = 1 And t2.p = 1 Then
			If t1.costs < t2.costs Then Return - 1
			
			If t1.costs = t2.costs Then Return 1
			
			If t1.costs > t2.costs Then Return 1
			
			ElseIf t1.p = 1 Then
				Return - 1
			ElseIf t2.p = 1 Then
				Return 1
			Else
				Return - 1
			EndIf
		End If
		
		Return 0
	End Function
End Type

Type TNode
	Field dir:Byte
	Field x:Int, y:Int

	
	Function Create:TNode(x1:Int, y1:Int, x2:Int, y2:Int)
		Local diffX:Int = Sgn(x1 - x2)
		Local diffY:Int = Sgn(y1 - y2)
		
		Local n:TNode = New TNode
		n.x = x2
		n.y = y2
		
		If Abs(diffX) Then
			n.dir = diffX + 1
		ElseIf Abs(diffY) Then
			n.dir = diffY + 2
		Else
			n.dir = 8
		End If
	
		
		Return n
	End Function
End Type
Type TUKSNode
	Field x:Int
	Field Y:Int
	Field g_Cost:Int
'	Field f_cost:Int
'	Field h_cost:Int
	
	Field passierbar:Int = 1
	
	Field _prev:TUKSNode
	
	Function Create:TUKSNode(x:Int, y:Int, cost:Int, x2:Float, y2:Float, prev:TUKSNode, passierbar:Int = 1)
		Local uksn:TUKSNode = New TUKSNode

		uksn.x = x
		uksn.y = y
	'	uksn.h_cost = Pythf(x, y, x2, y2)*14
		
		uksn.g_Cost = cost
	'	uksn.f_cost = uksn.g_Cost + uksn.h_cost
		
		uksn._prev = prev
		
		uksn.passierbar = passierbar
		
		Return uksn
	End Function
End Type



rem
	TWegpunkt ist das type, was die units führt. Sie hält die nachbarpunkte in ihrer logisch besten reihenfolge.
	author: Phillipk
end rem
Type TWegpunkt
	Global highestF:Int = 0
	
	Field dir:Byte[] = New Byte[4] '1,2,3 oder 4 auf 4 indices.
	Field cost:Short[] = New Short[4] 'X auf 4 indices.
	Field passable:Byte = 1
	Field costs:Int
	
	Method Fill(list:TList, passable:Int, f_costs:Int)
		Self.passable = passable
		Self.costs = f_costs
		
		If TWegpunkt.highestF < f_costs Then TWegpunkt.highestF = f_costs
		
		Local i:Int = 0
		
		For Local tmp:___tmpStuff = EachIn list
			dir[i] = tmp.dir
			cost[i] = tmp.costs
			
			i:+1
		Next
		
	End Method
End Type