﻿Rem
	Const bereich
End rem
Const ANIMATION_STAND:Int = 0 'nicht als frameset nutzen!
Const ANIMATION_MOVE:Int = 1'nicht als frameset nutzen!
Const ANIMATION_ATTACK:Int = 2 'nicht als frameset nutzen!

Const ANIMATION_DIE:Int = 5
Const ANIMATION_DEAD:Int = 6

Const ANI_STAND_N:Int = 0
Const ANI_STAND_E:Int = 1
Const ANI_STAND_S:Int = 2
Const ANI_STAND_W:Int = 3

Const ANI_MOVE_N:Int = 4
Const ANI_MOVE_E:Int = 5
Const ANI_MOVE_S:Int = 6
Const ANI_MOVE_W:Int = 7

Const ANI_ATK_N:Int = 8
Const ANI_ATK_E:Int = 9
Const ANI_ATK_S:Int = 10
Const ANI_ATK_W:Int = 11


'Jedes Animset mit einer richtung bitte VOR einzelanimationen.
Const ANI_DIE:Int = 15
Const ANI_DEAD:Int = 16

Rem
	Hilfstype zum finden von indices
End rem
Type FrameInidiceHelper
	Field name:String
	Field id:Int
	
	Global list:TMap = CreateMap()
	
	Function add(name:String, id:Int)
		Local fih:FrameInidiceHelper = New FrameInidiceHelper
		fih.name = name
		fih.id = id
		list.Insert(name, fih)
	End Function
	Function byName:Int(name:String)
		If list.Contains(name) Then
			Return FrameInidiceHelper(list.ValueForKey(name)).id
		End If
		Return - 1
	End Function
End Type
FrameInidiceHelper.add("ANIMATION_STAND_NORTH", ANI_STAND_N)
FrameInidiceHelper.add("ANIMATION_STAND_EAST", ANI_STAND_E)
FrameInidiceHelper.add("ANIMATION_STAND_SOUTH", ANI_STAND_S)
FrameInidiceHelper.add("ANIMATION_STAND_WEST", ANI_STAND_W)
FrameInidiceHelper.add("ANIMATION_MOVE_NORTH", ANI_MOVE_N)
FrameInidiceHelper.add("ANIMATION_MOVE_EAST", ANI_MOVE_E)
FrameInidiceHelper.add("ANIMATION_MOVE_SOUTH", ANI_MOVE_S)
FrameInidiceHelper.add("ANIMATION_MOVE_WEST", ANI_MOVE_W)
FrameInidiceHelper.add("ANIMATION_DIE", ANI_DIE)
FrameInidiceHelper.add("ANIMATION_DEAD", ANI_DEAD)
FrameInidiceHelper.add("ANIMATION_ATTACK_NORTH", ANI_ATK_N)
FrameInidiceHelper.add("ANIMATION_ATTACK_EAST", ANI_ATK_E)
FrameInidiceHelper.add("ANIMATION_ATTACK_SOUTH", ANI_ATK_S)
FrameInidiceHelper.add("ANIMATION_ATTACK_WEST", ANI_ATK_W)

Type TUnit
	Global list:TUnit[]
	
	Field id:Int
	Field name:String
	Field rasse:String
	
	Field framesets:Int[][]
	
	Field atk:Int
	Field def:Int
	Field hp:Int
	Field speed:Int
	
	Field col:Float[] = [1.0, 1.0, 1.0, 1.0]
	Field size:Float = 1.0

	'Debug: 
	Field timer:Int = MilliSecs()
	Field frame:Int = 0
	Field frmset:Int = 0
	
	Method Update()
		If timer < MilliSecs() Then
			frame = (frame + 1) Mod Len(framesets[frmset])
			If frame = 0 Then
				frmset = (frmset + 1) Mod 4
			End If
			
			timer = MilliSecs() + 1000
		End If
	End Method
	Method Draw(x:Int, y:Int)
		Local frame:TFrame = TFrame.GetUnitFrameByID(framesets[frmset][frame])
		
		If frame Then
			frame.DrawBySlotf(x, y, 1)
		End If
	End Method
	
	'Debug///
	Function CopyByID:TUnit(id:Int, levelfaktor:Float = 1.0)
		Local u:TUnit = GetById(id)
		
		If u Then
			Local n:TUnit = New TUnit
			
			n.atk = u.atk * levelfaktor
			n.def = u.def * levelfaktor
			n.framesets = u.framesets
			n.frame = u.frame
			n.frmset = u.frmset
			n.hp = u.hp * levelfaktor
			n.id = u.id
			n.name = u.name
			n.speed = u.speed
			n.col = u.col[..4]
			
			Select id
				Case 2
					n.col = [Rand(150, 255) / 255.0, Rand(150, 255) / 255.0, Rand(150, 255) / 255.0, 1.0]
			End Select
			
			n.size = u.size' + (Rnd(-0.2, 0.2))
	
			
			Return n
		End If
		Return Null
	End Function
	
	Function GetByID:TUnit(id:Int)
		If Len(list) <= id Then Return Null
		Return list[id]
	End Function
	
	Function LoadData(file:String)
		If FileType(file) = 0 Then
			RuntimeError("TUnit.LoadUnits -> " + file + " konnte nicht geladen werden: Datei existiert nicht.")
		End If
		
		Local ini:TInifile = tinifile.Load(file)
		
		For Local header:TIniheader = EachIn ini.data.Values()
			Local h:String = header.name
			
			Local u:TUnit = New TUnit
			
			u.atk = ini.geti(h, "Attack")
			u.def = ini.geti(h, "Defense")
			u.hp = ini.geti(h, "HP")
			u.speed = ini.geti(h, "Speed")
			u.name = ini.gets(h, "name")
			u.rasse = ini.gets(h, "rasse")
			Local col:Float[] = ini.getfArray(h, "col", ",")
		
			u.col = col +[1.0]
			
			u.size = ini.getf(h, "size", 1.0)
		
			
			Rem
				framesets laden
			End rem
			For Local entry:TInidata = EachIn header.data.Values()
				Local id:Int = FrameInidiceHelper.byName(entry.name)
				
				If id > - 1 Then
					If Len(u.framesets) <= id Then u.framesets = u.framesets[..id + 1]
					u.framesets[id] = GetFramesByString(entry.val)
				End If
			Next
			
			If Len(u.framesets) > ANI_DIE Then
			'	Print "juhu, frameset für sterben ist da!"
			'	Print "Anzahl der frames: " + Len(u.framesets[ANI_DIE])
				
			End If
			
'			Local ani:String
'			Local i:Int = 0
'			ani = ini.gets(h, "ANIMATION_STAND_NORTH")
'			If Len(ani) Then
'				If Len(u.framesets) <= i Then u.framesets = u.framesets[..i + 1]
'				u.framesets[i] = GetFramesByString(ani)
'				ani = ""
'			End If
'			i:+1
'			ani = ini.gets(h, "ANIMATION_STAND_EAST")
'			If Len(ani) Then
'				If Len(u.framesets) <= i Then u.framesets = u.framesets[..i + 1]
'				u.framesets[i] = GetFramesByString(ani)
'				ani = ""
'			End If
'			i:+1
'			ani = ini.gets(h, "ANIMATION_STAND_SOUTH")
'			If Len(ani) Then
'				If Len(u.framesets) <= i Then u.framesets = u.framesets[..i + 1]
'				u.framesets[i] = GetFramesByString(ani)
'				ani = ""
'			End If
'			i:+1
'			ani = ini.gets(h, "ANIMATION_STAND_WEST")
'			If Len(ani) Then
'				If Len(u.framesets) <= i Then u.framesets = u.framesets[..i + 1]
'				u.framesets[i] = GetFramesByString(ani)
'				ani = ""
'			End If
'			i:+1
'			ani = ini.gets(h, "ANIMATION_STAND_WEST")
'			If Len(ani) Then
'				If Len(u.framesets) <= i Then u.framesets = u.framesets[..i + 1]
'				u.framesets[i] = GetFramesByString(ani)
'				ani = ""
'			End If
'			i:+1
'			ani = ini.gets(h, "ANIMATION_STAND_WEST")
'			If Len(ani) Then
'				If Len(u.framesets) <= i Then u.framesets = u.framesets[..i + 1]
'				u.framesets[i] = GetFramesByString(ani)
'				ani = ""
'			End If
'			i:+1
'			ani = ini.gets(h, "ANIMATION_STAND_WEST")
'			If Len(ani) Then
'				If Len(u.framesets) <= i Then u.framesets = u.framesets[..i + 1]
'				u.framesets[i] = GetFramesByString(ani)
'				ani = ""
'			End If
'			i:+1
'			ani = ini.gets(h, "ANIMATION_STAND_WEST")
'			If Len(ani) Then
'				If Len(u.framesets) <= i Then u.framesets = u.framesets[..i + 1]
'				u.framesets[i] = GetFramesByString(ani)
'				ani = ""
'			End If
'			i:+1
			
			Local id:Int = h.ToInt()
			
			If Len(TUnit.list) <= id Then
				TUnit.list = TUnit.list[..id + 1]
			End If
			
			TUnit.list[id] = u
			u.id = id
		Next
	End Function
	

End Type

Function GetFramesByString:Int[] (str:String)
'	Print "GetFramesByString : " + str
	Local t:String[] = str.Split(";")
	Local ret:Int[] = New Int[Len(t) / 2]
'	Print "Len von ret: " + Len(ret)
	Local index:Int = 0
	For Local i:Int = 0 Until Len(t)
		If t[i] Then
			ret = ret[..index + 1]
			ret[index] = t[i].ToInt()
		'	Print "Frame index " + ret[index] + " -  array index: " + index
			index:+1
		EndIf
	Next
	Return ret
End Function

Type TUnitSektor
	Field list:TList = CreateList()
	
	Global sektors:TUnitSektor[,]
	Global sX:Int, sY:Int
	
	Method New()
		list = CreateList()
	End Method
	
	
	
	Function insert:Int(x:Int, y:Int, tuc:TunitController)
		Local x2:Int, y2:Int
		
	'	For x2 = x - 1 To x + 1
	'	For y2 = y - 1 To y + 1
			If x < 0 Or y < 0 Or x >= sX Or y >= sY Then
				Print "TUnitsektor -> Einheit out of range!"
				Return 0 'Continue
			EndIf
			sektors[x, y].list.addlast(tuc)
	'	Next
	'	Next
	End Function
	
	Function PrepareUnitSektors:Int(sizex:Int, sizeY:Int)
		sektors = New TUnitSektor[sizex, sizeY]
		Print "Unitsektoren werden erstellt. SizeX: " + sizex + " - SizeY: " + sizeY
		For Local x:Int = 0 Until sizex
		For Local y:Int = 0 Until sizeY
			sektors[x, y] = New TUnitSektor
			
		Next
		Next
		TUnitSektor.sX = sizex
		TUnitSektor.sY = sizeY
	End Function
End Type

Rem
	Ein Squad ist eine sammlung von units, zugewiesen vom spawner. 
	Der Squad hat die aufgabe, angriffsbefehle unter den units zu verteilen - macht man einen quad aggressiv, kommen se alle an.
	Weitere aufgabe ist es, einheiten zbeisammen zu halten.
	Ist die distanz zur approxen mitte des Squads zu groß, warten die units einen moment. Ausser es gilt der angriffsbefehl, dann rennen se, die würmer ^^
	author: PhillipK
end rem
Type TUnitSquad
	Field tucs:TunitController[]
	Field instruction:TUnitSquad_instruction = New TUnitSquad_walk
	Field newInstruction:Int = 0
	
	Field color:Float[] = [RndFloat(), RndFloat(), RndFloat(), 1.0]
	
	Field tuccnt:Int = 0
	
	Field SquadMiddle:Int[] = [0, 0]
	
	
	Method AddUnit:Int(tuc:TunitController)
		Local i:Int = 0
		For i = 0 Until Len(tucs)
			If Not tucs[i] Then Exit
		Next
		If i >= Len(tucs) Then Return - 1
		
		tucs[i] = tuc
		tuc.squad = Self
	'	tuc.unit.col = color
		tuccnt:+1
		Return i
	End Method
	
	Method Update:Int()
		
		'Step 1: Anweisungen verarbeiten.	
		If newInstruction Then 'And instruction.GetPriority() > 70 Then
		'	instruction.UpdateTUCs(tucs)
		EndIf
		
		'Step 2: Anweisungen auswerten.
		Select instruction.GetPriority()
			Case SQUAD_PRIO_ATTACK
				If instruction.target And instruction.target.destroyed = 0 Then
					'nixtun oO
				Else
					instruction = New TUnitSquad_walk
					newInstruction = 1
				End If
		End Select
		
		'Step 3: Squad units überprüfen und mittelpunkt errechnen
		Local i:Int, a:Int, cnt:Int
		SquadMiddle = New Int[2]
		For i = 0 Until Len(tucs)
			If tucs[i] And tucs[i].isAlive() Then
				a:+1
				If tucs[i].target Then cnt:+1
				SquadMiddle[0]:+tucs[i].slotx
				SquadMiddle[1]:+tucs[i].slotY
			ElseIf tucs[i] Then
				tucs[i] = Null
			EndIf
		Next
		Self.tuccnt = a
		If a > 0 Then
			SquadMiddle[0]:/a
			SquadMiddle[1]:/a
		EndIf
		Return 1
	End Method
	
	Method RequestAttack:Int(target:TBuilding)
		DebugStop()
		'erstmal debugmäßig: stattgegeben.
		If instruction.GetPriority() < 71 Then
		newInstruction = 1
		instruction = TUnitSquad_attack.Create(target)
		EndIf
	End Method
	
	Method RequestAction:Int(aID:Int, target:TBuilding, tuc:TunitController)
		'Step 1: Actionsid überprüfen
		Select aID
			Case ACTION_ATTACK
				'-> Er möchte ein target angreifen.
				
				'-> Check, ob diese unit bereits angreift.
				If tuc.action.getID() < ACTION_ATTACK Then
					' nein er greift nicht an.
					
					'-> Check, distanz zum squad mittelpunkt
'					If MDistf(target.posx, target.posy, SquadMiddle[0], SquadMiddle[1]) < 5 Then
'						'Ziemlich nah. Könnten gefährlich für den gesamten squad sein: Raid starten.
'						Self.instruction = TUnitSquad_attack.Create(target)
'						Self.newInstruction = 1
'						Return 1
'					ElseIf tuc
					If tuc
						' Weit genug weg. Lassen wir ihn machen. Schicken wir wen zur unterstützung?
						' nachtrag: Idee entfernt, das wäre uncool. Wenn die units die türme von selbst finden und hinrennen ist cooler :D
						
						' Tuc erlauben, target alleine anzugreifne.
						
						tuc.action = New TUnitAction_attack.Create(tuc)
						tuc.target = target
						tuc.tmpNodes = Null
						tuc.nodeTarget = Null
						Return 1
					EndIf
				EndIf
			Case ACTION_WALK
				If target And tuc.tmpNodes Then
					tuc.action = New TUnitAction_walk.Create(tuc)
					tuc.nodeTarget = target
					Print "ACTION_WALK -> tuc geht zu nodes."
					Return 1
				Else
					'Walk zum mittelpuntk der erde :> Endlich einer der mal tut was er soll: Burg angreifen.
					If tuc.action.getID() < ACTION_WALK Then
						tuc.action = New TUnitAction_walk.Create(tuc)
						
						If tuc.target Then tuc.target = Null
						
						Return 1
					End If
					Print "ACTION_WALK -> tuc geht zu mitte."
					tuc.nodeTarget = Null
					tuc.tmpNodes = Null
				End If
			Case ACTION_DIE
				'er stirbt. leb wohl du doofe unit :<
				tgame.stats_Kills:+1 'annixa hack 
				For Local i:Int = 0 Until Len(tucs)
					If tucs[i] = tuc Then
						tucs[i] = Null
						Self.tuccnt:-1
						tuc.squad = Null 'im stich lassen. Ders nixmehr wert.
						Return 1
					End If
				Next
			Case ACTION_DEAD
				'wenn das eintritt weine ich :O
			
		End Select
	End Method
	
	Method RequestRaidTarget:Tbuilding(tuc:TUnitController)
		
	End Method
End Type

Type TUnitSquad_instruction

	Field target:Tbuilding
	
	Method GetPriority:Int() Abstract
	
	Method UpdateTUCs:Int(tucs:TUnitController[]) Abstract
End Type

Const SQUAD_PRIO_WALK:Int = 0
Type TUnitSquad_walk Extends TUnitSquad_instruction
	Method GetPriority:Int()
		Return SQUAD_PRIO_WALK
	End Method
	
	Method UpdateTUCs:Int(tucs:TUnitController[])
		For Local i:Int = 0 Until Len(tucs)
			If tucs[i] And tucs[i].isAlive() Then
			'	tucs[i].target = Self.target
				tucs[i].action = new TUnitAction_walk.Create(tucs[i])
				'testweise: keinerlei wegfindung. Hier muss noch probiert werden, was am besten ist :(
				'die units sollen einfach zu ihrem target gehen, statt der wegfindung zu folgen. Im bestenfall sind die eh schon tot ^^
				
			End If
		Next
	End Method
End Type

Rem
	der Attack befehl wird gesetzt, wenn einer einheit schaden zugefügt wurde und der Squad nicht zu weit entfernt ist.
End Rem
Const SQUAD_PRIO_ATTACK:Int = 100
Type TUnitSquad_attack Extends TUnitSquad_instruction
	
	Method GetPriority:Int()
		Return SQUAD_PRIO_ATTACK
	End Method

	Function Create:TUnitSquad_instruction(target:TBuilding)
		Local tusA:TUnitSquad_attack = New TUnitSquad_attack
		tusA.target = target
	'	squad.instruction = tusA
		Return tusA
	End Function
	
	Method UpdateTUCs:Int(tucs:TUnitController[])
	'	Print "Request attack! :D  - anzahl tucs die das intressiert: " + Len(tucs)
		For Local i:Int = 0 Until Len(tucs)
			If tucs[i] And tucs[i].isAlive() Then
			'	tucs[i].target = Self.target
				
				'testweise: keinerlei wegfindung. Hier muss noch probiert werden, was am besten ist :(
				'die units sollen einfach zu ihrem target gehen, statt der wegfindung zu folgen. Im bestenfall sind die eh schon tot ^^
				
			End If
		Next
	End Method
End Type

Type TUnitController


	Global burgX:Int = 0
	Global burgY:Int = 0
	
	Global list:TList = CreateList()
	
	Global posArray:Float[][]
	Global oldPosArray:Float[][]
	
	Field slotX:Float
	Field sloty:Float
	Field lastSX:Float
	Field lastSY:Float

	Field zielX:Int
	Field zielY:Int
	
	Field unit:TUnit
	Field action:TUnitAction

	Field dir:Int = 0 '0 nord, 1 ost, 2 süd, 3 west

	Field anim:TAnimation = New TAnimation
	
	Field nextUpdate:Int = -1 'nächster update in update-ticks.
	
	Field killed:Int = 0
	
	Field target:TBuilding
	Field squad:TUnitSquad
	
	Field tmpNodes:TNode[]
	Field nodeTarget:Tbuilding
	
	Field froozen:Int = 0
	Field oldSpeed:Int = 0
	Field oldCol:Float[]
	Field freezeTimer:Int = 0
	
'	Field DOTs:byte[30]' = New Tprojectil[30]
	
	Field buildStoprange_update:Int = 20
	
	Global updateTicks:Int = 0
	
	
	Global _stepper:Int = 0
	Global _cnt:Int = 3 'jeder 3te kriegt n update!
	
	Method Freeze:Int(duration:Int)
		If froozen = 0 Then
			froozen = 1
			oldSpeed = Self.unit.speed
			Self.unit.speed:/2
			
			If Self.unit.speed <= 0 Then Self.unit.speed = 1
			
			oldCol = Self.unit.col
			
			Self.unit.col = oldCol[..]
			Self.unit.col[0] = 0.4
			Self.unit.col[1] = 0.4
			Self.unit.col[2] = 1.0
			
		EndIf
		freezeTimer = tgame.MSLocal + duration
	End Method
	
	Function RandSpawn:Tunitcontroller()
		'debugfunktion. 
		Local x1:Int = 0, x2:Int = 0, y1:Int = 0, y2:Int = 0
		
		Select Rand(0, 3)
			Case 0
				y1 = 0
				y2 = 0
				x1 = 0
				x2 = TLandschaft.map.sizeX - 1
			Case 1
				x1 = 0
				x2 = TLandschaft.map.sizeX - 1
				y1 = TLandschaft.map.sizey - 1
				y2 = TLandschaft.map.sizeY - 1
			Case 3
				x1 = 0
				x2 = 0
				y1 = 0
				y2 = TLandschaft.map.sizeY - 1
			Case 2
				x1 = TLandschaft.map.sizeX - 1
				x2 = TLandschaft.map.sizeX - 1
				y1 = 0
				y2 = TLandschaft.map.sizeY - 1
		End Select
		
		Local px:Int = Rand(x1, x2)
		Local py:Int = Rand(y1, y2)
		
		Local ids:Int[] = [0, 1, 2, 3]
		
'		For Local u:TUnit = EachIn TUnit.list
'			ids:+[u.id]
'		Next
		
		Return TUnitController.Create(px, py, ids[Rand(0, 3)], DEBUG_freeSquad)
	End Function
	Function kill:Int(tuc:TUnitController)

				
	'	tEffekt_FloatingText.Create("R.I.P", [255, 0, 0], 10, 0, tuc.slotX, tuc.sloty, -0.01, 0.0, 2000)

		
		list.Remove(tuc)
		tuc.anim = Null
		tgame.Ressources[RES_GOLD].plus(1)
		
		
'		For Local prj:TProjectil = EachIn tuc.DOTs
'			prj.destroy()
'		Next
		
	End Function
	Function Create:TUnitController(posx:Int, posy:Int, unitID:Int, squad:TUnitSquad = Null, levelfaktor:Float = 1.0)
		Local tuc:TUnitController = New TUnitcontroller
		
		tuc.slotX = posx
		tuc.sloty = posy
		
		
		Local unit:TUnit = TUnit.CopyByID(unitID, levelfaktor)
		
		If unit Then
			tuc.unit = unit
			
			TUnitController.list.AddLast(tuc)

			tuc.anim = TAnimation.CreateWithStand(tuc)
			tuc.action = New TUnitAction_idle.Create(tuc)
			
			If squad Then
				squad.AddUnit(tuc)
				tuc.squad = squad
				Select squad.instruction.GetPriority()
					Case SQUAD_PRIO_ATTACK
						tuc.target = squad.instruction.target
						
						tuc.action = New TUnitAction_walk.Create(tuc)
					Case SQUAD_PRIO_WALK
						tuc.action = New TUnitAction_walk.Create(tuc)
					Default
						
						tuc.action = New TUnitAction_idle.Create(tuc)
				End Select
			Else
				tuc.action = New TUnitAction_idle.Create(tuc)
			End If
			
		
		'	tuc.anim.dodie()
		
			Return tuc
			
		End If
	End Function
	
	Function Update:Int()
		Local x:Int, y:Int
		For x = 0 Until TUnitSektor.sx
		For y = 0 Until TUnitSektor.sy
			TUnitSektor.sektors[x, y].list.Clear()
		Next
		Next
		
		Local sekx:Int = 0, seky:Int = 0
		Local index:Int = 0
		
		'Positions update für minimap!
		If _stepper = 0 Then
			'neuen array anlegen.
			oldPosArray = posArray
			posArray = Null 'löschen, oderso.
		End If
		
		For Local tuc:TUnitController = EachIn list
		
		'	If tuc.isAlive() = 0 Then

			'	teffekt_print.Create("+", [255, 0, 0], 0, 0, tuc.slotX, tuc.sloty, 0, 0, 0)

		'	End If
		
			index = (index + 1) Mod _cnt
			If index <> _stepper Then
				sekx = tuc.slotX / 8
				seky = tuc.sloty / 8
	
				TUnitSektor.insert(sekx, seky, tuc)
				'wieder in liste rein
				Continue
			Else
			
			tuc._Update()
				posArray:+[[tuc.slotX, tuc.sloty]] 'erweitern.
		
			sekx = tuc.slotX / 8
			seky = tuc.sloty / 8
			
			TUnitSektor.insert(sekx, seky, tuc)
			EndIf
		Next
		
		_stepper = (_stepper + 1) Mod _cnt
	End Function
	
	Function emptyDisease:Int(TUC:Tunitcontroller)
		
	End Function
	Method _Update:Int()
		Local x:Int, y:Int
		buildStoprange_update:-1
		If buildStoprange_update <= 0 Then
		For x = slotX - 10 To slotX + 10
		For y = sloty - 10 To sloty + 10
			If x < 0 Or y < 0 Or x >= TLandschaft.map.sizeX Or y >= TLandschaft.map.sizeY Then Continue
			
			If Pythf(x, y, slotX, sloty) < 10 Then
				TLandschaft.map.colors[x, y].col = [1.0, 0.25, 0.25]
				TLandschaft.map.colors[x, y].change = 70
			endif
		Next
		Next
			buildStoprange_update = 20
		EndIf
		
		If Not squad Or Not anim Then
			TUnitController.kill(Self)
			Return -1
		EndIf
		If unit.hp <= 0 Then
			If action.getID() >= 0 Then
			action = New TUnitAction_die.Create(Self)
			EndIf
			Self.killed = 1
			
			action.Update()
			If anim Then anim.Update()
			
			Return - 1
		EndIf
		
		If froozen = 1 Then
		
			If Self.freezeTimer <= tgame.MSLocal Then
				Self.unit.speed = oldSpeed
				Self.unit.col = oldCol
				
				froozen = 0
			End If
		
			
		EndIf
		
		Local aID:Int = Self.action.getID()
	
		'step 0.0 -> animation!111
		If anim Then anim.update()
		
		'step 0.1 -> bin.ich.to.prüfung 
		If isAlive() = 0 Then
			'ich bin tot.
			'habe ich einen squad?
		'	Print "ich bin tot."
			If squad Then
				'bin ich grade dabei, zu sterben?
				If action.getID() < 0 Then
					'schade. Doch keine auferstehung? :(
				Else
					squad.RequestAction(ACTION_DIE, Null, Self)
				EndIf
			End If
		EndIf
	
		'Step 1- update allen krams. falls nötig, möglich, gewollt und nicht getrollt! :D
		If nextUpdate < TGame.mslocal then 'TGameControl.updateTicks Then
		'	Print "NEXT_UPDATE!"
			If Not tmpNodes And (aID = ACTION_WALK Or aID = ACTION_IDLE) And Not Self.target Then
				Local buildingSearch:TUmkreissuche_searchBuilding = TUmkreissuche_searchBuilding.Create(slotx, sloty, 10, TLandschaft.map)
				
				If buildingSearch Then
				'	Print "Wegfindung"
					Local nodes:TNode[] = buildingsearch.Search()
				'	Print "nodesearch."
					If nodes Then
						Self.nodeTarget = buildingSearch.target
						Self.tmpNodes = nodes
					End If
				EndIf
			EndIf
			
			
			nextUpdate = tgame.mslocal + 250 'TGameControl.updateTicks + 15
		Else
		'	Print "NextUpdate: " + nextUpdate + " - UpdateTicks: " + TGameControl.updateTicks
		End If
		
		'Step 1.1 - Checken, ob uns jemand deinen Tower unter den Hintern gebaut hat!
		Local building:Tbuilding = TLandschaft.map.GetBuilding(slotx, sloty)
		
		If building Then
			
			Self.nodeTarget = Null
			Self.tmpNodes = Null
			'squad.RequestAction(ACTION_ATTACK, building, Self)
			Self.action = New TUnitAction_attack.Create(Self)
			Self.target = building
			aID:Int = Self.action.getID()
		End If
		'Step 2- Check: Movement?

	'	Print "Aktionsid: " + aID
		If aID >= 0 Then
			If aID = ACTION_IDLE Then
			'	Print "IDLE :/"
				
					squad.RequestAction(ACTION_WALK, Null, Self)
				
			ElseIf aID = ACTION_WALK Then
				'er dürfte laufen. darf ers?
				If aID <> ACTION_WALK Then
					squad.RequestAction(ACTION_WALK, nodeTarget, Self)
				'	Print "Request walk"
				Else
					'er darf laufen.
					If tmpNodes Then
					'	Print "Tmpnodes!"
						MoveAlongNodes()
					ElseIf nodeTarget Then
						
					'	Print "walk to a target :D"
						'er war wohl am laufen und hat nun ein target vor dem er steht.
						If MDistf(nodeTarget.posx, nodeTarget.posy, slotX, sloty) < 1.5 Then
							If squad.RequestAction(ACTION_ATTACK, nodeTarget, Self) Then
							'	Print "node target genullt weil request attack"
								nodeTarget = Null
							Else
								action = New TUnitAction_idle.Create(Self)
							'	Print "node target genullt weil darf nicht angreifen!"
								nodeTarget = Null
								tmpNodes = Null
							End If
						Else
						'	Print "NodeTarget musste entfernt werden. Distanz: " + MDisti(nodeTarget.posx, nodeTarget.posy, slotX, sloty)
							nodeTarget = Null 'debug? ka :) target rausnehmen um verwirrung zu vermeiden.
						End If
					Else
						'er darf laufen aber er hat nix zum laufen!
				'		Print "WP abklappern."
						Local wp:TWegpunkt
						
						If slotX >= 0 And slotX < TLandschaft.map.sizeX And sloty >= 0 And sloty < TLandschaft.map.sizeY Then wp = TLandschaft.map.wegpunkte[slotX, sloty]
						
					'	tEffekt_Print.Create(slotX + " " + sloty, [255, 255, 255], 0, 0, Int(slotX-0.5), Int(sloty+0.75), 0, 0, 0)
					'	If TLandschaft.map.isBlocked(slotX, sloty) Then tEffekt_Print.Create("X", [255, 0, 0], 0, 0, slotX, sloty, 0, 0, 0)
						
						If wp Then
						'	Print "walk along wegpunkt"
							MoveToDir(wp.dir[0])
						End If
					EndIf
				End If
			ElseIf aID = ACTION_ATTACK Then
				'TUnitaction_attack macht bei .onAnimReady() schaden.
				If Not target Or (target And target.destroyed = 1) Then
					'Target tot. idlen =)
				'	Print "Target destroyed."
					target = Null
					action = New TUnitAction_idle.Create(Self)
				End If
			End If
		EndIf
		
		'step X: Action updaten.
		action.Update()
		
		
	End Method
	
	Method MoveAlongNodes:Int()
		For Local i:Int = 0 Until Len(tmpNodes)
			If tmpNodes[i] Then
				If i + 1 < Len(tmpNodes) And tmpNodes[i + 1] Then
					If MoveToDir(tmpNodes[i].dir) = -1 Then tmpNodes[i] = Null
					If MDistf(tmpNodes[i + 1].x, tmpNodes[i + 1].y, slotX, sloty) < MDistf(tmpNodes[i].x, tmpNodes[i].y, slotX, sloty) Then tmpNodes[i] = Null 'Or tmpNodes[i + 1].dir = 8 Then tmpNodes[i] = Null
			'	
					Return 1
				EndIf
			'	Return 1
			EndIf
		Next
		
'		'distanzcheck, er hat keine nodes mehr. wie weit muss er noch ran?
'		If nodeTarget Then
'			If MDisti(nodeTarget.posx, nodeTarget.posy, slotX, sloty) > 1 Then
'				'eine fake-node am anfang anfügen.
'				
'			EndIf
'		End If
		
		tmpNodes = Null
		Return 0
	
	End Method
	Method MoveToDir:Int(dir:Int)
		
		Select dir
			Case 0, 2 'x Richtung
				slotX:+(dir - 1) * 0.02 * action.GetMove()
				Local tmpX:Int = slotX * 1000 'auf 4 stellen nach dem komma genau!
				If (tmpX / 1000) < 0 Or (tmpX / 1000) > TLandschaft.map.sizeX Then
					Self.squad.RequestAction(ACTION_IDLE, Null, Self)
				Else
					If TLandschaft.map.isBlocked(tmpX / 1000, sloty) Then
						Self.squad.RequestAction(ACTION_IDLE, Null, Self)
					End If
				End If
				slotX = tmpX / 1000.0
				Self.dir = dir
				Return 1
			Case 1, 3 'y richtung
				sloty:+(dir - 2) * 0.02 * action.GetMove()
				Local tmpY:Int = slotY * 1000 'auf 4 stellen nach dem komma genau!
				If (tmpY / 1000) < 0 Or (tmpY / 1000) > TLandschaft.map.sizey Then
					Self.squad.RequestAction(ACTION_IDLE, Null, Self)
				Else
					If TLandschaft.map.isBlocked(tmpY / 1000, sloty) Then
						Self.squad.RequestAction(ACTION_IDLE, Null, Self)
					End If
				End If
				sloty = tmpY / 1000.0
				Self.dir = dir
				Return 1
				
			Default
				Return - 1
		End Select
	End Method
	Function Draw:Int()
		glBindTexture(GL_TEXTURE_2D, TFrame.texture[FRAMESET_UNIT])
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST) ;

   		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST) ;
		
		For Local tuc:TUnitController = EachIn list
			tuc._draw()
			
			glDisable(GL_TEXTURE_2D)
			
			glBegin(GL_LINES)
				If tuc.target Then
					Local posx:Int, posy:Int
					
					GetXYBySlot(tuc.slotX, tuc.sloty, posx, posy)
					
					glVertex2d(posx, posy)
					
					GetXYBySlot(tuc.target.posx, tuc.target.posy, posx, posy)
					
					glVertex2d(posx, posy)
				End If
			glEnd()
			
			glEnable(GL_TEXTURE_2D)
			glBindTexture(GL_TEXTURE_2D, TFrame.texture[FRAMESET_UNIT])
		Next
	End Function
	Method _draw:Int()

		If anim.frame Then
'			glBindTexture(GL_TEXTURE_2D, tex)
'			Local posx:Int = ((Int(slotx) - camX) * (32)) - ((Int(sloty) - camy) * (32)) - 32
'			Local posy:Int = ((Int(slotx) - camX) * (16)) + ((Int(sloty) - camy) * (16)) - 16
'			TKachel.list[2].Draw(posx, posy)
'		
'			glBindTexture(GL_TEXTURE_2D, TFrame.texture[FRAMESET_UNIT])
'			
			anim.frame.DrawbyslotfCol(slotX - camX, sloty - camY, unit.col, unit.size, unit.size, 1)

		End If
	End Method
	Method isVisible:Int()
		Return True 'reserviert für spätere erweiterung (falls es mal soweit kommt)
	End Method
	Method isAlive:Int()
		Return Self.killed = 0
	End Method
	Method DoDamage:Int(val:Int, target:Tbuilding = Null, durchschlag:Float = 1.0)

		Local damage:Int = val * durchschlag
Rem
	anmerkung phillipk: Def erstmal rausgenommen. Schaden wird nichtmehr mit def berechnet, sondern mit durchschlag skaliert.
end rem
'		If durchschlag Or unit.def <= 0 Then
'			damage = Max(val, 1)
'		ElseIf unit.def > 0 Then
'			damage = Max(val / unit.def, 1)
'		End If
		
		unit.hp:-damage
		

		
		Return damage
	End Method
End Type

Const ACTION_DIE:Int = -1
Const ACTION_DEAD:Int = -2
Const ACTION_IDLE:Int = 0
Const ACTION_WALK:Int = 1
Const ACTION_WAIT:Int = 2
Const ACTION_FLEE:Int = 9
Const ACTION_ATTACK:Int = 10
Const ACTION_WALK_TO_RAID:Int = 15
Const ACTION_ATTACK_RAIDTARGET:Int = 16

Type TUnitAction
	Field tuc:TUnitController
	
	
	Method Create:TunitAction(tuc:TUnitController) Abstract
	
	Method update:Int() Abstract
	
	Method getID:Int() Abstract
	
	Method getFrameset:Int() Abstract
	
	Method GetMove:Float() Abstract
	
	Method SetDelay:Int() Abstract
	
	Method onAnimReady:Int() Abstract
End Type
Type TUnitAction_raid_attack Extends TUnitAction
	Method Create:TUnitAction(tuc:TUnitController)
		Self.tuc = tuc
		If Not tuc.target Then
			If tuc.squad Then
				RuntimeError("TunitAction_raid_attack wurde aufgerufen, aber es gibt nix zum angreifen.")
			Else
				Return New TUnitAction_die.Create(tuc)
			End If
		EndIf
		tuc.anim.doAttack()
		Return Self
	End Method
	
	Method getID:Int()
		Return ACTION_ATTACK_RAIDTARGET
	End Method
	Method update:Int()

	End Method
	Method getFrameset:Int()
		Return ANI_ATK_N + tuc.dir
	End Method
	Method GetMove:Float()
		Return 0.0 'speedfaktor.
	End Method
	Method SetDelay:Int()
	'	tuc.nextUpdate = TGameControl.updateTicks + 60 '1 sekunden
	End Method
	Method onAnimReady:Int()
		If tuc.target Then
			tuc.target.DoDamage(tuc.unit.atk)
		End If
	End Method
End Type
Type TUnitAction_raid_walkTo Extends TUnitAction
	Method Create:TUnitAction(tuc:TUnitController)
		Self.tuc = tuc
		If Not tuc.tmpNodes Then
			If tuc.squad Then
				RuntimeError("TunitAction_raid_walkTo wurde aufgerufen, aber es gibt nix zum abklappern.")
			End If
		EndIf
		tuc.anim.domove()
		Return Self
	End Method
	
	Method getID:Int()
		Return ACTION_WALK_TO_RAID
	End Method
	Method update:Int()
		'Print "TIMER: " + tuc.timer + " - Ms: " + MilliSecs()
		'Print "IDLE"
	End Method
	Method getFrameset:Int()
		Return ANI_MOVE_N + tuc.dir
	End Method
	Method GetMove:Float()
		Return tuc.unit.speed * 0.56 'speedfaktor. Schneller weil bedrohliches raidziel! :D
	End Method
	Method SetDelay:Int()
	'	tuc.nextUpdate = TGameControl.updateTicks + 120 '2 sekunden
	'	tuc.timer = MilliSecs() + 2000
	End Method
	Method onAnimReady:Int()
		
	End Method
End Type
Type TUnitAction_idle Extends TUnitAction
	Method Create:TUnitAction(tuc:TUnitController)
		Self.tuc = tuc
		tuc.anim.doStand()
		Return Self
	End Method
	
	Method getID:Int()
		Return ACTION_IDLE
	End Method
	Method update:Int()
		'Print "TIMER: " + tuc.timer + " - Ms: " + MilliSecs()
		'Print "IDLE"
	End Method
	Method getFrameset:Int()
		Return ANI_STAND_N + tuc.dir
	End Method
	Method GetMove:Float()
		Return 0.0 'speedfaktor.
	End Method
	Method SetDelay:Int()
	'	tuc.nextUpdate = TGameControl.updateTicks + 120 '2 sekunden
	'	tuc.timer = MilliSecs() + 2000
	End Method
	Method onAnimReady:Int()
		
	End Method
End Type
Type TUnitAction_walk Extends TUnitAction
	Method Create:TUnitAction(tuc:TUnitController)
		Self.tuc = tuc
		If tuc.anim Then tuc.anim.doMove()


		Return Self
	End Method
	
	Method getID:Int()
		Return 1
	End Method
	Method update:Int()
	'	tuc.nextUpdate:+20
	End Method
	Method getFrameset:Int()
		Return ANI_MOVE_N + tuc.dir
	End Method
	
	Method GetMove:Float()
		Return tuc.unit.speed * 0.5 'speedfaktor
	End Method
	
	Method SetDelay:Int()
	'	tuc.nextUpdate = TGameControl.updateTicks + 120
	End Method
	Method onAnimReady:Int()
		
	End Method
End Type
Type TUnitAction_die Extends TUnitAction
	Method Create:TUnitAction(tuc:TUnitController)
		Self.tuc = tuc

		If tuc.anim Then tuc.anim.dodie()
	
		Return Self
	End Method
	
	Method getID:Int()
		Return - 1
	End Method
	Method update:Int()
	'	tuc.nextUpdate:+20
	End Method
	Method getFrameset:Int()
		Return ANI_DIE
	End Method
	
	Method GetMove:Float()
		Return 0.0 'speedfaktor
	End Method
	
	Method SetDelay:Int()
	'	tuc.nextUpdate = TGameControl.updateTicks + 120
	End Method
	Method onAnimReady:Int()
		'TUnitController.kill(tuc)
		tuc.action = New TUNitAction_dead.Create(tuc)
	End Method
End Type
Type TUNitAction_dead Extends TUnitAction
	Field time_start_rotten:Int
	
	Method Create:TunitAction(tuc:TUnitController)
		Self.tuc = tuc
		tuc.anim.doDead()
		Self.time_start_rotten = TGameControl.updateTicks
		
		tuc.unit.col = tuc.unit.col[..]
		
		Return Self
	End Method
	Method getID:Int()
		Return - 2
	End Method
	Method update:Int()
		If Self.time_start_rotten + 500 < TGameControl.updateTicks Then TUnitController.kill(tuc)
		
		Local alpha:Float = 1.0 - ((tgameControl.updateticks - Self.time_start_rotten) / 500.0)
		tuc.unit.col[3] = alpha
	End Method
	Method GetMove:Float()
		Return 0.0 'speedfaktor
	End Method
	Method getFrameset:Int()
		Return ANI_DEAD
	End Method
	Method SetDelay:Int()
	'	tuc.nextupdate = TGaemControl.updateticks + 5000
	End Method
	Method onAnimReady:Int()

	End Method
End Type
Type TUnitAction_attack Extends TUnitAction
	Field duration:Int = TGameControl.updateTicks + 200
	
	Method Create:TunitAction(tuc:TUnitController)
	'	Print "Action: Attack wurde erstellt."
		Self.tuc = tuc
		
		tuc.anim.doAttack()
		
		
		Return Self
	End Method
	Method getID:Int()
		Return ACTION_ATTACK
	End Method
	Method update:Int()
		If Self.duration < TGameControl.updateTicks Then
		'	If Self.tuc.unit.hp > 0 Then
			'	Self.tuc.DoDamage(1)
			If Not Self.tuc.target Or Self.tuc.target.destroyed Then
				Self.tuc.target = Null
				
				tuc.action = New TUnitAction_idle.Create(tuc)
				Return 1
			EndIf
				Self.duration = TGameControl.updateTicks + 120
		'	Else

		'	EndIf
		EndIf
	End Method
	Method GetMove:Float()
		Return 0.0
	End Method
	Method getFrameset:Int()
		Return ANI_ATK_N + tuc.dir
	End Method
	Method SetDelay:Int()
	'	tuc.nextUpdate = TGameControl.updateticks + 15
	End Method
	Method onAnimReady:Int()
		If Self.tuc.target And Not Self.tuc.target.destroyed Then
			Self.tuc.target.doDamage(Self.tuc.unit.atk)
		Else
			tuc.action = New TUnitAction_idle.Create(tuc)
		End If
	End Method
End Type
